/*
 * kmerlin.s
 * Ccopyright (c) 2003-2004, deitest@hotmail.com, yanmar@ogonigo.com
 * 
 *kmerlin.s is based on  kmerlin ver1.41. olueg@olsd.de
 *Fixed by deitest@hotmail.com, yanmar@ogonigo.com 2003-2004
 */
/***************************************************************************
                          chatviewimpl.cpp  -  description
                             -------------------
    begin                : Wed Jul 4 2001
    copyright            : (C) 2001 by olaf lueg
    email                : olaf.lueg@t-online.de
 ***************************************************************************/
/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// my include
#include "chatviewimpl.h"
#include "kmsMultiLineEdit.h"
#include <qpe/resource.h>
#include "kmerlin.h"
#include "onlineview.h"
#include "chatwindow.h"

// qt
//#include <qmultilineedit.h>

#include <qtabwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qtextbrowser.h>
#include <qstring.h>
#include <qcombobox.h>
#include <qlayout.h>
#include <qsizepolicy.h>
#include <qfile.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <qtextcodec.h>
#include <qtextstream.h>
#include <qcstring.h>
#include <sl/slsoundconf.h>

ChatViewImpl::ChatViewImpl(QWidget *parent, const char *name,QString infoFontSize,QString menuFontSize ) : chatview(parent,name,infoFontSize,menuFontSize) {
	loadSmileys();
	viewSmileys = true;
	textChanged = false;
    fnPress = false;

	infoText->setText(tr("Please wait"));
//	fontName = "helvetica";
//	fontName = "lcfont";
//	fontSize = "3"; // Customized By S.Yamashita[OGONIGO.COM] - fontSizeɲ
    connect( strSend, SIGNAL(keyPress(QKeyEvent *)), this, SLOT(keypressed(QKeyEvent *)) );
    connect( strSend, SIGNAL(keyRelease(QKeyEvent *)), this, SLOT(keyreleased(QKeyEvent *)) );
//    connect( cmbPix, SIGNAL(activated(const QString &)), strSend, SLOT(insert(const QString &)) );
    connect( cmbPix, SIGNAL(activated(const QString &)), this, SLOT(slotsendIcon(const QString &)) );
	strSend->setWordWrap(QMultiLineEdit::NoWrap);
}
ChatViewImpl::~ChatViewImpl(){
}

// Send button clicked
void ChatViewImpl::sendText(){

    emit tabRefresh();
    if(infoText->text().find("Please wait",0,true) != -1){return;}

	if(strSend->text().length() > 0) {
		emit sendMsg(strSend->text());//.utf8());
		strSend->setText("");
	  	textChanged = false;
	}else{
		strSend->setText("");
	}
}

QString ChatViewImpl::htmlParser(QString message){// Customized By S.Yamashita[OGONIGO.COM]
  if(message.mid(0,4) == "\r\n\r\n") {message = message.mid(4,message.length()-4);}
  message = message.replace(QRegExp("&"), "&amp;");
  message = message.replace(QRegExp("<"), "&lt;");
  message = message.replace(QRegExp("\""), "&quot;");
  message = message.replace(QRegExp(" "), "&nbsp;");
  message = message.replace(QRegExp("\r\n"),"<br>");
  message = message.replace(QRegExp("\r"),"<br>");
  message = message.replace(QRegExp("\n"),"<br>");
  return message;
}

QString ChatViewImpl::urlParser(QString message,QString tag )
{
  // if viewSmileys=true  urlParser works not correctly
  QChar c;
  c=message.at(0);
  while (c == '\n' || c == '\r' || c == '\0')
 {
   message.remove(0,1);  //removes prefixing \n \r and \0 so this function can work
   c=message.at(0);
 }

  int i = message.find(tag);

  redo:
  QString str= "";
  if(i != -1){
   	if(i == 0){
  	 	message.insert(i,"<a href=\"");
  	 	i = 1;
  	}
  	else{
  		if(QString(message.at(i-1)) == " "){
  			message.insert(i,"<a href=\"");
  			i = i+1;
  			
  		}
  		else
  		{
  			goto nodata;
  		}
  	}
  	 i = i+8;

 	 do{
 	 	  str += message.at(i);
 	 	  i++;
 	 }
 	 while((c= message.at(i)) != " " & i != message.length());
 	 message.insert(i,"\">" +str +"</a>");
  }
  nodata:
  if( i != -1){

  	i = message.find(tag,i+str.length()+1);
  	if(i != -1){
  		goto redo;
  	}
  }
	return message;
}
	
/** No descriptions */
void ChatViewImpl::insertMessage(QString publicName,QString message){
	if(!isActiveWindow()){
		//KNotifyClient::event("message",publicName+": "+message);
	}
  message = htmlParser(message);
  //message = urlParser(message,"http:");
  //message = urlParser(message,"mailto:");
  //message = urlParser(message,"ftp:");
  QString tmpCol1, tmpCol2;

  fontName = theApp->_fontName;
  fontSize = theApp->_fontSize;
  fontCol1 = theApp->_fontCol1;
  fontCol2 = theApp->_fontCol2;
  fontCol3 = theApp->_fontCol3;
  fontCol4 = theApp->_fontCol4;
  myName = QString::fromUtf8(theApp->_publicName);

  if (theApp->_logging == "1") {
	  saveLog(publicName,message);
  }
  if(publicName.left(myName.length()) == myName) {tmpCol1 = fontCol1; tmpCol2 = fontCol3;} else {tmpCol1 = fontCol2; tmpCol2 = fontCol4;}
  if(viewSmileys){
  	message = smileyParser(message);
  }

	QString lText = TextBrowser->text();
	QString sText = "<a name=\"x\"></a>";
	int i = 0;
	int idx = -1;
	for(i=1;i<theApp->maxComment;i++){
		idx = lText.findRev(sText, idx, false);
		idx--;
		if(idx < 0){
			break;
		}
	}
	if(idx < 0){idx = 0;}else{idx++;}
	idx = lText.length() - idx;

	TextBrowser->setText(lText.right(idx) + "<a name=\"x\"></a><font face=\""+fontName+"\" color=\"" +tmpCol1+ "\" size=\""+fontSize+"\">"+publicName+":" + "</font>"+"<br>"+"<font face=\""+fontName+"\" color=\"" +tmpCol2+ "\" size=\""+fontSize+"\">"+message+"</font><br>");

  TextBrowser->scrollBy(0,TextBrowser->contentsHeight());
  TextBrowser->repaintContents(0,0,TextBrowser->contentsWidth(),TextBrowser->contentsHeight(),true);

  if(theApp->soundEnable && publicName != myName){
    SlSoundPlayer::play(Resource::findSound("kmerlin/type"),true);
  }
}
/** No descriptions */
QString ChatViewImpl::smileyParser(QString message){
	message = message.replace(QRegExp("(Y)"),"<img src=\""+strSmilie[0]+"\">");
	message = message.replace(QRegExp("(y)"),"<img src=\""+strSmilie[0]+"\">");
	message = message.replace(QRegExp("(N)"),"<img src=\""+strSmilie[1]+"\">");
	message = message.replace(QRegExp("(n)"),"<img src=\""+strSmilie[1]+"\">");
	message = message.replace(QRegExp("(B)"),"<img src=\""+strSmilie[2]+"\">");
	message = message.replace(QRegExp("(b)"),"<img src=\""+strSmilie[2]+"\">");
	message = message.replace(QRegExp("(D)"),"<img src=\""+strSmilie[3]+"\">");
	message = message.replace(QRegExp("(d)"),"<img src=\""+strSmilie[3]+"\">");
	message = message.replace(QRegExp("(X)"),"<img src=\""+strSmilie[4]+"\">");
	message = message.replace(QRegExp("(x)"),"<img src=\""+strSmilie[4]+"\">");
	message = message.replace(QRegExp("(Z)"),"<img src=\""+strSmilie[5]+"\">");
	message = message.replace(QRegExp("(z)"),"<img src=\""+strSmilie[5]+"\">");
	message = message.replace(QRegExp("(6)"),"<img src=\""+strSmilie[6]+"\">");
	message = message.replace(QRegExp("(&amp;)"),"<img src=\""+strSmilie[33]+"\">");
	message = message.replace(QRegExp(":-[[]"),"<img src=\""+strSmilie[7]+"\">");
	message = message.replace(QRegExp(":[[]"),"<img src=\""+strSmilie[7]+"\">");
	message = message.replace(QRegExp("([}])"),"<img src=\""+strSmilie[8]+"\">");
	message = message.replace(QRegExp("([{])"),"<img src=\""+strSmilie[9]+"\">");
	message = message.replace(QRegExp(":-)"),"<img src=\""+strSmilie[10]+"\">");
	message = message.replace(QRegExp(":)"),"<img src=\""+strSmilie[10]+"\">");
	message = message.replace(QRegExp(":-D"),"<img src=\""+strSmilie[11]+"\">");
	message = message.replace(QRegExp(":d"),"<img src=\""+strSmilie[11]+"\">");
	message = message.replace(QRegExp(":D"),"<img src=\""+strSmilie[11]+"\">");
	message = message.replace(QRegExp(":-O"),"<img src=\""+strSmilie[12]+"\">");
	message = message.replace(QRegExp("&lt;:o)"),"<img src=\""+strSmilie[66]+"\">");
	message = message.replace(QRegExp(":O"),"<img src=\""+strSmilie[12]+"\">");
	message = message.replace(QRegExp(":o"),"<img src=\""+strSmilie[12]+"\">");
	message = message.replace(QRegExp(":0"),"<img src=\""+strSmilie[12]+"\">");
	message = message.replace(QRegExp(":-P"),"<img src=\""+strSmilie[13]+"\">");
	message = message.replace(QRegExp(":p"),"<img src=\""+strSmilie[13]+"\">");
	message = message.replace(QRegExp(":P"),"<img src=\""+strSmilie[13]+"\">");

	message = message.replace(QRegExp("&lt;"),"&l;t");
	message = message.replace(QRegExp("&amp;"),"&am;p");
	message = message.replace(QRegExp("&nbsp;"),"&nbs;p");
	message = message.replace(QRegExp("&quot;"),"&quo;t");

	message = message.replace(QRegExp(";-)"),"<img src=\""+strSmilie[14]+"\">");
	message = message.replace(QRegExp(";)"),"<img src=\""+strSmilie[14]+"\">");

	message = message.replace(QRegExp("&quo;t"),"&quot;");
	message = message.replace(QRegExp("&nbs;p"),"&nbsp;");
	message = message.replace(QRegExp("&am;p"),"&amp;");
	message = message.replace(QRegExp("&l;t"),"&lt;");

	message = message.replace(QRegExp(":-("),"<img src=\""+strSmilie[15]+"\">");
	message = message.replace(QRegExp(":("),"<img src=\""+strSmilie[15]+"\">");
	message = message.replace(QRegExp(":-S"),"<img src=\""+strSmilie[16]+"\">");
	message = message.replace(QRegExp(":s"),"<img src=\""+strSmilie[16]+"\">");
	message = message.replace(QRegExp(":S"),"<img src=\""+strSmilie[16]+"\">");
	message = message.replace(QRegExp(":-|"),"<img src=\""+strSmilie[17]+"\">");
	message = message.replace(QRegExp(":|"),"<img src=\""+strSmilie[17]+"\">");
	message = message.replace(QRegExp(":'("),"<img src=\""+strSmilie[18]+"\">");
	message = message.replace(QRegExp(":-[$]"),"<img src=\""+strSmilie[19]+"\">");
	message = message.replace(QRegExp(":[$]"),"<img src=\""+strSmilie[19]+"\">");
	message = message.replace(QRegExp("(H)"),"<img src=\""+strSmilie[20]+"\">");
	message = message.replace(QRegExp("(h)"),"<img src=\""+strSmilie[20]+"\">");
	message = message.replace(QRegExp(":-@"),"<img src=\""+strSmilie[21]+"\">");
	message = message.replace(QRegExp(":@"),"<img src=\""+strSmilie[21]+"\">");
	message = message.replace(QRegExp("(A)"),"<img src=\""+strSmilie[22]+"\">");
	message = message.replace(QRegExp("(a)"),"<img src=\""+strSmilie[22]+"\">");
	message = message.replace(QRegExp("(L)"),"<img src=\""+strSmilie[23]+"\">");
	message = message.replace(QRegExp("(l)"),"<img src=\""+strSmilie[23]+"\">");
	message = message.replace(QRegExp("(U)"),"<img src=\""+strSmilie[24]+"\">");
	message = message.replace(QRegExp("(u)"),"<img src=\""+strSmilie[24]+"\">");
	message = message.replace(QRegExp("(K)"),"<img src=\""+strSmilie[25]+"\">");
	message = message.replace(QRegExp("(k)"),"<img src=\""+strSmilie[25]+"\">");
	message = message.replace(QRegExp("(G)"),"<img src=\""+strSmilie[26]+"\">");
	message = message.replace(QRegExp("(g)"),"<img src=\""+strSmilie[26]+"\">");
	message = message.replace(QRegExp("(F)"),"<img src=\""+strSmilie[27]+"\">");
	message = message.replace(QRegExp("(f)"),"<img src=\""+strSmilie[27]+"\">");
	message = message.replace(QRegExp("(W)"),"<img src=\""+strSmilie[28]+"\">");
	message = message.replace(QRegExp("(w)"),"<img src=\""+strSmilie[28]+"\">");
	message = message.replace(QRegExp("(P)"),"<img src=\""+strSmilie[29]+"\">");
	message = message.replace(QRegExp("(p)"),"<img src=\""+strSmilie[29]+"\">");
	message = message.replace(QRegExp("(~)"),"<img src=\""+strSmilie[30]+"\">");
	message = message.replace(QRegExp("(T)"),"<img src=\""+strSmilie[31]+"\">");
	message = message.replace(QRegExp("(t)"),"<img src=\""+strSmilie[31]+"\">");
	message = message.replace(QRegExp("(@)"),"<img src=\""+strSmilie[32]+"\">");
//	message = message.replace(QRegExp("(&)"),"<img src=\""+strSmilie[33]+"\">");
	message = message.replace(QRegExp("(C)"),"<img src=\""+strSmilie[34]+"\">");
	message = message.replace(QRegExp("(c)"),"<img src=\""+strSmilie[34]+"\">");
	message = message.replace(QRegExp("(I)"),"<img src=\""+strSmilie[35]+"\">");
	message = message.replace(QRegExp("(i)"),"<img src=\""+strSmilie[35]+"\">");
	message = message.replace(QRegExp("(S)"),"<img src=\""+strSmilie[36]+"\">");
//	message = message.replace(QRegExp("(s)"),"<img src=\""+strSmilie[36]+"\">");
	message = message.replace(QRegExp("([*])"),"<img src=\""+strSmilie[37]+"\">");
	message = message.replace(QRegExp("(8)"),"<img src=\""+strSmilie[38]+"\">");
	message = message.replace(QRegExp("(E)"),"<img src=\""+strSmilie[39]+"\">");
	message = message.replace(QRegExp("(e)"),"<img src=\""+strSmilie[39]+"\">");
	message = message.replace(QRegExp("(^)"),"<img src=\""+strSmilie[40]+"\">");
	message = message.replace(QRegExp("(O)"),"<img src=\""+strSmilie[41]+"\">");
	message = message.replace(QRegExp("(o)"),"<img src=\""+strSmilie[41]+"\">");
	message = message.replace(QRegExp("(0)"),"<img src=\""+strSmilie[41]+"\">");
	message = message.replace(QRegExp("(M)"),"<img src=\""+strSmilie[42]+"\">");
	message = message.replace(QRegExp("(m)"),"<img src=\""+strSmilie[42]+"\">");

	message = message.replace(QRegExp(":-#"),"<img src=\""+strSmilie[43]+"\">");
	message = message.replace(QRegExp("8o|"),"<img src=\""+strSmilie[44]+"\">");
	message = message.replace(QRegExp("8-|"),"<img src=\""+strSmilie[45]+"\">");
	message = message.replace(QRegExp("\\^o)"),"<img src=\""+strSmilie[46]+"\">");
	message = message.replace(QRegExp(":-[*]"),"<img src=\""+strSmilie[47]+"\">");
	message = message.replace(QRegExp("[+]o("),"<img src=\""+strSmilie[48]+"\">");
	message = message.replace(QRegExp("(sn)"),"<img src=\""+strSmilie[49]+"\">");
	message = message.replace(QRegExp("(pl)"),"<img src=\""+strSmilie[50]+"\">");
	message = message.replace(QRegExp("(||)"),"<img src=\""+strSmilie[51]+"\">");
	message = message.replace(QRegExp("(pi)"),"<img src=\""+strSmilie[52]+"\">");
	message = message.replace(QRegExp("(so)"),"<img src=\""+strSmilie[53]+"\">");
	message = message.replace(QRegExp("(au)"),"<img src=\""+strSmilie[54]+"\">");
	message = message.replace(QRegExp("(ap)"),"<img src=\""+strSmilie[55]+"\">");
	message = message.replace(QRegExp("(um)"),"<img src=\""+strSmilie[56]+"\">");
	message = message.replace(QRegExp("(ip)"),"<img src=\""+strSmilie[57]+"\">");
	message = message.replace(QRegExp("(co)"),"<img src=\""+strSmilie[58]+"\">");
	message = message.replace(QRegExp("(mp)"),"<img src=\""+strSmilie[59]+"\">");
	message = message.replace(QRegExp("(st)"),"<img src=\""+strSmilie[60]+"\">");
	message = message.replace(QRegExp("(mo)"),"<img src=\""+strSmilie[61]+"\">");
	message = message.replace(QRegExp("(bah)"),"<img src=\""+strSmilie[62]+"\">");
//	message = message.replace(QRegExp(":[^])"),"<img src=\""+strSmilie[63]+"\">");
	message = message.replace(QRegExp(":^)"),"<img src=\""+strSmilie[63]+"\">");
	message = message.replace(QRegExp("[*]-)"),"<img src=\""+strSmilie[64]+"\">");
	message = message.replace(QRegExp("(li)"),"<img src=\""+strSmilie[65]+"\">");
//	message = message.replace(QRegExp("[<][:]o)"),"<img src=\""+strSmilie[66]+"\">");
	message = message.replace(QRegExp("8-)"),"<img src=\""+strSmilie[67]+"\">");
	message = message.replace(QRegExp("|-)"),"<img src=\""+strSmilie[68]+"\">");
	message = message.replace(QRegExp("(r)"),"<img src=\""+strSmilie[69]+"\">");
	message = message.replace(QRegExp("(R)"),"<img src=\""+strSmilie[69]+"\">");
	message = message.replace(QRegExp("(#)"),"<img src=\""+strSmilie[70]+"\">");
	message = message.replace(QRegExp("(brb)"),"<img src=\""+strSmilie[71]+"\">");
	message = message.replace(QRegExp("(%)"),"<img src=\""+strSmilie[72]+"\">");
	message = message.replace(QRegExp("([?])"),"<img src=\""+strSmilie[73]+"\">");
	message = message.replace(QRegExp("(xx)"),"<img src=\""+strSmilie[74]+"\">");
	message = message.replace(QRegExp("(tu)"),"<img src=\""+strSmilie[75]+"\">");
	message = message.replace(QRegExp("(yn)"),"<img src=\""+strSmilie[76]+"\">");
	message = message.replace(QRegExp("(h5)"),"<img src=\""+strSmilie[77]+"\">");
	message = message.replace(QRegExp("(ci)"),"<img src=\""+strSmilie[78]+"\">");

	return message;
}

/** No descriptions */
void ChatViewImpl::loadSmileys(){

	strSmilie[0]	= Resource::findPixmap("/kmerlin/thumbs_up.png");
	strSmilie[1]	= Resource::findPixmap("/kmerlin/thumbs_down.png");
	strSmilie[2]	= Resource::findPixmap("/kmerlin/beer_yum.png");
	strSmilie[3]	= Resource::findPixmap("/kmerlin/martini_shaken.png");
	strSmilie[4]	= Resource::findPixmap("/kmerlin/girl_handsacrossamerica.png");
	strSmilie[5]	= Resource::findPixmap("/kmerlin/guy_handsacrossamerica.png");
	strSmilie[6]	= Resource::findPixmap("/kmerlin/devil_smile.png");
	strSmilie[7]	= Resource::findPixmap("/kmerlin/bat.png");
	strSmilie[8]	= Resource::findPixmap("/kmerlin/girl_hug.png");
	strSmilie[9]	= Resource::findPixmap("/kmerlin/dude_hug.png");
	strSmilie[10]	= Resource::findPixmap("/kmerlin/regular_smile.png");
	strSmilie[11]	= Resource::findPixmap("/kmerlin/teeth_smile.png");
	strSmilie[12]	= Resource::findPixmap("/kmerlin/omg_smile.png");
	strSmilie[13]	= Resource::findPixmap("/kmerlin/tounge_smile.png");
	strSmilie[14]	= Resource::findPixmap("/kmerlin/wink_smile.png");
	strSmilie[15]	= Resource::findPixmap("/kmerlin/sad_smile.png");
	strSmilie[16]	= Resource::findPixmap("/kmerlin/confused_smile.png");
	strSmilie[17]	= Resource::findPixmap("/kmerlin/whatchutalkingabout_smile.png");
	strSmilie[18]	= Resource::findPixmap("/kmerlin/cry_smile.png");
	strSmilie[19]	= Resource::findPixmap("/kmerlin/embaressed_smile.png");
	strSmilie[20]	= Resource::findPixmap("/kmerlin/shades_smile.png");
	strSmilie[21]	= Resource::findPixmap("/kmerlin/angry_smile.png");
	strSmilie[22]	= Resource::findPixmap("/kmerlin/angel_smile.png");
	strSmilie[23]	= Resource::findPixmap("/kmerlin/heart.png");
	strSmilie[24]	= Resource::findPixmap("/kmerlin/broken_heart.png");
	strSmilie[25]	= Resource::findPixmap("/kmerlin/kiss.png");
	strSmilie[26]	= Resource::findPixmap("/kmerlin/present.png");
	strSmilie[27]	= Resource::findPixmap("/kmerlin/rose.png");
	strSmilie[28]	= Resource::findPixmap("/kmerlin/wilted_rose.png");
	strSmilie[29]	= Resource::findPixmap("/kmerlin/camera.png");
	strSmilie[30]	= Resource::findPixmap("/kmerlin/film.png");
	strSmilie[31]	= Resource::findPixmap("/kmerlin/phone.png");
	strSmilie[32]	= Resource::findPixmap("/kmerlin/kittykay.png");
	strSmilie[33]	= Resource::findPixmap("/kmerlin/bowwow.png");
	strSmilie[34]	= Resource::findPixmap("/kmerlin/coffee.png");
	strSmilie[35]	= Resource::findPixmap("/kmerlin/lightbulb.png");
	strSmilie[36]	= Resource::findPixmap("/kmerlin/moon.png");
	strSmilie[37]	= Resource::findPixmap("/kmerlin/star.png");
	strSmilie[38]	= Resource::findPixmap("/kmerlin/musical_note.png");
	strSmilie[39]	= Resource::findPixmap("/kmerlin/envelope.png");
	strSmilie[40]	= Resource::findPixmap("/kmerlin/cake.png");
	strSmilie[41]	= Resource::findPixmap("/kmerlin/clock.png");
	strSmilie[42]	= Resource::findPixmap("/kmerlin/messenger.png");
	strkong		= Resource::findPixmap("/kmerlin/kong.png");

	strSmilie[43]	= Resource::findPixmap("/kmerlin/47_47.png");
	strSmilie[44]	= Resource::findPixmap("/kmerlin/48_48.png");
	strSmilie[45]	= Resource::findPixmap("/kmerlin/49_49.png");
	strSmilie[46]	= Resource::findPixmap("/kmerlin/50_50.png");
	strSmilie[47]	= Resource::findPixmap("/kmerlin/51_51.png");
	strSmilie[48]	= Resource::findPixmap("/kmerlin/52_52.png");
	strSmilie[49]	= Resource::findPixmap("/kmerlin/53_53.png");
	strSmilie[50]	= Resource::findPixmap("/kmerlin/55_55.png");
	strSmilie[51]	= Resource::findPixmap("/kmerlin/56_56.png");
	strSmilie[52]	= Resource::findPixmap("/kmerlin/57_57.png");
	strSmilie[53]	= Resource::findPixmap("/kmerlin/58_58.png");
	strSmilie[54]	= Resource::findPixmap("/kmerlin/59_59.png");
	strSmilie[55]	= Resource::findPixmap("/kmerlin/60_60.png");
	strSmilie[56]	= Resource::findPixmap("/kmerlin/61_61.png");
	strSmilie[57]	= Resource::findPixmap("/kmerlin/62_62.png");
	strSmilie[58]	= Resource::findPixmap("/kmerlin/63_63.png");
	strSmilie[59]	= Resource::findPixmap("/kmerlin/64_64.png");
	strSmilie[60]	= Resource::findPixmap("/kmerlin/66_66.png");
	strSmilie[61]	= Resource::findPixmap("/kmerlin/69_69.png");
	strSmilie[62]	= Resource::findPixmap("/kmerlin/70_70.png");
	strSmilie[63]	= Resource::findPixmap("/kmerlin/71_71.png");
	strSmilie[64]	= Resource::findPixmap("/kmerlin/72_72.png");
	strSmilie[65]	= Resource::findPixmap("/kmerlin/73_73.png");
	strSmilie[66]	= Resource::findPixmap("/kmerlin/74_74.png");
	strSmilie[67]	= Resource::findPixmap("/kmerlin/75_75.png");
	strSmilie[68]	= Resource::findPixmap("/kmerlin/77_77.png");
	strSmilie[69]	= Resource::findPixmap("/kmerlin/rainbow.png");
	strSmilie[70]	= Resource::findPixmap("/kmerlin/sun.png");
	strSmilie[71]	= Resource::findPixmap("/kmerlin/jump.png");
	strSmilie[72]	= Resource::findPixmap("/kmerlin/handcuffs.png");
	strSmilie[73]	= Resource::findPixmap("/kmerlin/asl.png");
	strSmilie[74]	= Resource::findPixmap("/kmerlin/xbox.png");
	strSmilie[75]	= Resource::findPixmap("/kmerlin/turtle.png");
	strSmilie[76]	= Resource::findPixmap("/kmerlin/cross.png");
	strSmilie[77]	= Resource::findPixmap("/kmerlin/clap.png");
	strSmilie[78]	= Resource::findPixmap("/kmerlin/cigarette.png");

}

/** No descriptions */
void ChatViewImpl::slotsendIcon(const QString& s)
{
	key(s);
}
void ChatViewImpl::slotTabChange(int direction)
{
	theApp->changeTab(direction);
}

void ChatViewImpl::slotTextChanged()
{

    if(strSend->text().isEmpty())
    {
        SendButton->setEnabled(false);
        textChanged = false;
    }
    else
    {
        SendButton->setEnabled(true);
        textChanged = true;
    }
    if(strSend->text().length() == 1) // typing has start
    {
        emit writeMessage();
    }
}

/** No descriptions */
void ChatViewImpl::slotUrlClicked(const QString& url){
}

/** No descriptions */
void ChatViewImpl::systemMessage(QString message){

	QString lText = TextBrowser->text();
	QString sText = "<a name=\"x\"></a>";
	int i = 0;
	int idx = -1;
	for(i=1;i<theApp->maxComment;i++){
		idx = lText.findRev(sText, idx, false);
		idx--;
		if(idx < 0){
			break;
		}
	}
	if(idx < 0){idx = 0;}else{idx++;}
	idx = lText.length() - idx;

	TextBrowser->setText(lText.right(idx) + "<font face=\""+fontName+"\"size=\""+fontSize+"\">---------------------------<br></font><font face=\""+fontName+"\" color=red size=\""+fontSize+"\"><img src=\"" + strkong + "\" align=center>"+message+"</font><font face=\""+fontName+"\"size=\""+fontSize+"\"><br>---------------------------<br></font><br>");

	TextBrowser->scrollBy(0,TextBrowser->contentsHeight());
	TextBrowser->repaintContents(0,0,TextBrowser->contentsWidth(),TextBrowser->contentsHeight(),true);
}

void ChatViewImpl::key(QString s)
{
	int line, col;
	strSend->getCursorPosition(&line, &col);
	strSend->insertAt(s, line, col, false);
	slotTextChanged();

}

void ChatViewImpl::keypressed(QKeyEvent * k)
{
    bool s = (k->state() & ShiftButton);
    bool a = (k->state() & AltButton);
    bool c = (k->state() & ControlButton);
    switch (k->key()) {
        case 0x201a          : theApp->ListViewSetFocus();            break;
        case Key_PageUp      : slotTabChange(-1);		        break;
        case Key_PageDown    : slotTabChange(1);		        break;
        case Key_Home        : strSend->cursorHome(s);		        break;
        case Key_End         : strSend->cursorEnd(s);			break;
	case Key_F22         : fnPress = true;       									        break;
        case Key_X           : if(a || c || fnPress) strSend->cut(); else key(k->text());		break;
        case Key_C           : if(a || c || fnPress) strSend->copy(); else key(k->text());		break;
        case Key_V           : if(a || c || fnPress) strSend->paste(); else key(k->text());		break;
        case Key_Return      : if(s) strSend->nl(); else sendText(); slotTextChanged();	        break;
//        case Key_Left        : strSend->cursorL(s);										        break;
//        case Key_Right       : strSend->cursorR(s);									        	break;
        case Key_Left        : if(a || c || fnPress) slotTabChange(-1); else strSend->cursorL(s);		        break;
        case Key_Right       : if(a || c || fnPress) slotTabChange(1); else strSend->cursorR(s);			break;
        case Key_Up          : strSend->cursorU(s);									        	break;
        case Key_Down        : strSend->cursorD(s);									        	break;
        case Key_BackSpace   : strSend->bs();slotTextChanged();	                                break;
        case Key_Delete      : strSend->dl();slotTextChanged();						        	break;
        case Key_Tab         : if(s) slotShowMenu(); else cmbPix->setFocus();           		break;
		case Key_Escape      : slotCloseTab();										          	break;

        default              : key(k->text());

    }
}

void ChatViewImpl::keyreleased(QKeyEvent * k)
{
/*    bool s = (k->state() & ShiftButton);
    bool a = (k->state() & AltButton);
    bool c = (k->state() & ControlButton);
*/
    switch (k->key()) {
		case Key_F22         : fnPress = false;       									break;
    }
}


void ChatViewImpl::slotCloseTab(){
    emit closeTab();
}

void ChatViewImpl::slotShowMenu(){
    emit showMenu();
}

void ChatViewImpl::saveLog(QString name, QString msg) {

    QDir dir;
	dir.setPath(theApp->_logPath);
    if ( !dir.exists() ) mkdir(dir.path().local8Bit(),0700);
	dir.setPath(theApp->_logPath + "/KMerlin_Log");
    if ( !dir.exists() ) mkdir(dir.path().local8Bit(),0700);
    QString url = dir.path() + "/" + theWnd->chatWith + ".txt";

	QFile f(url);
	bool ok;
	if(!f.exists()){
		ok = f.open(IO_WriteOnly);
	} else {
		ok = f.open(IO_WriteOnly|IO_Append);
	}

	if(ok) {
		QTextCodec *codec = QTextCodec::codecForName( "eucJP" );
		QString time = QDateTime::currentDateTime().toString();
		msg = msg.replace(QRegExp("<br>"),"\r\n");
		msg = msg.replace(QRegExp("&amp;"),"&");
		msg = msg.replace(QRegExp("&quot;"),"\"");
		msg = msg.replace(QRegExp("&nbsp;")," ");
		msg = msg.replace(QRegExp("&lt;"),"<");

		QString buf = name;
		if ((theApp->_DispRecvtime == "0") || (theApp->_DispRecvtime == "None")){
			buf += "(" + time + ")";
		}
		buf += "\r\n" + msg + "\r\n\r\n";
		QCString cbuf = codec->fromUnicode(buf);
		f.writeBlock(cbuf, cbuf.length());

		f.close();
	}
}
// Speed up compilation



