/*
 * kmerlin.s
 * Ccopyright (c) 2003-2004, deitest@hotmail.com, yanmar@ogonigo.com
 * 
 *kmerlin.s is based on  kmerlin ver1.41. olueg@olsd.de
 *Fixed by deitest@hotmail.com, yanmar@ogonigo.com 2003-2004
 */
/***************************************************************************
                          chatwindow.cpp  -  description
                             -------------------
    begin                : Wed Jul 4 2001
    copyright            : (C) 2001 by olaf lueg
    email                : olaf.lueg@t-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
// my own
#include "chatwindow.h"
#include "chatviewimpl.h"
#include "kmerlin.h"
#include "kmsMultiLineEdit.h"
#include "chatmember.h"
#include "imservice.h"
#include "onlineview.h"
#include "mylistview.h"
#include <qpe/resource.h>
#include <qpe/qpemenubar.h>
#include <qpe/qpetoolbar.h>

// qt
#include <qlist.h>
#include <qprinter.h>
#include <qfile.h>
#include <qpopupmenu.h>
//#include <qmultilineedit.h>
#include <qtooltip.h>
#include <qstringlist.h>
#include <qfontdialog.h>
#include <qtextbrowser.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qtabwidget.h>
#include <qlayout.h>
#include <qfile.h>
#include <qdir.h>
#include <qpe/global.h>

// other
#include <time.h>

#define ID_STATUS_MSG 0

ChatWindow::ChatWindow(QWidget *parent,QString _infoFontSize,QString _menuFontSize,QString _sendFontSize, const char *name ) : QMainWindow(parent,name)
{
	//setGeometry((264 + (geometry().x() - x())),60,375,378);

	chatMemberList.setAutoDelete(true);
	// create the actions
	initActions();
	initMenuBar();
	blink = false;
	
	//create the chat view
	view = new ChatViewImpl(this,_infoFontSize,_menuFontSize);
	setCentralWidget(view);	
	view->viewSmileys = true;
	setCaption("ChatWindow");
	timer_id = startTimer(3000);// Customized By S.Yamashita[OGONIGO.COM] ????	switchBoardIsActive = false; // libkmsn sends a signal if we are connceted with the server
	chatWith = ""; // nobody in chat
	connect(view,SIGNAL(sendMsg(QString)),this,SLOT(slotSendButtonClicked(QString)));
	connect(view,SIGNAL(writeMessage()),this,SLOT(slotWriteMessage()));
	connect(view,SIGNAL(closeTab()),this,SLOT(slotCloseTab()));
	connect(view,SIGNAL(showMenu()),this,SLOT(slotShowMenu()));
	connect(view,SIGNAL(tabRefresh()),this,SLOT(slotTabRefresh()));
	connect(view->strSend,SIGNAL(getFocus()),this,SLOT(slotLedOff()));

	bool ok;
	QFont f = view->strSend->font();
	f.setPointSize( (_sendFontSize).toInt(&ok,10) );
	view->strSend->setFont(f);
	view->strSend->setFocus();

	view->strSend->setBackgroundMode(PaletteBase);
	viewSmileys->setOn(true);

    view->infoText->setBackgroundMode(PaletteButton);
	
	strPixUser = "";//Resource::loadPixmap("/pics/user.png");

}
ChatWindow::~ChatWindow(){
	killTimer(timer_id);
	theApp->ledOff();
}

void ChatWindow::connectToMenu()
{
	view->theApp = theApp;
	view->theWnd = this;
	chatAction = new QAction(tr("Chat"),tr("Chat"), 0, this);
	connect(chatAction, SIGNAL(activated()), this, SLOT(slotShowWindow()));
	chatAction->addTo(theApp->chatMenu);

}
void ChatWindow::slotShowWindow()
{
    int i = 0;
	ChatWindow *chatWindow;
	for( chatWindow = theApp->widgetList.first(); chatWindow != 0; chatWindow = theApp->widgetList.next() )
	{
        if(chatWindow == this) { 
            theApp->view->TabView->setCurrentPage(i);
            view->strSend->setFocus();
            return;
        }
        i++;
    }
}

/** No descriptions */
void ChatWindow::initActions()
{


  fileQuit = new QAction(tr("Close"), tr("C&lose"), QAccel::stringToKey(tr("Ctrl+Q")), this);
  fileQuit->setStatusTip(tr("Quits the application"));
  fileQuit->setWhatsThis(tr("Exit\n\nQuits the application"));
  connect(fileQuit, SIGNAL(activated()), this, SLOT(slotFileQuit()));

  editCut = new QAction(tr("Cut"), tr("Cu&t"), QAccel::stringToKey(tr("Ctrl+X")), this);
  editCut->setStatusTip(tr("Cuts the selected section and puts it to the clipboard"));
  editCut->setWhatsThis(tr("Cut\n\nCuts the selected section and puts it to the clipboard"));
  connect(editCut, SIGNAL(activated()), this, SLOT(slotEditCut()));

  editCopy = new QAction(tr("Copy"), tr("&Copy"), QAccel::stringToKey(tr("Ctrl+C")), this);
  editCopy->setStatusTip(tr("Copies the selected section to the clipboard"));
  editCopy->setWhatsThis(tr("Copy\n\nCopies the selected section to the clipboard"));
  connect(editCopy, SIGNAL(activated()), this, SLOT(slotEditCopy()));

  editPaste = new QAction(tr("Paste"), tr("&Paste"), QAccel::stringToKey(tr("Ctrl+V")), this);
  editPaste->setStatusTip(tr("Pastes the clipboard contents to actual position"));
  editPaste->setWhatsThis(tr("Paste\n\nPastes the clipboard contents to actual position"));
  connect(editPaste, SIGNAL(activated()), this, SLOT(slotEditPaste()));

  editClear = new QAction(tr("Clear"), tr("&Clear"), QAccel::stringToKey(tr("Ctrl+D")), this);
  editClear->setStatusTip(tr("Message Clear"));
  editClear->setWhatsThis(tr("Clear\n\nMessage Clear"));
  connect(editClear, SIGNAL(activated()), this, SLOT(slotEditClear()));

  viewSmileys = new QAction(tr("Smileys"), tr("S&mileys"), 0, this, 0, true);
  viewSmileys->setStatusTip(tr("Enables/disables the smileys"));
  viewSmileys->setWhatsThis(tr("Smileys\n\nEnables/disables the smileys"));
  connect(viewSmileys, SIGNAL(toggled(bool)), this, SLOT(slotViewSmileys(bool)));
	//viewSmileys->setOn(true);

  logOpen = new QAction(tr("Open Log"), tr("&Open Log"), QAccel::stringToKey(tr("Ctrl+L")), this);
  logOpen->setStatusTip(tr("Log file"));
  logOpen->setWhatsThis(tr("Open Log\n\nOpen the Log file"));
  connect(logOpen, SIGNAL(activated()), this, SLOT(slotLogOpen()));
}

void ChatWindow::initMenuBar()
{
  ///////////////////////////////////////////////////////////////////
  // MENUBAR

  ///////////////////////////////////////////////////////////////////
  // menuBar entry fileMenu
  popMenu=new QPopupMenu();
  contactInvite = new QPopupMenu();
  contactAdd = new QPopupMenu();

  logOpen->addTo(popMenu);
  popMenu->insertSeparator();

  ///////////////////////////////////////////////////////////////////
  // menuBar entry editMenu
  editCut->addTo(popMenu);
  editCopy->addTo(popMenu);
  editPaste->addTo(popMenu);
  popMenu->insertSeparator();

  ///////////////////////////////////////////////////////////////////
  // menuBar entry viewMenu
  popMenu->setCheckable(true);
  viewSmileys->addTo(popMenu);
  popMenu->insertSeparator();

  ///////////////////////////////////////////////////////////////////
  // EDIT YOUR APPLICATION SPECIFIC MENUENTRIES HERE

  ///////////////////////////////////////////////////////////////////
  // MENUBAR CONFIGURATION
  popMenu->insertItem(tr("&Invite Contact"),contactInvite);
  popMenu->insertItem(tr("&Add Contact"),contactAdd);
  popMenu->insertSeparator();
  editClear->addTo(popMenu);
  popMenu->insertSeparator();
  fileQuit->addTo(popMenu);

  connect(contactAdd, SIGNAL(aboutToShow()), this, SLOT(slotContactAdd()));
  connect(contactInvite, SIGNAL(aboutToShow()), this, SLOT(slotContactInvite()));

  connect(contactAdd, SIGNAL(activated( int )), this, SLOT(slotContactAdd( int )));
  connect(contactInvite, SIGNAL(activated( int )), this, SLOT(slotContactInvite( int )));

}


/** No descriptions */
void ChatWindow::slotViewSmileys(bool f)
{
	///////////////////////////////////////////////////////////////////
	//turn Smileys on or off
	if(!f)
	{
		view->viewSmileys = false;
	}
	else
	{
		view->viewSmileys = true;
	}
}

/** No descriptions */
void ChatWindow::slotFileQuit()
{
	chatAction->removeFrom(theApp->chatMenu);
	emit closeSession();
	theApp->widgetList.remove(this);
    theApp->view->TabView->removePage(this);
    theApp->view->ListView->setFocus();    
	if(blink){ theApp->ledOff(); }
	delete this;
}

void ChatWindow::slotStatusMsg(const QString &text)
{
	///////////////////////////////////////////////////////////////////
	// change status message permanently
	updateInfoText(text);
}

/** No descriptions */
void ChatWindow::slotEditCut()
{
	if(view->strSend->hasFocus())
	{
		view->strSend->cut();
	}
}

/** No descriptions */
void ChatWindow::slotEditPaste()
{
	if(view->strSend->hasFocus())
	{
		view->strSend->paste();
	}
}

/** No descriptions */
void ChatWindow::slotEditCopy()
{
	if(view->TextBrowser->hasFocus())
	{
		if(view->TextBrowser->hasSelectedText())
		{
			view->TextBrowser->copy();
		}
	}
	if(view->strSend->hasFocus())
	{
		view->strSend->copy();
	}
}

/** No descriptions */
void ChatWindow::slotEditClear()
{
	if(view->TextBrowser->hasFocus())
	{
		view->TextBrowser->setText("");
	}
	if(view->strSend->hasFocus())
	{
		view->strSend->setText("");
	}
}

/**********************   Invite Contact ********************************************************/


/** Invite a user to the chat  called from Toolbar*/
void ChatWindow::slotContactInvite(int i){
	// switchboard is active- invite
	QString str = contactInvite->text(i);

	if(switchBoardIsActive)
	{
		emit inviteContact(str);
	}
	else
	{			// no switchboard
//		slotStatusMsg(tr("Please wait...."));
		slotStatusMsg(tr(theApp->_WaitmsgText));
		// mmhhhh disable send button?   clicking the send button at this time, it will be create a
		// second session. For test i will disable it here and enable it in slotSwitchBoardIsActive(bool)
		view->SendButton->setEnabled(false);
		chatWith = str;
		emit createSession(str);
	}
}
/** Update the invite button in toolbar */
void ChatWindow::slotContactInvite()
{
	ChatMember *member;
	bool found = false;
	QString str;
	contactInvite->clear();
	QStringList list = theApp->imService->getAvailableContacts();
	
	for(QStringList::Iterator it = list.begin(); it != list.end(); ++it)
	{
		str = (*it).latin1();
		found = false;
		for ( member = chatMemberList.first(); member != 0; member=chatMemberList.next() )
		{
			if(member->handle == str)
			{
				found = true;
			}
		}
		if(!found)
		{
			contactInvite->insertItem(str);
			found = false;
		}
	}
}


/**************************** Add Contact *****************************************/
/** This update the add contact menu */
void ChatWindow::slotContactAdd()
{
	ChatMember *member;
	contactAdd->clear();
	for ( member = chatMemberList.first(); member != 0; member=chatMemberList.next() )
	{
		if(member->inContactList)
		{
			contactAdd->insertItem(member->handle);
		}
	}
	contactAdd->insertItem(tr("Other..."));
}


/** this add the selected contact
to the contact list */
void ChatWindow::slotContactAdd(int i)
{
	if(contactAdd->text(i) == tr("Other...") )
	{
		theApp->slotContactAdd();
	}
	else
	{
		theApp->imService->contactAdd(contactAdd->text(i) );
	}
}

/******************************** Events **********************************************/
/** No descriptions */
void ChatWindow::closeEvent(QCloseEvent*){
	slotFileQuit();
}

/** No descriptions */
void ChatWindow::timerEvent(QTimerEvent* ev)
{
	if(ev->timerId() == timer_id)
	{
		if(view->textChanged)
		{
			emit typingMsg();
			view->textChanged = false;
		}
		else
		{
			updateStatusText();
		}
	}
}

/****************************************** Helper *********************************************/
/** Change the text in infoText */
void ChatWindow::updateInfoText(QString text)
{
	view->infoText->setText(text);

}
/** No descriptions */
void ChatWindow::slotChatWith(QString handle,bool av){
	chatWith = handle;
	available = av;
	setCaption(tr("Short Message -")+ " " +theApp->imService->getPublicName(chatWith));
	chatAction->setMenuText(tr("Chat with: ") + theApp->imService->getPublicName(chatWith));
	if(!waitingMessage.isEmpty()){
		if(av){
			// send waiting message
			sendMsg(waitingMessage);
			waitingMessage = "";
		}
	}
}

void ChatWindow::updateStatusText()
{
	ChatMember *member;
	time_t TR_ID =  time((time_t *)NULL);
	QString statusText;
	for ( member = chatMemberList.first(); member != 0; member=chatMemberList.next() )
	{
		if( (TR_ID - member->timeStamp) <= 6)
		{
//				statusText += theApp->imService->getPublicName(member->handle) + ",  ";
			if( !statusText.isEmpty() )
				statusText +=  ",  " + theApp->imService->getPublicName(member->handle);
			else
				statusText = theApp->imService->getPublicName(member->handle);
		}
	}
	if( !statusText.isEmpty() )
	{
		statusText = theApp->_WritesmsgText.arg(statusText);
   		slotStatusMsg(statusText);
	}
	else
	{
		// nothing todo - display default msg
		slotStatusMsg(statusMsg);
	}
}

/********************************** SLOTS *******************************************/
/** No descriptions */
void ChatWindow::slotSwitchBoardIsActive(bool active)
{
	switchBoardIsActive = active;
	if(!view->strSend->text().isEmpty())   // disabled in slotInviteUser()
	{
		if(!view->SendButton->isEnabled())
		{
			view->SendButton->setEnabled(true);
		}
	}
}

/** No descriptions */
void ChatWindow::slotSendButtonClicked(QString msg)
{
	if(switchBoardIsActive)
	{
		if(available)
		{
			// ok send the message
			emit sendMsg(msg);
			waitingMessage = "";
		}
		if(!available)
		{
			// not in chat- invite
			emit inviteContact(chatWith);
			waitingMessage  = msg; // send it later
//			slotStatusMsg(tr("Please wait...."));
			slotStatusMsg(tr(theApp->_WaitmsgText));
		}
	}
	if(!switchBoardIsActive)
	{
		// chat session is closed, reconnect
        emit closeSession();
		emit createSession(chatWith);
		waitingMessage = msg;
//		slotStatusMsg(tr("Please wait...."));
		slotStatusMsg(tr(theApp->_WaitmsgText));
	}
}

void ChatWindow::slotContactTyping(QString handle)
{
	ChatMember *member;
	// serch handle in ChatMemberList
	for ( member = chatMemberList.first(); member != 0; member=chatMemberList.next() )
	{
		if(member->handle == handle)
		{
			// this is the correct one
			// set a time stamp
			member->timeStamp = time((time_t *)NULL);
			updateStatusText();
			return;
		}
	}
}
bool ChatWindow::isChatMember(const QString handle)
{
	ChatMember *member;
	if(chatMemberList.count() == 0) return false;
	for ( member = chatMemberList.first(); member != 0; member=chatMemberList.next() )
	{
		if( member->handle  == handle)
		{
			return true;
		}
	}
	return false;
}
void ChatWindow::slotUpdateChatMemberList(QString handle, QString command,bool last)
{
	ChatMember *member;
	QString dummy,dummy1,dummy2;
	QString publicName = theApp->imService->getPublicName(handle);
	bool b = false;
	if(command == "BYE")
	{
		// remove member
		for ( member = chatMemberList.first(); member != 0; member=chatMemberList.next() )
		{
			if( member->handle  == handle)
			{
				if(chatMemberList.count() <= 1)
				{
			 	// create some info in infoText?  nobody in chat
				chatMemberList.remove(member);
				slotChatWith(handle,false);
				}
				else
				{
					chatMemberList.remove(member);
					view->systemMessage(publicName + tr(": has left the session"));
				}
			}
		}
	}
	if(!isChatMember(handle) ) // fixme : it must create a new chatwindow
	{
		if(command == "IRO")
		{
			// create new
			member = new ChatMember(handle,publicName);
			member->inContactList = theApp->imService->isNewContact(handle);
			chatMemberList.append(member);
			if(chatMemberList.count() > 1 )
			{
				if(last)
				{
					// this is the last in this multi chat session, create a system message
					for ( member = chatMemberList.first(); member != 0; member=chatMemberList.next() )
					{
						dummy += "<b>" + member->publicName + "</b>"  + "  " + member->handle + "<br>";
					}
					view->systemMessage(tr("You are talking with:") +"<br>" + dummy);
				}
			}
			else
			{
				slotChatWith(handle,true);
			}
		}
		if(command == "JOI")
		{
			member = new ChatMember(handle,publicName);
			member->inContactList = theApp->imService->isNewContact(handle);
			chatMemberList.append(member);
			 // send Info to chatView
		 	if(chatMemberList.count() <= 1)
		 	{
		 		slotChatWith(handle,true);
			}
			else
			{
				view->systemMessage(publicName + tr(" has joined the session"));
			}
		}
	} // end isChatMember(handle)
	if( chatMemberList.count() == 0)
	{
		// i'm alone
		updateInfoText(handle + " " + tr("has closed the chat window"));
		statusMsg = handle + " " + tr("has closed the chat window");
		QToolTip::add(view->infoText,tr("There is nobody in this Chat session!<br>If you send a message, <b>") + publicName + tr("</b> will be invite immediatly")) ;
	}
	else
	{
		dummy = "";
		dummy1 = tr("This poeple are in chat session") +"<br>";
		dummy2 = tr("This people are not in your Contact List:") +"<br>";
		for ( member = chatMemberList.first(); member != 0; member=chatMemberList.next() )
		{
			dummy += member->publicName + " <a href=\"mailto: " + member->handle + "\"> " + member->handle + "</a> ";
			dummy1 += "<b>" + member->publicName + "</b><a href=\"mailto: " + member->handle + "\">" + member->handle + "</a><br>";
			if(member->inContactList)
			{
				dummy2 += member->handle + "<br>";
				b = true;
			}
		}
		updateInfoText(dummy);
		statusMsg = dummy;
		if(b)
		{
			dummy2 += tr("You can add this Contact(s) in the File Menu");
			dummy1 += dummy2;
		}
		QToolTip::add(view->infoText,dummy1);
	}
}

void ChatWindow::slotMsgAcknowledgement(bool f)
{
	QString strTime;
	strTime=getCurrentTime(theApp->_MsgRecvtime);

	if(f)
	{
		if ((theApp->_Recvmsg != "2") && (theApp->_Recvmsg != "You")){
			statusMsg = theApp->_RecvdmsgText.arg(strTime);
			updateStatusText();
		}
	}
	else
	{
		statusMsg = theApp->_UnRecvdmsgText.arg(strTime);
		updateStatusText();
	}
}

void ChatWindow::slotMsgReceived(QString handle, QString publicName, QString msg)
{
	ChatMember *member;
	// serch handle in ChatMemberList
	for ( member = chatMemberList.first(); member != 0; member=chatMemberList.next() )
	{
		if(member->handle == handle)
		{
			// this is the correct one
			// set a time stamp
			member->timeStamp = member->timeStamp -6;

			if ((theApp->_Recvmsg != "0") && (theApp->_Recvmsg != "Another")){
				QString strTime;
				strTime=getCurrentTime(theApp->_MsgRecvtime);
				statusMsg = theApp->_RecvmsgText.arg(strTime);
			}
			updateStatusText();
		}
	}
	if ((theApp->_DispRecvtime != "0") && (theApp->_DispRecvtime != "None")){
		QString strTime;
		strTime=getCurrentTime(theApp->_DispRecvtime);
		view->insertMessage(publicName + tr("(") + strTime + tr(")"),msg);
	} else {
		view->insertMessage(publicName,msg);
	}
    if(theApp->view->TabView->currentPage() != this){
        theApp->view->TabView->changeTab(this,"* " + theApp->imService->getPublicName(chatWith));
    }else{
        theApp->view->TabView->changeTab(this,theApp->imService->getPublicName(chatWith));
    }

	if(QString::fromUtf8(theApp->_publicName) != publicName){
//		Global::statusMessage(publicName + " Says");
		Global::statusMessage(theApp->_SayText.arg(publicName));

	}

	if(!view->strSend->hasFocus() && QString::fromUtf8(theApp->_publicName) != publicName){
		theApp->ledBlink();
		blink = true;
	}
}

void ChatWindow::slotWriteMessage()
{
	emit typingMsg();
}

void ChatWindow::setMaxLayout(QRect qr){
	view->setMaximumSize(qr.width(),qr.height());
    view->resize(qr.width(),qr.height());
    resize(qr.width(),qr.height());
}

void ChatWindow::slotCloseTab(){
    theApp->view->TabView->removePage(this);
	if(blink){ theApp->ledOff(); }
    close();
}

void ChatWindow::slotShowMenu(){
    popMenu->exec(view->menuBtn->mapToGlobal(QPoint(0,0)));
}

void ChatWindow::slotCurrentChanged(QWidget *qw){
    if(qw==this){
        theApp->view->TabView->changeTab(this,theApp->imService->getPublicName(chatWith));
		view->TextBrowser->setText(view->TextBrowser->text());
		view->TextBrowser->scrollBy(0,view->TextBrowser->contentsHeight());
		view->TextBrowser->repaintContents(0,0,view->TextBrowser->contentsWidth(),view->TextBrowser->contentsHeight(),true);
		theApp->ledOff();
    }
}

void ChatWindow::slotTabRefresh(){
    theApp->view->TabView->showPage(this);
    view->strSend->setFocus();
}

void ChatWindow::slotLogOpen(){
	theApp->slotOpenLogWindow(chatWith);
}

void ChatWindow::slotLedOff(){
	if(blink){
		theApp->ledOff();
		blink = false;
		theApp->view->TabView->showPage(this);
	}
}

QString ChatWindow::getCurrentTime(QString flg){
	QString strTime;
	strTime=QDateTime::currentDateTime().toString();
	if ((flg == "2") || (flg == "Date Time")){
		QDateTime curDate;
		curDate=QDateTime::currentDateTime();
		strTime.sprintf("%d/%.2d/%.2d %d:%.2d",
			curDate.date().year(),
			curDate.date().month(),
			curDate.date().day(),
			curDate.time().hour(),
			curDate.time().minute());
	}
	if ((flg == "3") || (flg == "Time")){
		strTime=QTime::currentTime().toString();
	}
	return strTime;
}
