/*
 * kmerlin.s
 * Ccopyright (c) 2003-2004, deitest@hotmail.com, yanmar@ogonigo.com
 * 
 *kmerlin.s is based on  kmerlin ver1.41. olueg@olsd.de
 *Fixed by deitest@hotmail.com, yanmar@ogonigo.com 2003-2004
 */
/***************************************************************************
                          chatwindow.h  -  description
                             -------------------
    begin                : Wed Jul 4 2001
    copyright            : (C) 2001 by olaf lueg
    email                : olaf.lueg@t-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CHATWINDOW_H
#define CHATWINDOW_H

#include <qwidget.h>

#include <qmainwindow.h>
#include <qapp.h>
#include <qpopupmenu.h>
#include <qaccel.h>
#include <qaction.h>
#include <qlist.h>

#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>

class QPEMenuBar;
/**
  *@author olaf lueg
  */
class ChatMember;
class ChatViewImpl;
class QPopupMenu;
class KMerlinApp;
class QPEToolBar;
class QTabWidget;
class ChatWindow : public QMainWindow  {
   Q_OBJECT
public: 
	ChatWindow(QWidget *parent=0, QString _infoFontSize = "12", QString _menuFontSize = "10", QString _sendFontSize = "16",const char *name=0);
	~ChatWindow();
	ChatViewImpl *view;
	KMerlinApp *theApp;
	int timer_id;
	bool textChanged;
	QString chatWith, waitingMessage;
	QString strPixUser;
	bool switchBoardIsActive,available;
	QList <ChatMember> chatMemberList;

//	QPEMenuBar *menuBar;
	
   	QPopupMenu *popMenu;

	QPopupMenu *contactInvite;
	QPopupMenu *contactAdd ;


	QAction *fileQuit;
	QAction *editCut;
	QAction *editCopy;
	QAction *editPaste;
	QAction *logOpen;

	QAction *chatAction;
	QAction *editClear;



	QAction *viewSmileys;

	
//	QPopupMenu* menu;
private:
	QString statusMsg;
	bool blink;

public slots: // Public slots
	void slotStatusMsg(const QString &text);
	/** toggle the smileys */
	void slotViewSmileys( bool f );
	/** No descriptions */
	void slotFileQuit();
	/** No descriptions */
	void slotEditCopy();
	/** No descriptions */
	void slotEditPaste();
	/** No descriptions */
	void slotEditCut();
	/** No descriptions */
	void slotEditClear();
	
	/** No descriptions */
	void slotContactInvite(int i);
	void slotContactInvite();
	
	void slotContactAdd(int i);
	void slotContactAdd();

	void slotShowWindow();
    void slotCurrentChanged(QWidget *qw);

	  	
	void slotChatWith(QString handle,bool av);
	void updateInfoText(QString text);
	void slotSwitchBoardIsActive(bool active);
	void slotContactTyping(QString handle);
	void slotUpdateChatMemberList(QString handle, QString command,bool last);
	void slotMsgAcknowledgement(bool f);
	void slotMsgReceived(QString handle,QString publicName ,QString msg);
	void slotSendButtonClicked(QString);
	void slotWriteMessage();
	void slotTabRefresh();

public:

	void updateStatusText();
	
	void initActions();
	void initMenuBar();

	void closeEvent(QCloseEvent*);
	bool isChatMember(const QString handle);
	void connectToMenu();
	void setMaxLayout(QRect qr);
	QString getCurrentTime(QString flg);

private slots: // Private slots
    void slotCloseTab();
    void slotShowMenu();
	void slotLogOpen();
	void slotLedOff();

protected: // Protected methods
  /** No descriptions */
  void timerEvent(QTimerEvent* ev);
	

public:
signals: // Signals
	/** sends the contact is writing a message command
	*/
	void typingMsg();
	/** Invite an user to the current chat
  		@param The handle from this user
  	*/
  	void inviteContact(QString);
  	/** No descriptions */
  	void closeSession();
	/** reconnect to switchoard server */
	void createSession(QString);
	/** sends a message to switchboard server */
	void sendMsg(QString);
};

#endif
