/*
 * kmerlin.s
 * Ccopyright (c) 2003-2004, deitest@hotmail.com, yanmar@ogonigo.com
 * 
 *kmerlin.s is based on  kmerlin ver1.41. olueg@olsd.de
 *Fixed by deitest@hotmail.com, yanmar@ogonigo.com 2003-2004
 */

/***************************************************************************
                          imchatservice.cpp  -  description
                             -------------------
    begin                : Tue Nov 27 2001
    copyright            : (C) 2001 by Olaf Lueg
    email                : olueg@olsd.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "imchatservice.h"
#include "imservice.h"
#include "imfilereceive.h"
#include "kmerlin.h"
#include <time.h>
// qt
#include <qdatetime.h>
#include <qsocket.h>
#include <qstring.h>
#include <qmessagebox.h>


IMChatService::IMChatService(){
}
IMChatService::~IMChatService(){
	
}

void IMChatService::connectToSwitchBoard(QString ID, QString address, QString auth){
	QString server,port,command;
	time_t Tr_ID = time((time_t *)NULL);
	if(ID == 0L)
	{
		command.sprintf("USR %lu ",Tr_ID);
		command += myHandle +" "+ auth+"\r\n";
		server = address;
		server = server.left(server.find(":"));
		port = address;
		port = port.right(port.length() -port.findRev(":")-1);
	}
	else
	{
		command.sprintf("ANS %lu ",Tr_ID);
		command += myHandle +" "+ auth + " "+ ID +"\r\n";
		server = address;
		server = server.left(server.find(":"));
		port = address;
		port = port.right(port.length() -port.findRev(":")-1);
	}
	msgSocket = new QSocket(this);
	msgSocket->connectToHost(server,port.toUInt());
	connect(msgSocket,SIGNAL(readyRead()),this,SLOT(slotDataReceived()));
	connect(msgSocket,SIGNAL(connectionClosed()),this,SLOT(slotSocketClosed()));
	msgSocket->writeBlock(command,command.length());
	// send active message
	emit switchBoardIsActive(true);
}

//IMFileReceive fileReceive;

void IMChatService::slotDataReceived()
{
	QString str,len,miss; char dat[1024];
redo:
	if(msgSocket->canReadLine())
	{
		str= msgSocket->readLine();
		if(str.left(3) == "NAK")
		{
			emit msgAcknowledgement(false);    // msg has not reveived
		}
		if(str.left(3) == "ACK")
		{
			emit msgAcknowledgement(true);   // msg has received
		}
		if(str.left(3) == "JOI")
		{
			// new user joins the chat, update user in chat list
			emit switchBoardIsActive(true);
			emit updateChatMember(word(str,1),"JOI",false);
		}
		if(str.left(3) == "IRO")
		{
			// we have joined a multi chat session- this are the users in this chat
			emit switchBoardIsActive(true);
			if(word(str,2) == word(str,3) )
			{
				emit updateChatMember(word(str,4),"IRO",true);
			}
			else
			{
				emit updateChatMember(word(str,4),"IRO",false);
			}
		}
		if(str.left(3) == "USR")
		{
			callUser();
		}
		if(str.left(3) == "BYE")
		{
			// some has disconnect from chat, update user in chat list
			emit updateChatMember(word(str,1).replace(QRegExp("\r\n"),""),"BYE",false);
		}
	if(str.left(3) == "MSG")
	{
		len = word(str,3);
		msgSocket->readBlock(dat,len.toUInt());
		miss = dat;
		miss = miss.left(len.toUInt());
		if(miss.contains("Content-Type: text/plain;"))
		{
			miss = miss.right(miss.length() -miss.findRev("\r\n\r\n"));

			QString handle = word(str,1);
			emit msgReceived(handle,imService->getPublicName(handle), QString::fromUtf8(miss));//.replace(QRegExp("\r\n"),""));
		}
	// incoming message for File-transfer
		if(miss.contains("Content-Type: text/x-msmsgsinvite; charset=UTF-8"))
		{
		// filetransfer ,this comes in a later release
			// needs some debugging time
			if(miss.contains("Invitation-Command: ACCEPT"))
			{
				//Get the IP we are connecting to
				QString address = miss.right( miss.length() - miss.find( "IP-Address:" ) - 12 );
				address = address.left( address.find( "\r\n" ) );
				QString address2 = miss.right( miss.length() - miss.find( "IP-Address-Internal:" ) - 21 );
				address2 = address2.left( address2.find( "\r\n" ) );
				//Get the port
				QString port = miss.right( miss.length() - miss.find( "Port:" ) - 6 );
				port = port.left( port.find( "\r\n" ) );
				QString portX = miss.right( miss.length() - miss.find( "PortX:" ) - 7 );
				portX = portX.left( portX.find( "\r\n" ) );
				QString portX2 = miss.right( miss.length() - miss.find( "PortX-Internal:" ) - 16 );
				portX2 = portX2.left( portX2.find( "\r\n" ) );
				//Get the AuthCookie
				QString cookie = miss.right( miss.length() - miss.find( "AuthCookie:" ) - 12 );
				cookie = cookie.left( cookie.find( "\r\n" ) );
				//Receive the file
//				IMFileReceive fileReceive;
				fileReceive = new IMFileReceive();
				fileReceive->m_DownPath = imService->theApp->_downPath;
				fileReceive->run( lastFileName, address, address2, port, portX, portX2, cookie, myHandle );
				//Filetransfer is not supported
				
			}
			else if(miss.contains("Invitation-Command: INVITE"))
			{
				QString command, message;
				time_t Tr_ID = time((time_t *)NULL);
				QString cookie = miss.right( miss.length() - miss.find( "Invitation-Cookie:" ) - 19 );
				cookie = cookie.left( cookie.find( "\r\n" ));
				if(miss.contains("Application-GUID: {5D3E02AB-6190-11d3-BBBB-00C04F795683}"))
				{
					QString fileName = miss.right( miss.length() - miss.find( "Application-File:" ) - 18 );
					fileName = QString::fromUtf8(fileName.left( fileName.find( "\r\n" )));
					lastFileName = fileName;
					QString fileSize = miss.right( miss.length() - miss.find( "Application-FileSize:" ) - 22 );
					fileSize = fileSize.left( fileSize.find( "\r\n" ));
					if ( QMessageBox::warning( 0, tr("KMerlin File Transfer"),
						"Accept Transfer of \r\n" + fileName + "\r\n (" + fileSize + "B)",
			                          tr("Yes"), tr("No") ) == 0 )
					{
						message = "MIME-Version: 1.0\r\nContent-Type: text/x-msmsgsinvite; charset=UTF-8\r\n\r\nInvitation-Command: ACCEPT\r\n";
						message += "Invitation-Cookie: " + cookie + "\r\nLaunch-Application: FALSE\r\nRequest-Data: IP-Address:";
					} else {
						message = "MIME-Version: 1.0\r\nContent-Type: text/x-msmsgsinvite; charset=UTF-8\r\n\r\nInvitation-Command: CANCEL\r\n";
						message += "Invitation-Cookie: " + cookie + "\r\nCancel-Code: REJECT\r\n";
					}
				} else {
					message = "MIME-Version: 1.0\r\nContent-Type: text/x-msmsgsinvite; charset=UTF-8\r\n\r\nInvitation-Command: CANCEL\r\n";
					message += "Invitation-Cookie: " + cookie + "\r\nCancel-Code: REJECT_NOT_INSTALLED\r\n";
				}
				command.sprintf( "MSG %lu N %d\r\n", Tr_ID, message.length() );
				command += message;
				msgSocket->writeBlock( command, command.length() );
			}
			else if(miss.contains("Invitation-Command: CANCEL"))
			{
				  QMessageBox::warning(0,tr("KMerlin File Transfer"),tr("File Transfer was canceled."));
//				delete fileReceive;
			}
		}
		if(miss.contains("MIME-Version: 1.0\r\nContent-Type: text/x-msmsgscontrol\r\nTypingUser:"))
		{
			QString message;
			message = miss.right(miss.length() - miss.findRev(" ")-1);
			message = message.replace(QRegExp("\r\n"),"");
			emit userTypingMsg(message);    // changed 20.10.2001
		}
		if ((miss.contains("Content-Type: application/x-msnmsgrp2p"))
			&& (miss.contains("Content-Type: text/plain;") == false))
		{
			int pt = miss.find("INVITE");
			if (pt != -1 ) {
				qDebug("MSG:" + miss.mid(pt));
			}
			qDebug("CHAT-MSG:P2P");
		}
		}
	}
	if(msgSocket->canReadLine())goto redo;
}

// this sends the user is typing msg
void IMChatService::slotTypingMsg()
{
	time_t Tr_ID = time((time_t *)NULL);
	QString command, message = "MIME-Version: 1.0\r\nContent-Type: text/x-msmsgscontrol\r\nTypingUser: "+myHandle+"\r\n\r\n";
	command.sprintf("MSG %lu U %d \r\n",Tr_ID,message.length());
	command += message;
	msgSocket->writeBlock(command,command.length());
}

// this Invites an Contact
void IMChatService::slotInviteContact(QString handle)
{
	time_t Tr_ID = time((time_t *)NULL);
	QString command;
	command.sprintf("CAL %lu ",Tr_ID);
	command += handle+"\r\n";
	msgSocket->writeBlock(command,command.length());
}

// this sends a short message to the server
void IMChatService::slotSendMsg(QString message)
{
	time_t Tr_ID = time((time_t *)NULL);
	QString command,head;
	head ="MIME-Version: 1.0\r\nContent-Type: text/plain; charset=UTF-8\r\nX-MMS-IM-Format: FN=MS%20Sans%20Serif; EF=; CO=0; CS=0; PF=0\r\n\r\n";

	message = message.replace(QRegExp("\r\n"),"\n");
	message = message.replace(QRegExp("\r"),"\n");
	message = message.replace(QRegExp("\n"),"\r\n");

	head += message.utf8();
	command.sprintf("MSG %lu A %d\r\n",Tr_ID,head.length());
	command += head;
	msgSocket->writeBlock(command,command.length());
	emit msgReceived(myHandle, imService->getPublicName(), message);    // send the own msg to chat window
}

void IMChatService::slotSocketClosed()
{
	// we have lost the connection, send a message to chatwindow (this will not displayed)
	emit switchBoardIsActive(false);
	delete this;
}

void IMChatService::slotCloseSession()
{
	qDebug("CloseSession");
	QString command = "OUT\r\n";
	msgSocket->writeBlock(command,command.length());
}

void IMChatService::callUser()
{
	time_t Tr_ID = time((time_t *)NULL);
	QString command;
	command.sprintf("CAL %lu ",Tr_ID);
	command += msgHandle+"\r\n";
	msgSocket->writeBlock(command,command.length());
}

QString IMChatService::word( const QString &text , uint pos )
{
    QStringList list = QStringList::split( " ", text , true );

    if ( pos < list.count() )
        return list[ pos ];

    return "";
}

