/***************************************************************************
                          imfilereceive.cpp  - file recieve class
                             -------------------
    begin                : Friday 4 Oct 2002
    copyright            : (C) 2002 by Marc Brooker
    email                : mbrooker@smuts.uct.ac.za
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include "imfilereceive.h"
#include <qsocket.h>
#include <qfile.h>
#include <time.h>
//#include <kdebug.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>
//#include <qglobal.h>
//Timeout in seconds
#include <qmessagebox.h>

#define TRANSFER_TIMEOUT 30

  FILE *myoutFile;
  int myinSocket;
  int myfileSize;

IMFileReceive::IMFileReceive()
{
  qDebug("filerecieve created");
}

IMFileReceive::~IMFileReceive()
{
  qDebug("filerecieve deleted");
}

/* Start and run the file transfer */
void IMFileReceive::run(QString fileName, QString address, QString address2, QString port, QString portX, QString portX2, QString cookie, QString passport)
{  
  m_status = 0;
  debug("File Transfer started");
//  QString saveName = KFileDialog::getSaveFileName("~/"+fileName, "*.*");
  QString saveName = m_DownPath+tr("/")+fileName;

  if (saveName == QString::null)
    return;
  debug("Save Name: " + saveName);

  m_fileName = saveName;
  m_fileName2 = fileName;
  m_address = address;
  m_address2 = address2;
  m_port = port;
  m_portX = portX;
  m_portX2 = portX2;
  m_cookie = cookie;
  m_passport = passport;
  m_connecthow = 0;

	qDebug("Address:" + m_address);
	qDebug("Address2:" + m_address2);
	qDebug("Port:" + m_port);
	qDebug("PortX:" + m_portX);
	qDebug("PortX2:" + m_portX2);
  //Make a socket
	recvSocket = new QSocket( this );
	connect(recvSocket,SIGNAL(connected()),this,SLOT(slotSocketConnected()));
	connect(recvSocket,SIGNAL(error(int)),this,SLOT(slotSocketError(int)));
	connect(recvSocket,SIGNAL(readyRead()),this,SLOT(slotDataReceived()));

	recvSocket->connectToHost(m_address,m_port.toUInt());

}

void IMFileReceive::slotSocketConnected()
{
	qDebug("filereceive connected");
  m_connecthow = 2;
  QString command("VER MSNFTP\r\n");
  recvSocket->writeBlock(command, command.length());

}

void IMFileReceive::disconnect()
{
  recvSocket->writeBlock("BYE 16777989\r\n", 15); 
  delete recvSocket;
}

void IMFileReceive::slotSocketError(int error)
{
	if (m_connecthow == 0) {
		debug("connect2");
		m_connecthow = 1;
		if (m_portX != "") {
			recvSocket->connectToHost(m_address,m_portX.toUInt());
			return;
		}
	}
	if (m_connecthow == 1) {
		debug("connect3");
		m_connecthow = 2;
		if (m_address2 != "") {
			recvSocket->connectToHost(m_address2,m_portX2.toUInt());
			return;
		}
	}

	switch(error)
	{
		case 0:
		{
			QMessageBox::warning(0,tr("Error"),tr("Connection refused"));
			break;
		}
		case 1:
		{
			QMessageBox::warning(0,tr("Error"),tr("Host not found"));
			break;
		}
		default:
		{
			QMessageBox::warning(0,tr("Error"),tr("Socket error"));
		}
	}
//	emit connected(false);
	delete recvSocket;
	      delete this;

}

void IMFileReceive::slotDataReceived()
{
  qDebug("slotDataReceived");
if (m_status == 0) {
  int bufSize = 2048;
  char buffer[bufSize];
  int status, i = 0, start = time(NULL);
  buffer[0] = 0;
  do
    { 
      if ((time(NULL) - start) > TRANSFER_TIMEOUT) 
	{
	  debug("socketReadLine transfer timeout\n");
        disconnect();
	      delete this;
	  return;
	}
      status = recvSocket->readBlock(&(buffer[i]), 1);
      if (status == 1)
	{
	  i++;	
	  if ((buffer[i-1] == '\n') || (i == bufSize))
	    {
//	qDebug("data read:%s",buffer);
	    break;
		}
	}
      if ((status == -1) && (errno == EAGAIN))
	status = 0;	
    }
  while (status != -1);

  if (strstr(buffer, "VER") != NULL)
    {
	qDebug("MSFTP:GET VER");
	  QString command;	
	  command.sprintf("USR %s %s\r\n", m_passport.latin1(), m_cookie.latin1());
	  if (recvSocket->writeBlock(command, command.length()) <= -1 )
	    {
	      debug("Error writeblock to USR " + m_address);
              disconnect();
	      delete this;
	      return;
	    }
	      return;
    }
  if (strstr(buffer, "USR") != NULL) {
	qDebug("MSFTP:GET USR");
	    return;
  }
  if (strstr(buffer, "FIL") == NULL)
    {
      qDebug("Wrong response from server: %s (expected FIL)\n",buffer);
      disconnect();
      delete this;
      return;
    }

	qDebug("MSFTP:GET FIL");
  //Get the filesize
  int fileSize;
  QString qresult(buffer);
  QString fSize = qresult.right(qresult.length() - qresult.find("FIL")-4);
  fileSize = fSize.left(fSize.find("\r\n")).toInt();
  //Send the TFR

	  QString command("TFR\r\n");	
	  if (recvSocket->writeBlock(command, command.length()) <= -1 )
	    {
	      debug("Error writeblock to TFR " + m_address);
              disconnect();
	      delete this;
	    }


  debug("Handshake Done. Got Filesize "+fSize);
  
  m_status = 1;
  waitData = 0;  
  gotData = 0;
  //Open the output file
//  FILE *outFile = fopen(m_fileName.data(), "w");

  recvFile = new QFile( m_fileName );
  if ( !recvFile->open( IO_WriteOnly ) )
    {
      qDebug("Unable to Open %s.", m_fileName.data());
      return;
    }

  
//  myoutFile = outFile;
  myinSocket = recvSocket->socket();
  myfileSize = fileSize;
  return ;
}

  recvSocket->waitForMore(1000);
  int lastReceived = time(NULL);    
redo:
	if(recvSocket->bytesAvailable())
{
  char *buffer = new char[4];
  //Read data from socket

      if ((time(NULL) - lastReceived) > TRANSFER_TIMEOUT)
	{
	  QMessageBox::warning(0,tr("KMerlin File Transfer"),tr("Timeout on file receive.\r\n" + m_fileName2 + "\r\n"));
	  qDebug("Timeout on file receive");
	      recvFile->close();
	      disconnect();
	      delete this;
	  return;
	}
      if (waitData == 0)
	{	  
	  //We have a header
          if (recvSocket->readBlock(buffer, 3) == 0)
	    {
	      qDebug("Read error on socket\n");
	      recvFile->close();
	      disconnect();
	      delete this;
	      return;
	    }
	  //Check validity
	  if (buffer[0] != 0)
	    {
	  QMessageBox::warning(0,tr("KMerlin File Transfer"),tr("Data Stream Malformed.\r\n" + m_fileName2 + "\r\n"));
	      qDebug("Data Stream Malformed\n");
	      recvFile->close();
	      disconnect();
	      delete this;
	      return;
	    }
	  waitData = buffer[1] + buffer[2]*256;	  
	  lastReceived = time(NULL);
	}
	delete[] buffer;

    {
      //Check for a timeout
      if ((time(NULL) - lastReceived) > TRANSFER_TIMEOUT)
	{
	  QMessageBox::warning(0,tr("KMerlin File Transfer"),tr("Timeout on file receive.\r\n" + m_fileName2 + "\r\n"));
	  qDebug("Timeout on file receive");
	      recvFile->close();
	      disconnect();
	      delete this;
	      return;
	}
      if (waitData > 0)
	{	  
	  char *transBuffer  = new char[waitData+1];
	  //We have data	  
          unsigned int gotDataPacket = recvSocket->readBlock(transBuffer, waitData);
	  //Put it in the file	  
	  recvFile->writeBlock(transBuffer, gotDataPacket);
	  //Calculate how much data we still need to wait for
	  gotData += gotDataPacket;
	  waitData -= gotDataPacket;
	  lastReceived = time(NULL);
	  delete[] transBuffer;
	  qDebug("gotData:%d waitData:%d",gotData,waitData);
	}
    }
	goto redo;
}
  if (gotData >= myfileSize) {
  qDebug("Done\n");
  recvSocket->writeBlock("BYE 16777989\r\n", 15); 
      recvFile->close();
//      disconnect();
  QMessageBox::warning(0,tr("KMerlin File Transfer"),tr("File Transer completed.\r\n" + m_fileName2 + "\r\n"));
  delete recvSocket;
	delete this;
  }
}
