/***************************************************************************
                          imfilereceive.h - File Receive class
                             -------------------
    begin                : Friday 4 October 2002
    copyright            : (C) 2002 by Marc Brooker
    email                : mbrooker@smuts.uct.ac.za
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef IM_FILERECEIVE
#define IM_FILERECEIVE

#include <qobject.h>
#include <qstrlist.h>
#include <qsocket.h>
#include <qfile.h>

class IMFileReceive: public QObject
{
Q_OBJECT
 public:
  IMFileReceive();
  ~IMFileReceive();
  void run(QString fileName, QString address, QString address2, QString port, QString portX, QString portX2, QString cookie, QString passport);
  QString m_DownPath;
 private:
  
  bool receiveData(QString fileName, int fileSize);
  void disconnect();
  QSocket *recvSocket;
  QFile *recvFile;
  QString m_fileName;
  QString m_fileName2;
  QString m_address;
  QString m_address2;
  QString m_port;
  QString m_portX;
  QString m_portX2;
  QString m_cookie;
  QString m_passport;
  int m_connecthow;
  int m_status;
  unsigned int gotData;
  unsigned int waitData;

protected slots:
	void slotSocketConnected();
	void slotSocketError(int error);
	void slotDataReceived();
};

#endif
