/*
 * kmerlin.s
 * Ccopyright (c) 2003-2004, deitest@hotmail.com, yanmar@ogonigo.com
 * 
 *kmerlin.s is based on  kmerlin ver1.41. olueg@olsd.de
 *Fixed by deitest@hotmail.com, yanmar@ogonigo.com 2003-2004
 */
/***************************************************************************
                          imservice.cpp  -  description
                             -------------------
    begin                : Sat Nov 10 2001
    copyright            : (C) 2001 by Olaf Lueg
    email                : olueg@olsd.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// other include
#include "imservice.h"
#include "imcontact.h"
#include "imgroups.h"
#include "imservicesocket.h"
#include "imchatservice.h"



// qt include
#include <qlabel.h>
#include <qtextcodec.h>

#define Forward 0x01
#define Allow 0x02
#define Block 0x04
#define Reverse 0x08

IMService::IMService()
{
	_serial = 0;
	groupList.setAutoDelete(true);
	contactList.setAutoDelete(true);
	_status = FLN;
	_publicName = "";
	connected = false;
	serviceSocket = new IMServiceSocket();
	// connections
	connect( serviceSocket, SIGNAL(groupAdded(QString, uint,uint)), this, SLOT(slotGroupAdded(QString, uint, uint )));
	connect( serviceSocket, SIGNAL(groupRenamed(QString, uint,uint)), this, SLOT(slotGroupRenamed( QString, uint, uint)));
	connect( serviceSocket, SIGNAL(groupName(QString, uint)), this, SLOT(slotGroupName(QString, uint)));
	connect( serviceSocket, SIGNAL(groupRemoved( uint, uint )), this, SLOT(slotGroupRemoved(uint, uint )));
	
	connect( serviceSocket, SIGNAL(contactAdded(QString, QString, QString, uint, uint)), this, SLOT(slotContactAdded(QString, QString, QString, uint, uint )));
	connect( serviceSocket, SIGNAL(contactRemoved(QString, QString, uint, uint)), this, SLOT(slotContactRemoved(QString, QString, uint, uint)));
	
	// SessionID, Address, AuthInfo, handle, publicName
	connect( serviceSocket, SIGNAL(invitedToChat(QString, QString, QString, QString, QString )), this, SLOT(slotCreateChat( QString, QString, QString, QString, QString )));
	connect( serviceSocket, SIGNAL(startChat( QString,QString )), this, SLOT(slotCreateChat(QString, QString )));
	
	connect( serviceSocket, SIGNAL(contactStatusChanged(QString, QString, QString, QString)), this, SLOT(slotContactStatusChanged(QString, QString, QString, QString)));
	connect( serviceSocket, SIGNAL(contactStatus(QString, QString, QString, QString)), this, SLOT(slotContactStatus(QString, QString, QString, QString)));
	connect( serviceSocket, SIGNAL(contactList(QString, QString, QString, QString)), this, SLOT(slotContactList(QString, QString, QString, QString)));
	
	connect( serviceSocket, SIGNAL( connected(bool)), this, SLOT(slotConnected(bool )));
	connect( serviceSocket, SIGNAL( statusChanged( QString )), this, SLOT(slotStatusChanged( QString )));
	
	connect( serviceSocket, SIGNAL( newMail( QString, uint )), this, SLOT(slotNewMail( QString, uint )));

	connect( serviceSocket, SIGNAL( publicNameChanged(QString ,QString)), this, SLOT(slotPublicNameChanged(QString, QString)));
	connect( serviceSocket, SIGNAL( newPublicName(QString)), this, SLOT(slotPublicNameReceived(QString)));

	connect( serviceSocket, SIGNAL( setMSPAuth(QString,QString,QString,QString)), this, SLOT(slotSetMSPAuth(QString,QString,QString,QString)));
	connect( serviceSocket, SIGNAL( setHotMailUrl(QString,QString,QString)), this, SLOT(slotSetHotMailUrl(QString,QString,QString)));

}
IMService::~IMService(){
}

void IMService::cleanUp()
{
	contactList.clear();
	groupList.clear();
	_status = FLN;
	_serial = 0;
}

void IMService::connectToService()
{

	serviceSocket->connectToService(_handle, _password, _serial, _hostAddr, _tcpPort);
	emit connectingToService();
}


void IMService::disconnect()
{
	serviceSocket->closeService();
}

void IMService::cancelConnect()
{
	serviceSocket->kill();
}

void IMService::changeStatus( Status status, QString pictureObj)
{
	serviceSocket->setStatus(status, pictureObj);
}

void IMService::setMyPublicName( QString publicName )
{
	serviceSocket->changePublicName( publicName );
}

void IMService::setMobile( QString Mobile )
{
	serviceSocket->setMobile( Mobile );
}

void IMService::setRefTimer( QString RefTimer )
{
	serviceSocket->setRefTimer( RefTimer );
}

// slots
// SessionID, Address, AuthInfo, handle, publicName     ( RNG)
void IMService::slotCreateChat(QString ID, QString address, QString auth, QString handle, QString publicName)
{
	chatService = new IMChatService();
	chatService->setHandle(_handle);
	chatService->imService = this;
	chatService->connectToSwitchBoard(ID, address, auth);
	emit startChat(chatService, handle);
}
// (XFR)
void IMService::slotCreateChat( QString address, QString auth)
{
	chatService = new IMChatService();
	chatService->setHandle(_handle);
	chatService->msgHandle = msgHandle;
	chatService->imService = this;
	chatService->connectToSwitchBoard(0L, address, auth);
	emit startChat(chatService, msgHandle);
}

void IMService::slotStartChatSession(QString handle)
{
	if(connected)
	{
		if( handle == _handle) return;
		msgHandle =handle;
		serviceSocket->createChatSession();
	}
}

void IMService::contactSendMail(QString handle)
{
	QString msg;
	msg = "msg test";
	serviceSocket->SendMail( handle, msg );
}

void IMService::slotConnected( bool f)
{
	if(f)
	{
		_publicName = serviceSocket->_publicName;
	}
	emit connectedToService(f);
	connected = f;
	if(!f)
	{
		cleanUp();
	}
	
}

// this is the own status
void IMService::slotStatusChanged( QString status )
{
	_status = convertStatus( status );
	emit statusChanged( _status );
}

// contact has changed status
void IMService::slotContactStatusChanged(QString handle, QString publicName, QString status, QString ClientID)
{
	IMContact *imContact;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if(imContact->getHandle() == handle )
		{
			if ( ClientID != "" ) {
				bool ok;
				if (ClientID.toInt(&ok,10) & 1 == 1) {
					imContact->setMobile(true);
				} else {
					imContact->setMobile(false);
				}
			}
			int old = imContact->getStatus();
			if( status == "FLN" )
			{
				imContact->setStatus(convertStatus(status) );
				emit updateContact( handle,  convertStatus(status), old);
				return;
			}
			else
			{
				imContact->setStatus(convertStatus(status) );
				if (imContact->getPublicName() != publicName) {
					imContact->setPublicName(publicName);
					serviceSocket->changeNickName( handle, publicName );
				}

				emit updateContact( handle,  convertStatus(status), old);
				return;
			}
		}
	}
}

// status of contact after login
void IMService::slotContactStatus(QString handle, QString publicName, QString status, QString ClientID)
{
	IMContact *imContact;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if(imContact->getHandle() == handle )
		{
			if ( ClientID != "" ) {
				bool ok;
				if (ClientID.toInt(&ok,10) & 1 == 1) {
					imContact->setMobile(true);
				} else {
					imContact->setMobile(false);
				}
			}
			int old = imContact->getStatus();
			imContact->setStatus(convertStatus(status) );
			if (imContact->getPublicName() != publicName) {
				imContact->setPublicName(publicName);
				serviceSocket->changeNickName( handle, publicName );
			}
			emit updateContact(handle, convertStatus(status), old);
			return;
		}
	}
}

void IMService::slotContactList(QString handle, QString publicName, QString group, QString list )
{
	IMContact *imContact, *imSearchContact;
	QString groupName;
	QStringList groups;
	groups = QStringList::split(",",group, false );
	int flags = list.toInt();

	if( flags & Forward )
	{
		imContact = new IMContact();
		imContact->setHandle(handle);
		imContact->setPublicName(publicName);
		imContact->setDeleted(false);
		for ( QStringList::Iterator it = groups.begin(); it != groups.end(); ++it )
		{
			imContact->addToGroup( getGroupName( (*it).latin1() ) );
		}
		contactList.append( imContact );
		if( flags & Block ) {
			imContact->setBlocked(true);
		}
		return;
	}
	if( flags & Block )
	{
		for( imSearchContact = contactList.first(); imSearchContact != 0; imSearchContact = contactList.next() )
		{
			if(imSearchContact->getHandle() == handle)
			{
				imSearchContact->setBlocked(true);
				return;
			}
		}
		imContact = new IMContact();  // deleted contact
		imContact->setHandle(handle);
		imContact->setPublicName(publicName); // this is an deleted Contact
		imContact->setDeleted(true);
		contactList.append( imContact );
		return;

	}
	if( flags & Allow )
	{
		for( imSearchContact = contactList.first(); imSearchContact != 0; imSearchContact = contactList.next() )
		{
			if(imSearchContact->getHandle() == handle)
			{
				return;
			}
		}
		imContact = new IMContact();
		imContact->setHandle(handle);
		imContact->setPublicName(publicName); // this is an deleted Contact
		imContact->setDeleted(true);
		contactList.append( imContact );
		return;
	}
	if( flags & Reverse )
	{
		// search for new Contacts
		for( imSearchContact = contactList.first(); imSearchContact != 0; imSearchContact = contactList.next() )
		{
			if(imSearchContact->getHandle() == handle)
			{
				imSearchContact->setPublicName(publicName);
				return;
			}
		}
		// contact not found - Authenticate
		emit newContact( handle );
	}
		
}
void IMService::slotContactAdded(QString handle, QString publicName, QString list, uint serial, uint group)
{
	IMContact *imContact;
	IMGroups *imGroup;
	QString groupName;
	_serial = serial;
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next())
	{
		if(imGroup->group == group)
		{
			groupName = imGroup->groupName;
		}
	}
	for( imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if(imContact->getHandle() == handle )
		{
			int old = imContact->getStatus();
			if( group != 0L)
			{
				imContact->addToGroup(groupName);
			}
			if( list == "BL" )
			{
				imContact->setBlocked(true);
				emit updateContact(handle, BLO, old);
			}
			if( list == "FL" )
			{
				imContact->addToGroup(groupName );
				emit contactAdded(handle, publicName, groupName);
			}
			return;
		}
	}
	// contact not found
	// create new one
	if( list == "FL" )
	{
		imContact = new IMContact();
		imContact->setHandle(handle);
		imContact->setPublicName(publicName); // this is an deleted Contact
		imContact->setDeleted(true);
		imContact->addToGroup( groupName );
		contactList.append( imContact );
		emit contactAdded(handle, publicName, groupName);
		return;
	}
	if( list == "AL" )
	{
		imContact = new IMContact();
		imContact->setHandle(handle);
		imContact->setPublicName(publicName); // this is an deleted Contact
		imContact->setBlocked(false);
		contactList.append( imContact );
		return;
	}
	emit newContact( handle );
}

void IMService::slotContactRemoved(QString handle, QString list, uint serial, uint group)
{
	IMContact *imContact;
	IMGroups *imGroup;
	QString groupName;
	_serial = serial;
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next())
	{
		if(imGroup->group == group)
		{
			groupName = imGroup->groupName;
		}
	}
	for( imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if(imContact->getHandle() == handle )
		{
			int old = imContact->getStatus();
			if( group != 0L)
			{
				imContact->removeFromGroup(groupName);
			}
			if( list == "BL" )
			{
				imContact->setBlocked(false);
				serviceSocket->addContact( handle, getPublicName(handle), 0, AL );
				emit updateContact(handle, imContact->getStatus(), old);
			}
			if( list == "RL" )
			{ /*
				InfoWidget *info = new InfoWidget(0);
				info->title->setText("<b>" + i18n( "Contact removed!" ) +"</b>" );
				QString dummy;
				dummy = "<center><b>" + imContact->getPublicName() + "(" +imContact->getHandle()  +")</b></center><br>";
				dummy += i18n("has removed you from his contact list!") + "<br>";
				dummy += i18n("This contact is now removed from your contact list");
				info->infoText->setText(dummy);
				info->setCaption("KMerlin - Info");
				info->show();  */
				
			}
			if( list == "FL" )
			{
				imContact->removeFromGroup(groupName);
				emit contactRemoved( handle, groupName );
			}
			if( imContact->getGroupList().count() == 0 )
			{
				contactList.remove(imContact);
			}
			
		}
	}
}

void IMService::slotPublicNameReceived(QString publicName)
{
	_publicName = publicName;
	emit publicNameChanged(_publicName);
}

void IMService::slotPublicNameChanged(QString handle, QString publicName)
{
	if( handle == _handle)
	{
		_publicName = QString::fromUtf8(publicName);
		emit publicNameChanged(publicName);
	}
}

void IMService::slotGroupName(QString groupName, uint group)
{
	IMGroups *imGroup = new IMGroups();
	imGroup->group = group;
	imGroup->groupName = groupName;
	groupList.append(imGroup);
}

void IMService::slotGroupAdded( QString groupName, uint serial, uint group)
{
	IMGroups *imGroup = new IMGroups();
	_serial = serial;
	imGroup->group = group;
	imGroup->groupName = groupName.utf8();
	groupList.append(imGroup);
	emit groupAdded(groupName);
}

void IMService::slotGroupRenamed( QString groupName, uint serial, uint group )
{
	IMGroups *imGroup;
	IMContact *imContact;
	QString oldGroupName;
	_serial = serial;
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next() )
	{
		if(imGroup->group == group )
		{
			oldGroupName = imGroup->groupName;
			for( imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
			{
				if( imContact->isInGroup(oldGroupName) )
				{
					imContact->removeFromGroup(oldGroupName);
					imContact->addToGroup(groupName.utf8());
				}
			}
			imGroup->groupName = groupName.utf8();
			emit groupRenamed(oldGroupName, groupName.utf8());
			return;
		}
	}
}

void IMService::slotNewMail( QString message, uint count )
{
	emit newMail(message, count);
}

void IMService::slotGroupRemoved( uint serial, uint group )
{
	IMGroups *imGroup;
	QString groupName;
	_serial = serial;
	 for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next() )
	{
		if( imGroup->group == group)
		{
			groupName = imGroup->groupName;
		}
	}
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next() )
	{
		if(imGroup->group == group )
		{
			groupList.remove(imGroup);
		}
	}
	emit groupRemoved(groupName);
}

// get a list of all contacts in this group
QStringList IMService::getContacts( const QString &groupName)
{
	IMContact *imContact;
	QStringList list;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if( imContact->isInGroup(groupName) )
		{
			list.append(imContact->getHandle() );
		}
	}
	return list;
}

bool IMService::isAvailable(QString handle)
{
	IMContact *imContact;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if( imContact->getHandle() == handle )
		{
			if(imContact->getStatus() != FLN  )
			{
				return true;
			}
			else return false;
		}
	}
	return false;
}

QStringList IMService::getAvailableContacts()
{
	IMContact *imContact;
	QStringList list;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if( imContact->getStatus() != FLN  )
		{
			list.append(imContact->getHandle() );
		}
	}
	return list;
}


QString IMService::getGroupInfo(QString groupName)
{
	IMContact *imContact;
	int cnCount, coCount;
	cnCount = coCount =0;
	QString dummy;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if( imContact->isInGroup(groupName) )
		{
			cnCount++;
			if(imContact->getStatus() != FLN)
			{
				coCount++;
			}
		}
	}
	dummy.sprintf("( %i / %i )",cnCount, coCount);
	return dummy;

}
// get a list of all groups
QStringList IMService::getGroups()
{
	IMGroups *imGroup;
	QStringList list;
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next() )
	{
		list.append(imGroup->groupName );
	}
	return list;
}

// add a new group
void IMService::groupAdd()
{
	IMGroups *imGroup;
	int i = 1;
	QString newGroupName;
	QString num;
redo:
	num.setNum(i);
	newGroupName = tr("New Group")+ num;
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next() )
	{
		if(imGroup->groupName == newGroupName)
		{
			i++;
			goto redo;
		}
	}
	serviceSocket->addGroup( newGroupName );
}

// rename a group
void IMService::groupRename( QString oldGroupName, QString newGroupName )
{
	IMGroups *imGroup;
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next() )
	{
		if(QString::fromUtf8(imGroup->groupName) == oldGroupName)
		{

			QString dummy;
			dummy.sprintf("%i",imGroup->group);
			serviceSocket->renameGroup( newGroupName, dummy );
			return;
		}
	}
}

// remove a group
void IMService::groupDelete( QString groupName )
{
	IMGroups *imGroup;
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next() )
	{
		if(QString::fromUtf8(imGroup->groupName) == groupName)
		{
			serviceSocket->removeGroup( imGroup->group );
			return;
		}
	}
}

void IMService::contactAdd( QString handle )
{
	if(connected)
	{
		serviceSocket->addContact( handle, getPublicName( handle ), 0, FL);
		serviceSocket->addContact( handle, getPublicName( handle ), 0, AL);
	}
}


void IMService::contactCopy( QString handle, QString groupName )
{
	IMGroups *imGroup;
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next() )
	{
		if(QString::fromUtf8(imGroup->groupName) == groupName)
		{
			serviceSocket->addContact( handle, getPublicName( handle), imGroup->group, FL);
			return;
		}
	}
}

void IMService::contactMove( QString handle, QString oldGroupName, QString newGroupName )
{
	IMGroups *imGroup;
	uint newGroup = getGroupNumber( newGroupName );
	uint oldGroup = getGroupNumber( oldGroupName );
	
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next() )
	{
		if(QString::fromLocal8Bit(imGroup->groupName) == oldGroupName)
		{
			serviceSocket->addContact( handle, getPublicName(handle), newGroup, FL);
			serviceSocket->removeContact(handle, oldGroup, FL );
			return;
		}
	}
}

void IMService::contactRemove( QString handle, QString groupName )
{
	IMGroups *imGroup;
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next() )
	{
		if(QString::fromLocal8Bit(imGroup->groupName) == groupName)
		{
			serviceSocket->removeContact( handle, imGroup->group, FL );
			return;
		}
	}
}

uint IMService::getGroupNumber( QString groupName )
{
	IMGroups *imGroup;
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next() )
	{
		if(QString::fromLocal8Bit(imGroup->groupName) == groupName)
		{
			return imGroup->group;
		}
	}
	return 0;
}

QString IMService::getGroupName( QString number )
{
	IMGroups *imGroup;
	for( imGroup = groupList.first(); imGroup != 0; imGroup = groupList.next() )
	{
		if(imGroup->group == number.toUInt() )
		{
			return imGroup->groupName;
		}
	}
	return "";
}

// this deletes a contact from the list
void IMService::contactDelete( QString handle )
{
	QStringList list;
	QString groupName;
	IMContact *imContact;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if( imContact->getHandle() == handle )
		{
			list =  imContact->getGroupList();
		}
	}
	for ( QStringList::Iterator it = list.begin(); it != list.end(); ++it )
	{
		serviceSocket->removeContact( handle, getGroupNumber( (*it).latin1() ), FL );
	}
	if( isBlocked( handle ) )
	{
		serviceSocket->removeContact( handle, 0, BL );
	}
	
}

void IMService::contactBlock( QString handle )
{
	int old = getStatus( handle );
	serviceSocket->removeContact( handle, 0, AL);
	serviceSocket->addContact( handle, getPublicName( handle ), 0, BL );
	emit updateContact(handle, BLO, old);
}

void IMService::contactUnBlock( QString handle )
{
	int old = getStatus( handle );
	serviceSocket->removeContact( handle, 0, BL );
	emit updateContact(handle, getStatus( handle ), old);
	
}


// get a list of all blocked contacts
QStringList IMService::getBlockedContacts()
{
	IMContact *imContact;
	QStringList list;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if( imContact->isBlocked () )
		{
			list.append(imContact->getHandle() );
		}
	}
	return list;
}

QString IMService::getPublicName(  QString handle)
{
	IMContact *imContact;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if( imContact->getHandle() == handle )
		{
			return imContact->getPublicName();
		}
	}
	return handle;
}

bool IMService::isBlocked( QString handle)
{
	IMContact *imContact;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if(imContact->getHandle() == handle )
		{
			return imContact->isBlocked();
		}
	}
	return false;
}

bool IMService::isMobile( QString handle)
{
	IMContact *imContact;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if(imContact->getHandle() == handle )
		{
			return imContact->isMobile();
		}
	}
	return false;
}

bool IMService::isNewContact(QString handle )
{
	IMContact *imContact;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if(imContact->getHandle() == handle )
		{
			return false;
		}
	}
	return true;
}

// get the status from this contacts
int IMService::getStatus(  QString handle)
{
	IMContact *imContact;
	for(imContact = contactList.first(); imContact != 0; imContact = contactList.next() )
	{
		if(imContact->getHandle() == handle )
		{
			return imContact->getStatus();
		}
	}
	return FLN;
}

bool IMService::getMailEnable()
{
	return serviceSocket->MailEnable;
}
void IMService::readConfig()
{

}




int IMService::convertStatus( QString status )
{
	if(status == "NLN")
	{
		return NLN;
	}
	if(status == "FLN")
	{
		return FLN;
	}
	if(status == "HDN")
	{
		return HDN;
	}
	if(status == "PHN")
	{
		return PHN;
	}
	if(status == "LUN")
	{
		return LUN;
	}
	if(status == "BRB")
	{
		return BRB;
	}
	if(status == "AWY")
	{
		return AWY;
	}
	if(status == "BSY")
	{
		return BSY;
	}
	if( status == "IDL" )
	{
		return IDL;
	}
	return FLN;
}

QString IMService::GetHotMail(QString _address) {

	QTextCodec *codec = QTextCodec::codecForName( "eucJP" );
	QString buf = "";
	buf += "<html>\r\n";
	buf += "<head>\r\n";
	buf += "<noscript>\r\n";
	buf += "<meta http-equiv=Refresh content=\"0;url=";
	buf += "http://www.hotmail.com";
	buf += "\">\r\n";
	buf += "</noscript>\r\n";
	buf += "</head>\r\n";
	buf += "<body onload=\"document.pform.submit(); \">\r\n";
	buf += "<form name=\"pform\"\r\n";
	buf += "action=\"";
	buf += _actionurl;
	buf += "\" method=\"POST\">\r\n";
	buf += "<input type=\"hidden\" name=\"mode\" value=\"ttl\">";
	buf += "<input type=\"hidden\" name=\"login\" value=\"";

	buf += "\">\r\n";
	buf += "<input type=\"hidden\" name=\"username\" value=\"";
	buf += _handle;
	buf += "\">\r\n";
	buf += "<input type=\"hidden\" name=\"sid\" value=\"";
	buf += _sid;
	buf += "\">\r\n";
	buf += "<input type=\"hidden\" name=\"kv\" value=\"";
	buf += _kv;
	buf += "\">\r\n";
	buf += "<input type=\"hidden\" name=\"id\" value=\"";
	if ( _address == "" ) {
		buf += _id;
	} else {
		buf += "2";
	}
	buf += "\">\r\n";
	buf += "<input type=\"hidden\" name=\"sl\" value=\"";
	buf += "9";
	buf += "\">\r\n";
	buf += "<input type=\"hidden\" name=\"rru\" value=\"";
	if ( _address == "" ) {
		buf += _rru;
	} else {
		buf += "/cgi-bin/compose?mailto=1&to=" + _address;
	}
	buf += "\">\r\n";
	buf += "<input type=\"hidden\" name=\"auth\" value=\"";
	buf += _auth;
	buf += "\">\r\n";
	buf += "<input type=\"hidden\" name=\"creds\" value=\"";
	buf += _creds;
	buf += "\">\r\n";
	buf += "<input type=\"hidden\" name=\"svc\" value=\"mail\">";
	buf += "<input type=\"hidden\" name=\"js\" value=\"yes\">";
	buf += "</form>\r\n";
	buf += "</body>\r\n";
	buf += "</html>\r\n";


	QCString cbuf = codec->fromUnicode(buf);
	return cbuf;
}

void IMService::slotSetMSPAuth(QString s1,QString s2,QString s3,QString s4)
{
	_sid = s1;
	_kv = s2;
	_auth = s3;
	_creds = s4;
}

void IMService::slotSetHotMailUrl(QString Url1,QString Url2,QString Url3)
{
	_rru = Url1;
	_actionurl = Url2;
	_id = Url3;
}
