/*
 * kmerlin.s
 * Ccopyright (c) 2003-2004, deitest@hotmail.com, yanmar@ogonigo.com
 * 
 *kmerlin.s is based on  kmerlin ver1.41. olueg@olsd.de
 *                   and ZiciZ ver0.90. aova@hauN.org
 *Fixed by deitest@hotmail.com, yanmar@ogonigo.com 2003-2004
 */
/***************************************************************************
                          imservicesocket.cpp  -  description
                             -------------------
    begin                : Mon Nov 12 2001
    copyright            : (C) 2001 by Olaf Lueg
    email                : olueg@olsd.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/*
 * msnNSConnection.cpp
 *
 * Copyright 2004 aova@hauN.org
 * 
 * This file is part of ZiciZ.
 * 
 * ZiciZ is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * ZiciZ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with ZiciZ; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * ZiciZ is based on Zic ver0.2. 2001 Matthew Stephenson
 */

#include "imservicesocket.h"
#include "imservice.h"
#include "kmd5.h"
#include "config.h"
#include <sys/socket.h>
#include <qtimer.h>
class socket : public QSocket
{
  Q_OBJECT
};
#include <netdb.h>
#include <unistd.h>
#include <sys/types.h>
#include <netinet/in.h>
//#include <openssl/crypto.h>
//#include <openssl/x509.h>
//#include <openssl/pem.h>
#include <openssl/ssl.h>
#include <openssl/err.h>
//#include <openssl/rand.h>
//#include <openssl/e_os.h>

#include<qtopia/qlibrary.h>
//qt
#include <qregexp.h>
#include <qmessagebox.h>

QLibrary *lib1, *lib2;

IMServiceSocket::IMServiceSocket(){
	if (initlibssl() == FALSE) {
		QMessageBox::warning(0,tr("Error"),tr("SSL Library Read Error"));
		SSLsupport = FALSE;
	} else {
		SSLsupport = TRUE;
	}
	Config settings(tr("/home/QtPalmtop/share/kmerlin_menu.conf"), Config::File );
	settings.setGroup("Menu");
	CountryCode = settings.readEntry("CountryCode", tr("0x0409"));
}
IMServiceSocket::~IMServiceSocket(){
	if ( lib1 ) delete lib1;
	if ( lib2 ) delete lib2;
}

void IMServiceSocket::connectToService(QString handle, QString password, uint serial, QString host, QString port)
{
	_handle = handle;
	_password = password;
	_serial = serial;
	isConnected = false;
	mailCount = 0;
	MailEnable = false;
	lastPing = false;
	socket = new QSocket( this );
	connect(socket,SIGNAL(connected()),this,SLOT(slotSocketConnected()));
	connect(socket,SIGNAL(readyRead()),this,SLOT(slotDataReceived()));
	connect(socket,SIGNAL(connectionClosed()),this,SLOT(slotSocketClose()));
	connect(socket,SIGNAL(error(int)),this,SLOT(slotSocketError(int)));
	bool ok;
	socket->connectToHost(host,port.toInt(&ok,10));
}

void IMServiceSocket::close()
{

}

void IMServiceSocket::kill()
{
	lastPing = false;
	emit connected(false);
	isConnected = false;
//	delete socket;
	if (socket->state() == QSocket::Connection ) {
		socket->close();
	}
}

void IMServiceSocket::closeService()
{

	QString command = "OUT\r\n";
	socket->writeBlock(command,command.length());
	kill();
}
void IMServiceSocket::slotSocketConnected()
{
	sendProtocol();
}

void IMServiceSocket::slotSocketClose()
{
//	qDebug("socketclose");
	lastPing = false;
	emit connected(false);
	isConnected = false;
//	delete socket;
}

void IMServiceSocket::slotSocketError(int error)
{
	kill();
	switch(error)
	{
		case 0:
		{
			QMessageBox::warning(0,tr("Error"),tr("Connection refused"));
			break;
		}
		case 1:
		{
			QMessageBox::warning(0,tr("Error"),tr("Host not found"));
			break;
		}
		default:
		{
			QMessageBox::warning(0,tr("Error"),tr("Socket error"));
		}
	}
}

void IMServiceSocket::slotDataReceived()
{
	// incoming data
	QString data;
	char buf[512];
	if(socket->canReadLine())
	{
		socket->readLine(buf, 512);
		data = QString::fromUtf8(buf);
	}
//	showError(data);
	QString command = data.left(3);
//	qDebug(command);
	if(command == "911")
	{
		uint serial = word(data,1).toUInt();
		kill();
		QString errmsg;
		errmsg.sprintf("Authentication failed.(%d)",serial);

		QMessageBox::warning(0,tr("Error"),errmsg);
		return;
	}
	if(command == "601")
	{
		kill();
		QMessageBox::warning(0,tr("Error"),tr("Server is unavailable."));
		return;
	}
	if(command == "910")
	{
		kill();
		QMessageBox::warning(0,tr("Error"),tr("Server too busy."));
		return;
	}
	if(command == "280" || command == "281")
	{
		kill();
		QMessageBox::warning(0,tr("Error"),tr("Sorry!\nThere is a problem with the server."));
		return ;
	}
	if(command == "500")
	{
		kill();
		QMessageBox::warning(0,tr("Error"),tr("Sorry!\nService Temporarily Unavailable."));
		return ;
	}

	parseCommand(data);
	while(socket->canReadLine())
	{
		socket->readLine(buf, 512);
		data = QString::fromUtf8(buf);
		parseCommand(data);
	}
}

void IMServiceSocket::parseCommand(QString str)
{
	QString miss,len; char dat[1024];
	str = str.replace(QRegExp("\r\n"),"");
	QString command = str.left(3);
	if(!isConnected)
	{
		if(command == "XFR")
		{
			// new server reconnect
			newConnect(str);
			return;
		}
	}
	if(command == "VER")
	{
		sendServerPolicy( command);
		return;
	}
	if(command == "CVR")
	{
		sendServerPolicy( command);
		return;
	}
	if(command == "INF")
	{
		sendInitialInfo();
		return;
	}
	if(command == "USR")
	{
		if(word(str,3) == "S")
		{
			QStringList *paramsList,answerList,tempList1,tempList2,tempList3;
			QString answerString="",client_ticket,tempString1="",tempString2="";

			m_authData = word(str, 4);
			paramsList = new QStringList();
			if (HttpsConnect(QString::QString("nexus.passport.com"),QString::QString("/rdr/pprdr.asp"),paramsList,&answerString) != 0)
			{
				QMessageBox::warning(0,tr("Error"),tr("Authentication error"));
				return;
		    }

		    answerList = QStringList::split("\r\n",answerString,true);

		    if ( answerList[0] != "HTTP/1.1 200 OK" ){
			qDebug("Https1Error:" + answerString);
		    }

			tempString1 = ListGet(&answerList,QString::QString("PassportURLs:"));

			if ( tempString1 == "" )
			{
				QMessageBox::warning(0,tr("Error"),tr("Passport error"));
				return;
			}
			tempList1 = QStringList::split(",",tempString1);

			tempString2 = ListGet(&tempList1,QString::QString("DALogin="));

		    if ( tempString2== "" )
		    {
				QMessageBox::warning(0,tr("Error"),tr("Authentication error"));
		    	return;
		    }
		    tempList2 = QStringList::split("=",tempString2);
		    tempList3 = QStringList::split("/",tempList2[1]);
		    answerString = "";
		    tempList1 = QStringList::split("@",_handle);
		    paramsList->append("Authorization: Passport1.4 OrgVerb=GET,OrgURL=http%3A%2F%2Fmessenger%2Emsn%2Ecom,sign-in="+tempList1[0]+"%40"+tempList1[1]+",pwd="+_password+","+m_authData);
		    if (HttpsConnect(tempList3[0],QString::QString("/")+tempList3[1],paramsList,&answerString) != 0 )
		    {
				QMessageBox::warning(0,tr("Error"),tr("Authentication error"));
				return;
		    }
		    answerList=QStringList::split("\r\n",answerString,true);

		    if(answerList[0]== "HTTP/1.1 302 Found")
		    {
				tempString1 = ListGet(&answerList,QString::QString("Location:"));

				if(tempString1== "")
				{
					kill();
					QMessageBox::warning(0,tr("Error"),tr("MSN Nexus server returned invalid redirect information."));
					return;
				}

				tempList1 = QStringList::split( "/" , tempString1);
				answerString = "";
				QString a = tempList1[2];
				QStringList b;
				b = QStringList::split( "?" , a );
				if (HttpsConnect(tempList1[1],QString::QString("/")+b[0],paramsList,&answerString) != 0 ) 
				{
						kill();
						QMessageBox::warning(0,tr("Error"),tr("Authentication error"));
						return;
				}
				answerList = QStringList::split("\r\n",answerString,true);
			}
			if ( answerList[0] != "HTTP/1.1 200 OK" )
			{
				kill();
				QMessageBox::warning(0,tr("Error"),tr("Authentication error"));
				return;
			}

			tempString1 = ListGet(&answerList,QString::QString("Authentication-Info:"));

			if ( tempString1 == "" )
			{
				kill();
				QMessageBox::warning(0,tr("Error"),tr("Authentication error"));
				return;
			}
			tempList1 = QStringList::split("'",tempString1);
			client_ticket = tempList1[1];

			QString command;
			command.sprintf( "USR 3 TWN S " + client_ticket + "\r\n" );
			socket->writeBlock( command, command.length() );

		} else {
			_publicName = word( str, 4 ).replace( QRegExp( "%20" ), " " );
			emit publicNameChanged(word(str,3).utf8(),_publicName.utf8() );
			sendSerial();
			lastPing = true;
			QTimer::singleShot( m_reftimer, this, SLOT( slotPing() ));

		}
		return;
	}
	if ( command == "QNG" ) {
		if(!isConnected)
		{
			isConnected = true;
			emit connected(true);
		}
		lastPing = true;
		return ;
	}
	if(command == "NLN")
	{
		// handle, publicName, status
		emit contactStatusChanged( word(str,2).utf8(), word(str,3).replace(QRegExp("%20")," ").utf8(), word(str,1), word(str,4) );
		return;
	}
	if(command == "FLN")
	{
		emit contactStatusChanged(word(str,1).utf8(), "", "FLN" ,"");
		return;
	}
	if(command == "ILN")
	{
		// handle, publicName, Status
		emit contactStatus(word(str,3).utf8(), word(str,4).replace(QRegExp("%20")," ").utf8(), word(str,2), word(str,5) );
		return;
	}
	if( command == "LSG" )
	{
	    QString group_name;
	    QString group_id;
		if(str.contains(' ') > 4) //FROM LSG
	    {
	        group_name = word(str,6);
	        group_name = group_name.replace( QRegExp( "%20" ), " " );
	        group_id = word(str,7);

	    }
	    else //from SYN
	    {
	        group_name = word(str,2);
	        group_name = group_name.replace( QRegExp( "%20" ), " " );
	        group_id = word(str,1);
	    }
		if ( str.contains( "0 ~ 0" ) )
		{
			emit groupName( QString::QString("Friends"), 0 );
			renameGroup(QString::QString("Friends"),"0");
			return;
		}
		emit groupName( group_name.utf8(), group_id.toUInt() );
		return;
	}


	if(command == "LST")
	{
		emit contactList( word(str,1).utf8(), word(str,2).replace(QRegExp("%20")," ").utf8(), word(str,4), word(str,3) );
		return;
	}
	if(command == "CHL")
	{
		sendFinalAuthentication(word(str,2));
		return;
	}
	if(command == "RNG")
	{
		// SessionID, Address, AuthInfo, handle, publicName
		emit invitedToChat( word(str,1), word(str,2), word(str,4), word(str,5).utf8(), word(str,6).replace(QRegExp("%20")," ").utf8() );
		return;
	}

	if(command == "XFR")
	{
		// Address, AuthInfo
		emit startChat(word(str,3), word(str,5) );
		return;
	}
	if(command == "MSG")
	{
		len = word(str,3);
		socket->readBlock(dat,len.toUInt());
//		miss = dat;
		miss = QString::fromUtf8(dat);
//		miss = miss.left(len.toUInt());
		if(miss.contains("EmailEnabled:")) {
			QString EmailEnabled;
			 EmailEnabled = miss.right(miss.length() - miss.find("EmailEnabled:") );
			 EmailEnabled = EmailEnabled.left(EmailEnabled.find("\r\n"));
			 EmailEnabled = EmailEnabled.right(EmailEnabled.length() -EmailEnabled.find(" ")-1);
			if (EmailEnabled == "1") {
				MailEnable = true;
				ID = time((time_t *)NULL);
				QString command1;
				command1.sprintf("URL %lu INBOX\r\n",ID);
				socket->writeBlock(command1,command1.length());
			} else {
				MailEnable = false;
			}
		}
		if(miss.contains("sid:")) {
			QString _sid;
			QString _kv;
			QString _MSPAuth;
			 _sid = miss.right(miss.length() - miss.find("sid:") );
			 _sid = _sid.left(_sid.find("\r\n"));
			 _sid = _sid.right(_sid.length() -_sid.find(" ")-1);

			 _kv = miss.right(miss.length() - miss.find("kv:") );
			 _kv = _kv.left(_kv.find("\r\n"));
			 _kv = _kv.right(_kv.length() -_kv.find(" ")-1);

			 _MSPAuth = miss.right(miss.length() - miss.find("MSPAuth:") );
			 _MSPAuth = _MSPAuth.left(_MSPAuth.find("\r\n"));
			 _MSPAuth = _MSPAuth.right(_MSPAuth.length() -_MSPAuth.find(" ")-1);

			QString str3 = _MSPAuth + "9" + _password;
			KMD5 context(str3);
			QString _creds = context.hexDigest();

			emit setMSPAuth(_sid,_kv,_MSPAuth,_creds);

		}

		if(miss.contains("Inbox-Unread:"))
		{
			 //this sends the server if we are going online, contains the unread message count
			 miss = miss.right(miss.length() - miss.find("Inbox-Unread:") );
			 miss = miss.left(miss.find("\r\n"));
			 mailCount = miss.right(miss.length() -miss.find(" ")-1).toUInt();
			 qDebug( "Inbox-Unread:%d" , mailCount);
			 emit newMail("",mailCount);
			 return;
		}
		if(miss.contains("Message-Delta:"))
		{
			 //this sends the server if mails are deleted
			 miss = miss.right(miss.length() - miss.find("Message-Delta:") );
			 miss = miss.left(miss.find("\r\n"));
			 mailCount = mailCount - miss.right(miss.length() -miss.find(" ")-1).toUInt();
			 qDebug( "Inbox-Unread:%d" , mailCount);
			 emit newMail("",mailCount);
			 return;
		}
		if(miss.contains("From-Addr:"))
		{
			 //this sends the server if a new mail has arrived
			 miss = miss.right(miss.length() - miss.find("From-Addr:") );
			 miss = miss.left(miss.find("\r\n"));
			 mailCount++;
			 miss = miss.right(miss.length() -miss.find(" ")-1);
			 qDebug( "Inbox-Unread:%d" , mailCount);
			 emit newMail(miss,mailCount);
			 return;
		}
//		qDebug("OtherMSG:" + word(str,1));
		return;

	}
	if(command == "URL")
	{

		 emit setHotMailUrl(word(str,2),word(str,3),word(str,4));
		return;
	}
	if(command == "PRP")
	{
		qDebug("PRP COMMAND:" + word(str,1));
		return;
	}
	if(command == "SYN")
	{
		// this is the current serial on the server, if its different with the own we can get the user list
		uint serial = word(str,2).toUInt();
		if( serial != _serial)
		{
			emit newSerial(serial);  // remove all contacts, msn sends a new contact list
			_serial = serial;
		}
		// set the status to online
		// create an option in config dialog to select the state to be set
		setStatus(NLN,"");
		sendCVR();
		return;
	}

	if( command == "RMG" )
	{
		emit groupRemoved(word(str,2).toUInt(), word(str,3).toUInt() );
	}
	if( command == "REG" )
	{
		_serial =  word(str,2).toUInt();
		// groupName, serial, group
		emit groupRenamed( word(str,4).replace(QRegExp("%20")," "), word(str,2).toUInt(), word(str,3).toUInt() );
		return;
	}
	if( command == "ADG" )
	{

		_serial = word(str,2).toUInt();
		// groupName, serial, group
		emit groupAdded( word(str,3).replace(QRegExp("%20")," "), word(str,2).toUInt(), word(str,4).toUInt() );
		return;
	}
	if(command == "CHG")
	{
		if(!isConnected)
		{
			isConnected = true;
			emit connected(true);
		}
		statusChanged( word(str,2) );

		return;
	}
	if(command == "OUT")
	{

		kill();

		if( word(str,1) == "OTH" )
		{
			QMessageBox::warning(0,tr("Error"),tr("You have connected\r\nfrom an other client"));
		}
		if( word(str,1) == "SSD" )
		{
			QMessageBox::warning(0,tr("Error"),tr("Server shutdown \r\nfor maintainence"));
		}
		return;
	}
	if(command == "REM") // someone is removed from a list
	{
		if( word(str, 2) == "FL")
		{
			// handle, list, serial, group
			contactRemoved( word(str,4).utf8(), word(str,2), word(str,3).toUInt(), word(str,5).toUInt() );
		}
		else
		{
			contactRemoved( word(str,4).utf8(), word(str,2), word(str,3).toUInt(), 0L );
		}
		return;
	}
	if(command == "ADD")
	{
		//
		if( word(str,2) == "FL")
		{
			// handle, publicName, List, serial , group
			emit contactAdded( word(str,4).utf8(), word(str,4).replace(QRegExp("%20")," ").utf8(), word(str,2), word(str,3).toUInt(), word(str,6).toUInt() );
		}
		else
		{
			// handle, publicName, List, serial
			emit contactAdded( word(str,4).utf8(), word(str,4).replace(QRegExp("%20")," ").utf8(), word(str,2), word(str,3).toUInt(), 0L );
		}
		return;
	}
	if(command == "REA")
	{
		_publicName = word( str, 4 ).replace( QRegExp( "%20" ), " " );
		emit publicNameChanged(word(str,3).utf8(),_publicName.utf8() );
		return;
	}

	if(command == "GTC")
	{
		return;
	}
	if(command == "BLP")
	{
		return;
	}
	qDebug("Unsupport command:" + command );
}

void IMServiceSocket::sendCVR()
{

}

void IMServiceSocket::sendFinalAuthentication(QString res)
{
	ID = time((time_t *)NULL);
	res.replace(QRegExp("\r\n"),"");
	QString command;
	QString str3 = res + "Q1P7W2E4J9R8U3S5" ;
	KMD5 context(str3);
	QString str5 = context.hexDigest();
	command.sprintf("QRY %lu msmsgs@msnmsgr.com 32\r\n",ID);
	command += str5 ;
	socket->writeBlock(command,command.length());

//	ID = time((time_t *)NULL);
//	command.sprintf("PRP %lu MOB N\r\n",ID);
//	socket->writeBlock(command,command.length());
	
}

void IMServiceSocket::sendPing()
{
	if ( lastPing == true ) {
		QString command = "PNG \r\n";
		socket->writeBlock(command,command.length());
	}
}
	
void IMServiceSocket::slotPing()
{
		if ( lastPing ) {
			if(!isConnected)
			{
				isConnected = true;
				emit connected(true);
			}
			QTimer::singleShot(m_reftimer, this, SLOT( slotPing()));
			sendPing();
			return;
		}
}
	
// connecting stuff
void IMServiceSocket::sendProtocol()
{
	QString command;
        QString agent = CountryCode + " winnt 5.1 i386 MSNMSGR 6.1.0211 MSMSGS ";
    command.sprintf( "VER 0 MSNP9\r\nCVR 1 "+ agent +" "+ _handle +"\r\nUSR 2 TWN I "+ _handle +"\r\n");
	socket->writeBlock(command,command.length());

}

void IMServiceSocket::newConnect( QString data)
{
	socket->close();
	QString port,server;
	data =  word(data,3);
	port = data.right(data.length() - data.findRev(":") - 1);
	server = data.right(data.length() - data.findRev(" ") - 1);
	server = server.left(server.find(":"));
	socket->connectToHost(server,port.toUInt());

}

void IMServiceSocket::sendServerPolicy( QString cmd )
{

    if( cmd == "VER" )
    {
        QString command;
        QString agent = CountryCode + " winnt 5.1 i386 MSNMSGR 6.1.0211 MSMSGS ";
        command.sprintf( "CVR 1 "+ agent +" "+ _handle +"\r\n" );
    }
    else if ( cmd == "CVR" ) //else if( cmd == "INF" )
    {
            QString command;
            command.sprintf( "USR 2 TWN I "+ _handle +"\r\n" );
        }
        else
        {
    }
}

void IMServiceSocket::sendInitialInfo()
{
	md5_tr = time((time_t *)NULL);
	QString command;
	command.sprintf("USR %lu MD5 I ",md5_tr);
	command += _handle +"\r\n";
	socket->writeBlock(command,command.length());

}

void IMServiceSocket::sendResponseInfo()
{
	if(hashRes.contains("\r\n",true))
	{
	  hashRes = hashRes.left(hashRes.find("\r\n",0,true));
	}
	QString str3 = hashRes +_password;
	KMD5 context(str3);
	QString strcommand1,str5 = context.hexDigest();
	strcommand1.sprintf("USR %lu ",md5_tr);
	strcommand1 += "MD5 S ";
	strcommand1 += str5 + "\r\n";
	socket->writeBlock(strcommand1,strcommand1.length());
}

void IMServiceSocket::sendSerial()
{
	ID = time((time_t *)NULL);
	QString command;

	command.sprintf( "SYN 4 %d",_serial );
	command += "\r\n" ;
	socket->writeBlock( command, command.length() );

}
// end



void IMServiceSocket::addGroup(QString groupName)
{
	groupName.replace(QRegExp(" "),"%20");        // convert whitespaces to %20
	ID = time((time_t *)NULL);
	QString command;
	command.sprintf("ADG %lu ",ID);
	command += groupName.utf8() + " 0\r\n";
	socket->writeBlock(command,command.length());
}

void IMServiceSocket::renameGroup(QString groupName, QString group)
{

	groupName.replace(QRegExp(" "),"%20");        // convert whitespaces to %20
	ID = time((time_t *)NULL);
	QString command;
	command.sprintf( "REG %lu ", ID );
	command += group + " ";
	command += groupName.utf8() + " 0\r\n";
	socket->writeBlock(command,command.length());
}

void IMServiceSocket::removeGroup(uint group)
{
	QString command;
	ID = time((time_t *)NULL);
	command.sprintf("RMG %lu %u\r\n",ID, group);
	socket->writeBlock(command,command.length());
}

void IMServiceSocket::addContact( const QString &handle, QString publicName, uint group, int list )
{
	time_t ID = time((time_t *)NULL);
	QString command;
	QString strGroup;
	strGroup.setNum(group);
	if( list == FL )
	{
		command.sprintf("ADD %lu FL ",ID);
		command += handle.utf8() + " " + publicName.replace(QRegExp(" "),"%20").utf8() + " " +strGroup.utf8() + "\r\n";
	}
	if( list == AL )
	{
		command.sprintf("ADD %lu AL ",ID);
		command += handle.utf8() + " " + publicName.replace(QRegExp(" "),"%20").utf8() + "\r\n";
	}
	if( list == BL )
	{
		command.sprintf("ADD %lu BL ",ID);
		command += handle.utf8() + " " + publicName.replace(QRegExp(" "),"%20").utf8() + "\r\n";
	}
	socket->writeBlock(command,command.length());
}

void IMServiceSocket::removeContact( const QString &handle, uint group, int list )
{
	ID = time((time_t *)NULL);
	QString command;
	QString strGroup;
	strGroup.setNum(group);
	switch(list)
	{
		case FL:
		{
			command.sprintf("REM %lu FL ",ID);
			command += handle + " " +strGroup + "\r\n";
			break;
		}
		case AL:
		{
			command.sprintf("REM %lu AL ",ID);
			command += handle + "\r\n";
			break;
		}
		case BL:
		{
			command.sprintf("REM %lu BL ",ID);
			command += handle + "\r\n";
			break;
		}
	}
	socket->writeBlock(command,command.length());
}

void IMServiceSocket::setMobile( QString Mobile )
{
	m_mobile = Mobile;
}

void IMServiceSocket::setRefTimer( QString RefTimer )
{
	bool ok;
	m_reftimer = RefTimer.toInt(&ok,10);
}

void IMServiceSocket::setStatus( int status ,QString pictureObj)
{
	ID = time((time_t *)NULL);
	QString command;
	switch(status)
	{
		case NLN:
		{
			command.sprintf("CHG %lu NLN ",ID);
			break;
		}
		case BSY:
		{
			command.sprintf("CHG %lu BSY ",ID);
			break;
		}
		case BRB:
		{
			command.sprintf("CHG %lu BRB ",ID);
			break;
		}
		case AWY:
		{
			command.sprintf("CHG %lu AWY ",ID);
			break;
		}
		case PHN:
		{	
			command.sprintf("CHG %lu PHN ",ID);
			break;
		}
		case LUN:
		{
			command.sprintf("CHG %lu LUN ",ID);
			break;
		}
		case FLN:
		{
			command.sprintf("CHG %lu FLN ",ID);
			break;
		}
		case HDN:
		{
			command.sprintf("CHG %lu HDN ",ID);
			break;
		}
		case IDL:
		{
			command.sprintf("CHG %lu IDL ",ID);
			break;
		}
	}

	command.append(m_mobile + "\r\n");

//	command.append(m_mobile + " " + pictureObj + "\r\n");

/*
	if (m_mobile == "1") {
		command.append(tr("65") + "\r\n");
	} else {
		command.append(tr("64") + "\r\n");
	}
*/
/*
	if (m_mobile == "1") {
		command.append("536870949 " + pictureObj + "\r\n");
	} else {
		command.append("536870948 " + pictureObj + "\r\n");
	}

*/
	socket->writeBlock(command,command.length());
}

void IMServiceSocket::SendMail(const QString &handle, QString msg )
{
	QString command;
	QString name;
	name = _publicName.replace(QRegExp(" "),"%20").utf8();
	ID = 0;
	msg = name;
	QString msglen;
	msglen.sprintf("%d",msg.length());
	command = "SDC 1 " + handle + " 0x0411 MSMSGS WindowsMessenger X X ";
	command += name + " " + msglen + "\r\n" + msg;
//	command.sprintf("SDC %lu %s 0x0411 MSMSGS WindowsMessenger X X aaa %d\r\n%s",ID,handle.data(),msg.length(),msg.data());
//	qDebug("SDC:%s",command.data());
	socket->writeBlock(command, command.length());
}
void IMServiceSocket::changeNickName(const QString &handle, QString nick )
{
	QString command;
	ID = 0;
	command.sprintf("REA %lu ",ID);
	command += handle + " " + nick.replace(QRegExp(" "),"%20") + "\r\n";
	socket->writeBlock(command, command.length());
}

void IMServiceSocket::changePublicName(QString publicName )
{
	QString command;
	ID = time(( time_t*)NULL);
	command.sprintf("REA %lu ",ID);
	command += _handle + " " + publicName.replace(QRegExp(" "),"%20") + "\r\n";
	socket->writeBlock(command, command.length());
}

void IMServiceSocket::createChatSession()
{
	ID = time((time_t *)NULL);
	QString command;
	command.sprintf("XFR %lu SB\r\n",ID);
	socket->writeBlock(command,command.length());
}

QString IMServiceSocket::word( const QString &text , uint pos )
{
    QStringList list = QStringList::split( " ", text , true );

    if ( pos < list.count() )
        return list[ pos ];

    return "";
}

QString IMServiceSocket::ListGet(QStringList *list,QString keyword)
{
	QString temp = "";
	int keylen = keyword.length();
	for ( QStringList::Iterator it = list->begin(); it != list->end(); ++it )
	{
		if( (*it).left(keylen) == keyword )
		{
			temp = *it;
			break;
		}
	}
	return temp;
}

void (*_SSL_library_init)();
void (*_SSL_load_error_strings)();
SSL_METHOD * (*_SSLv23_client_method)();
SSL_CTX * (*_SSL_CTX_new)(SSL_METHOD *);
SSL * (*_SSL_new)(SSL_CTX *);
int (*_SSL_shutdown)(SSL *);
void (*_SSL_free)(SSL *);
void (*_SSL_CTX_free)(SSL_CTX *);
int (*_SSL_connect)(SSL *);
int (*_SSL_read)(SSL *, void *, int);
int (*_SSL_write)(SSL *, const void *, int);
long (*_SSL_CTX_ctrl)(SSL_CTX *, int, long, void *);
int (*_SSL_set_fd)(SSL *, int);

void (*_RAND_seed)(const void *, int);


bool loadSymbols()
{
	void *p;
	p = lib1->resolve("SSL_library_init"); if(!p) return FALSE; else _SSL_library_init = (void(*)())p;
	p = lib1->resolve("SSL_load_error_strings"); if(!p) return FALSE; else _SSL_load_error_strings = (void(*)())p;
	p = lib1->resolve("SSLv23_client_method"); if(!p) return FALSE; else _SSLv23_client_method = (SSL_METHOD *(*)())p;
	p = lib1->resolve("SSL_CTX_new"); if(!p) return FALSE; else _SSL_CTX_new = (SSL_CTX *(*)(SSL_METHOD *))p;
	p = lib1->resolve("SSL_new"); if(!p) return FALSE; else _SSL_new = (SSL *(*)(SSL_CTX *))p;
	p = lib1->resolve("SSL_shutdown"); if(!p) return FALSE; else _SSL_shutdown = (int(*)(SSL *))p;
	p = lib1->resolve("SSL_free"); if(!p) return FALSE; else _SSL_free = (void(*)(SSL *))p;
	p = lib1->resolve("SSL_CTX_free"); if(!p) return FALSE; else _SSL_CTX_free = (void(*)(SSL_CTX *))p;
	p = lib1->resolve("SSL_connect"); if(!p) return FALSE; else _SSL_connect = (int(*)(SSL *))p;
	p = lib1->resolve("SSL_read"); if(!p) return FALSE; else _SSL_read = (int(*)(SSL *, void *, int))p;
	p = lib1->resolve("SSL_write"); if(!p) return FALSE; else _SSL_write = (int(*)(SSL *, const void *, int))p;
	p = lib1->resolve("SSL_CTX_ctrl"); if(!p) return FALSE; else _SSL_CTX_ctrl = (long(*)(SSL_CTX *, int, long, void *))p;
	p = lib1->resolve("SSL_set_fd"); if(!p) return FALSE; else _SSL_set_fd = (int(*)(SSL *, int))p;

	p = lib2->resolve("RAND_seed"); if(!p) return FALSE; else _RAND_seed = (void(*)(const void *, int))p;

	return TRUE;
}

bool initlibssl()
{
	lib1 = 0;
	lib2 = 0;

	lib1 = new QLibrary("libssl.so");
	if(!lib1->load()) {
		delete lib1;
		lib1 = 0;
		qDebug("libssl.so not found");
		return FALSE;
	}

	lib2 = new QLibrary("libcrypto.so");
	if(!lib2->load()) {
		delete lib1;
		delete lib2;
		lib1 = 0;
		lib2 = 0;
		qDebug("libcrypto.so not found");
		return FALSE;
	}

	if(!loadSymbols()) {
		delete lib1;
		if(lib2)
			delete lib2;
		lib1 = 0;
		lib2 = 0;
		qDebug("ssl symbol not found");
		return FALSE;
	}

	return TRUE;
}

int HttpsConnect(QString hostname,QString get,QStringList *params,QString *answers)
{
	int err, port = 443;
	int sock;
	SSL_CTX *ctx;
	SSL *ssl;
	struct hostent *serverhost; 
	struct sockaddr_in server;
	char buf[1024];

	const char  *seed = "LaYnIoM9YpN6AkPkYjImPaNyJuKoVPnAoPmBuAoBal9H4Iz";
	_RAND_seed(seed, strlen(seed));

//SSL initialize
	_SSL_library_init(); 
//	SSLeay_add_ssl_algorithms();
	_SSL_load_error_strings();
	ctx = _SSL_CTX_new(_SSLv23_client_method());
//	SSL_CTX_set_mode(ctx, SSL_MODE_AUTO_RETRY);
	_SSL_CTX_ctrl((ctx),SSL_CTRL_MODE,(SSL_MODE_AUTO_RETRY),NULL);

	serverhost = gethostbyname(hostname);
	if ( serverhost == NULL )
	{
		qDebug("Https:gethostbyname Error");
		return -1;
	}
	bzero((char *)&server, sizeof(server));
	server.sin_family = AF_INET;
	bcopy(serverhost->h_addr, (char *)&server.sin_addr, serverhost->h_length);
	server.sin_port = htons(port);

	sock = socket(PF_INET, SOCK_STREAM, 0); 
	if ( sock < 0 )
	{
		qDebug("Https:socket Error");
		return -1;
	}
	if ( connect(sock, (struct sockaddr*) &server, (socklen_t)(sizeof(server))) == -1 )
	{
		qDebug("Https:connect Error");
		return -1;
	}
//connect
	ssl = _SSL_new(ctx);
	_SSL_set_fd(ssl, sock);
	err = _SSL_connect(ssl);
	if ( err < 0 )
	{
		qDebug("Https:SSL_connect Error");
		return -1;
	}
  //send
	sprintf(buf,"GET %s HTTP/1.0\r\n",get.latin1());
	err = _SSL_write(ssl, buf, strlen(buf));

	if ( err < 0 )
	{
		qDebug("Https:SSL_write Error");
		return -1;
	}

	for ( QStringList::Iterator it = params->begin(); it != params->end(); ++it )
	{
		err = _SSL_write(ssl, ((*it)+"\r\n").latin1(), strlen((*it).latin1() + 2 ));
		if ( err < 0 )
		{
			qDebug("Https:SSL_write Error");
			return -1;
		}
	}

	sprintf(buf,"Host: %s\r\n\r\n",hostname.latin1());
	err = _SSL_write(ssl, buf, strlen(buf));
	if ( err < 0 )
	{
		qDebug("Https:SSL_write Error");
		return -1;
	}

//read
	while (1)
	{
		int read_size;
		read_size = _SSL_read(ssl, buf, sizeof(buf)-1);
		buf[read_size] = '\0';
		if ( read_size == 0 ){
			break;
		}
		answers->append(QString::QString(buf));
	}

//close
	_SSL_shutdown(ssl);
	close(sock);
	_SSL_free(ssl);
	_SSL_CTX_free(ctx);
	return 0;
}

