/*
 * kmerlin.s
 * Ccopyright (c) 2003-2004, deitest@hotmail.com, yanmar@ogonigo.com
 * 
 *kmerlin.s is based on  kmerlin ver1.41. olueg@olsd.de
 *Fixed by deitest@hotmail.com, yanmar@ogonigo.com 2003-2004
 */
/***************************************************************************
                          imservicesocket.h  -  description
                             -------------------
    begin                : Mon Nov 12 2001
    copyright            : (C) 2001 by Olaf Lueg
    email                : olueg@olsd.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef IMSERVICESOCKET_H
#define IMSERVICESOCKET_H

#include <qobject.h>
#include <qbuffer.h>


// qt
#include <qsocket.h>
// other
#include <time.h>
/**
  *@author Olaf Lueg
  */

class IMServiceSocket : public QObject
{
Q_OBJECT
public: 
	IMServiceSocket();
	~IMServiceSocket();
	QString _publicName;
	bool SSLsupport;
	bool MailEnable;
protected:
	uint _serial;
	uint mailCount;
	QString _handle;
	QString _password;
	QString hashRes;
	time_t ID;
	time_t md5_tr;
	QSocket *socket;
	bool isConnected;

	QString m_sid, m_kv;

    QString m_account;
    QString m_password;
    QString m_badPassword;
    QString m_loginTime;
    QString m_authData;
	QString m_mobile;
	int m_reftimer;
	bool lastPing;
	QString CountryCode;

protected slots:
	void slotDataReceived();
	void slotSocketError(int error);
	void slotSocketClose();
	void slotSocketConnected();
	void slotPing();
//	void slotAuthJobDone ( bool );
//	void slotAuthJobChanged ( int );
//	void slotAuthJobReq ( int,bool );
//	void slotAuthJobDataReceived(const QHttpResponseHeader& resp );
protected:
	void sendProtocol();
	void newConnect( QString data);
    void sendServerPolicy( QString cmd );
	void sendInitialInfo();
	void sendResponseInfo();
	void sendSerial();
	void sendCVR();
	void sendFinalAuthentication(QString res);
	
	void parseCommand( QString str);
	QString word( const QString &text , uint pos );
	QString ListGet(QStringList *list,QString keyword);

	void sendPing();
	
public:
	void connectToService( QString handle, QString password, uint serial, QString host, QString port);
	void close();
	void kill();
	void closeService();
	
	void setMobile( QString Mobile );
	void setRefTimer( QString RefTimer );
	void setStatus( int status ,QString pictureObj);
	void addContact( const QString &handle, QString pulicName, uint group , int list );
	void removeContact( const QString &handle, uint group, int list );
	
	void addGroup( QString groupName );
	void removeGroup( uint group );
	void renameGroup(QString groupName, QString group);
	
	void SendMail(const QString &handle, QString msg );
	void changeNickName(const QString &handle, QString Nick );
	void changePublicName(QString publicName );
	QString getPublicName() { return _publicName;}
	
	void createChatSession();
signals:
	void newMail(QString, uint);
	void contactList(QString, QString, QString, QString);
	void contactList(QString, QString, uint);
	void contactStatusChanged( QString, QString, QString, QString );
	void contactStatus(QString, QString, QString,QString );
	void contactAdded(QString, QString, QString, uint, uint);
	void contactRemoved(QString, QString, uint, uint);
	void contactOffline(QString);
	
	void groupName(QString, uint);
	void groupAdded( QString, uint, uint);
	void groupRenamed( QString, uint, uint);
	void groupRemoved( uint, uint);
	
	void sessionClosed( QString);
	void connected( bool);
	
	void invitedToChat(QString, QString, QString, QString, QString );
	void startChat( QString, QString );
	
	void newPublicName(QString);
	void publicNameChanged( QString, QString );
	void newSerial( uint );
	void statusChanged( QString );
	void setMSPAuth(QString,QString,QString,QString);
	void setHotMailUrl(QString,QString,QString);
	
};
	bool loadSymbols();
	bool initlibssl();
	int HttpsConnect(QString host,QString get,QStringList *params,QString *answers);
#endif
