/*
 * kmerlin.s
 * Ccopyright (c) 2003-2004, deitest@hotmail.com, yanmar@ogonigo.com
 * 
 *kmerlin.s is based on  kmerlin ver1.41. olueg@olsd.de
 *Fixed by deitest@hotmail.com, yanmar@ogonigo.com 2003-2004
 */
/***************************************************************************
                          kmerlin.cpp  -  description
                             -------------------
    begin                : Sam Dez  8 15:23:00 CET 2001
    copyright            : (C) 2001 by Olaf Lueg
    email                : olueg@olsd.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#include <qaccel.h>
#include <qmessagebox.h>
#include <qlabel.h>
#include <qpe/qcopenvelope_qws.h>


#include "kmerlin.h"
#include "imservice.h"
#include "imchatservice.h"
#include "onlineview.h"
#include "mylistview.h"
//#include "imservice.h"
#include "chatwindow.h"
#include "chatviewimpl.h"
#include "logviewimpl.h"
#include "kmsMultiLineEdit.h"
#include "inputdlg.h"
#include "setting.h"
#include "newuserimpl.h"
#include <qpe/resource.h>

#include "sha1.h"

#include "config.h"
#include "sharpled.h"
#include "HQPppEnv.h"

#include <qpe/qpetoolbar.h>
#include <qpe/qpemenubar.h>
#include <qpe/global.h>
#include <qdir.h>
#include <qfontdatabase.h>
#include <qstringlist.h>
#include <qcombobox.h>
#include <qtabwidget.h>
#include <qcheckbox.h>
#include <qpushbutton.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <qdir.h>
#include <qtextcodec.h>

KMerlinApp::KMerlinApp(QString ap)
{
    ConfigName = ap;
    appName = tr("KMerlin.s");
    setCaption(appName);

  ///////////////////////////////////////////////////////////////////
  // call inits to invoke all other construction parts
  imService = new IMService();
  imService->theApp = this;

	hqPppEnv = new HQPppEnv(ConfigName,"PPP",this);

  initActions();
  initMenuBar();
  workTimer = 0L;
  refreshTimer = 0L;
  bool ok;
//  initDoc();
	Config settings(ConfigName, Config::User );
	settings.setGroup("Base");
	layout = settings.readEntry("Layout", "0");
	_tabFontSize = settings.readEntry("TabFontSize", "12");
  initView();

	connect(imService,SIGNAL(startChat(IMChatService*,QString)),this,SLOT(slotOpenChatWindow(IMChatService*,QString)));
//	// new protocoll
	connect(imService, SIGNAL( connectedToService(bool)), this, SLOT(slotConnected(bool)));
	connect(imService, SIGNAL( connectedToService(bool)), view, SLOT(slotConnected(bool )));

	connect(imService, SIGNAL( updateContact(QString, uint, uint)), view, SLOT(slotUpdateContact(QString, uint, uint)));
	connect(imService, SIGNAL( updateContact(QString, uint, uint)), this, SLOT(slotShowNotifier(QString, uint, uint)));

	connect(imService, SIGNAL( newMail(QString, uint)), view, SLOT(slotUpdateMail(QString, uint)));
	connect(imService, SIGNAL( newMail(QString, uint)), this, SLOT(slotMailNotifier(QString, uint)));

	connect(imService, SIGNAL( contactAdded(QString, QString, QString )), view, SLOT(slotContactAdded(QString, QString, QString)));
	connect(imService, SIGNAL( contactRemoved(QString, QString)), view, SLOT(slotContactRemoved(QString, QString)));

	connect(view, SIGNAL( chatToUser(QString)), imService, SLOT( slotStartChatSession( QString)));

	connect(imService, SIGNAL( statusChanged( uint )), this, SLOT(slotStatusChanged( uint )));
	connect(imService, SIGNAL( newContact( QString )), this, SLOT(slotAuthContact( QString )));

	connect(imService, SIGNAL( groupRenamed( QString, QString)), view, SLOT(slotUpdateGroup( QString, QString)));
	connect(imService, SIGNAL( groupAdded( QString )), view, SLOT(slotInsertGroup( QString)));
	connect(imService, SIGNAL( groupRemoved( QString )), view, SLOT(slotRemoveGroup( QString )));

	connect(imService, SIGNAL( publicNameChanged(QString)), this, SLOT(slotPublicNameChanged(QString )));
	connect(view, SIGNAL( keyPress(QKeyEvent *)), this, SLOT(keypressed(QKeyEvent *)) );
	connect(view, SIGNAL( setMainCaption(QString)), this, SLOT(slotSetMainCaption(QString)) );

	currentStatus = FLN;
	connected = false;
	netConnected = false;
	fileConnect->setEnabled(true);
	fileDisconnect->setEnabled(false);
	contactMenu->setEnabled(false);
	groupMenu->setEnabled(false);
	statusMenu->setEnabled(false);
	view->setOnlineLabelText(tr("Offline"));
/*
	Config settings(ConfigName, Config::User );
	settings.setGroup("Base");
*/
	_handle = settings.readEntry("Handle", "" );
	_passWd = settings.readEntry("Password", "");
	_hostAddr = settings.readEntry("HostAddress", "messenger.hotmail.com");
	_tcpPort = settings.readEntry("Port", "1863");
	_refTime  = settings.readEntry("RefreshTime", "20000");
	_fontName = settings.readEntry("FontName", "lcfont");
	_fontSize = settings.readEntry("FontSize", "2");
	_fontCol1 = settings.readEntry("FontCol1", "#003366");
	_fontCol2 = settings.readEntry("FontCol2", "#003366");
	_fontCol3 = settings.readEntry("FontCol3", "#000000");
	_fontCol4 = settings.readEntry("FontCol4", "#000000");
	_autoWidth = settings.readEntry("AutoWidth", "1");
	_msgWidth = settings.readEntry("MessageTabWidth", "420");
	_marginH = settings.readEntry("MarginH", "5");
	_marginV = settings.readEntry("MarginV", "40");
	_maxComment = settings.readEntry("MaxComment", "10");

	_logPath = settings.readEntry("LogPath", (QString(getenv("HOME")) + "/Documents"));
	_downPath = settings.readEntry("DownloadPath", (QString(getenv("HOME")) + "/Documents"));
	_logFontSize = settings.readEntry("LogFontSize", "16");
	_sndEnable = settings.readEntry("SoundEnable", "1");
	_ledMode = settings.readEntry("LedMode", "normblink");
	_Mobile = settings.readEntry("Mobile", "0");
	_infoFontSize = settings.readEntry("InfoFontSize", "12");
	_menuBtnFontSize = settings.readEntry("MenuBtnFontSize", "10");
	_sendFontSize = settings.readEntry("SendFontSize", "16");
	_Recvmsg = settings.readEntry("ReceiveMessage", "Another");
	_RecvmsgText = settings.readEntry("ReceiveMessageText", "You received the last message  at :%1");
	_RecvdmsgText = settings.readEntry("ReceivedMessageText", "Your last message was received at :%1");
	_UnRecvdmsgText = settings.readEntry("UnReceivedMessageText", "Your last message was not received :%1");
	_WritesmsgText = settings.readEntry("WritesMessageText", "%1,  writes a message");
	_WaitmsgText = settings.readEntry("WaitMessageText", "Please wait....");
	_SayText = settings.readEntry("SayText", "%1 Says");
	_DispRecvtime = settings.readEntry("DispReceiveTime", "Full Format");
	_MsgRecvtime = settings.readEntry("MessageReceiveTime", "None");
	_logging = settings.readEntry("Logging", "1");
	_AutoConnectMode = settings.readEntry("AutoConnectMode", "No");
	_DisconnectMode = settings.readEntry("DisconnectMode", "No");
	_ConnectRequest = settings.readEntry("ConnectRequest", "1");

	_MyText[0] = settings.readEntry("MyText0", "");
	_MyText[1] = settings.readEntry("MyText1", "");
	_MyText[2] = settings.readEntry("MyText2", "");
	_MyText[3] = settings.readEntry("MyText3", "");
	_MyText[4] = settings.readEntry("MyText4", "");
	_MyText[5] = settings.readEntry("MyText5", "");
	_MyText[6] = settings.readEntry("MyText6", "");
	_MyText[7] = settings.readEntry("MyText7", "");
	_MyText[8] = settings.readEntry("MyText8", "");
	_MyText[9] = settings.readEntry("MyText9", "");
	_MyText[10] = settings.readEntry("MyText10", "");
	_MyText[11] = settings.readEntry("MyText11", "");
	_MyText[12] = settings.readEntry("MyText12", "");
	_MyText[13] = settings.readEntry("MyText13", "");
	_MyText[14] = settings.readEntry("MyText14", "");
	_MyText[15] = settings.readEntry("MyText15", "");

	_OfflineVisible = settings.readEntry("OfflineVisible", "1");
	_BlockedVisible = settings.readEntry("BlockedVisible", "1");
	_MailNoticeEnable = settings.readEntry("MailNoticeEnable", "0");

	_MailAp = settings.readEntry("MailAp", "qtmail");
	_BrowserAp = settings.readEntry("BrowserAp", "netfront3");
	_ServerStatusUrl = settings.readEntry("ServerStatusUrl", "http://messenger.msn.com/Status.aspx");
	_ProfileUrl = settings.readEntry("ProfileUrl", "http://members.msn.com/default.msnw?mem=");

	resetPictureObject(false);
	imService->setRefTimer(_refTime);
	imService->setMobile(_Mobile);

	soundEnable = true;
	if(_sndEnable == "0") { soundEnable = false; }

    view->setWidth(_autoWidth,_msgWidth,layout);
//	refreshTimer = startTimer(_refTime.toInt(&ok,10));
//    if(!ok){refreshTimer = startTimer(20000);}

	maxComment = _maxComment.toInt(&ok,10);
	if(!ok){maxComment = 10;}

	ledOff();
	if (_AutoConnectMode == "Yes") {
		slotFileConnect();
	}
}

KMerlinApp::~KMerlinApp()
{
	ledOff();
}

void KMerlinApp::timerEvent(QTimerEvent *ev)
{
	if(ev->timerId() == workTimer)
	{
		imService->cancelConnect();
		killTimer(workTimer);
		workTimer = 0L;
	}
	return;
	if(ev->timerId() == refreshTimer && connected){
		int rer = 0;

		if(currentStatus == NLN){
			imService->changeStatus(NLN,m_pictureObj);rer++;
		}
		if(currentStatus == BSY){
			imService->changeStatus(BSY,m_pictureObj);rer++;
		}
		if(currentStatus == BRB){
			imService->changeStatus(BRB,m_pictureObj);rer++;
		}
		if(currentStatus == AWY){
			imService->changeStatus(AWY,m_pictureObj);rer++;
		}
		if(currentStatus == PHN){
			imService->changeStatus(PHN,m_pictureObj);rer++;
		}
		if(currentStatus == LUN){
			imService->changeStatus(LUN,m_pictureObj);rer++;
		}
		if(currentStatus == HDN){
			imService->changeStatus(HDN,m_pictureObj);rer++;
		}
		if(rer == 0) {
			imService->changeStatus(NLN,m_pictureObj);rer++;
		}
		rer = 0;
	}
}

/** initializes all QActions of the application */
void KMerlinApp::initActions(){

	Config settings(tr("/home/QtPalmtop/share/kmerlin_menu.conf"), Config::File );
	settings.setGroup("Menu");
	QString MenuData;
	MenuData = settings.readEntry("Connect", tr("Connect"));
	fileConnect = new QAction(tr("Connect"),Resource::loadPixmap("/kmerlin/connect.png"), MenuData, 0, this);
	fileConnect->setStatusTip(tr("Connect to MSN Service"));
	connect(fileConnect, SIGNAL(activated()), this, SLOT(slotFileConnect()));

	MenuData = settings.readEntry("Disconnect", tr("Disconnect"));
	fileDisconnect = new QAction(tr("Disconnect"),Resource::loadPixmap("/kmerlin/connect_no.png"),  MenuData, 0, this);
	fileDisconnect->setStatusTip(tr("Disconnecting from MSN ServiceOpens an existing document"));
	connect(fileDisconnect, SIGNAL(activated()), this, SLOT(slotFileDisconnect()));

	MenuData = settings.readEntry("Cancel", tr("Cancel"));
	fileCancel = new QAction(tr("Cancel"),Resource::loadPixmap("/kmerlin/stop.png"), MenuData, 0, this);
	connect(fileCancel, SIGNAL(activated()), this, SLOT(slotFileCancel()));

	MenuData = settings.readEntry("Settings", tr("Settings..."));
	viewSettings = new QAction(tr("Settings"), MenuData, 0, this);
	viewSettings->setStatusTip(tr("Settings..."));
	connect(viewSettings, SIGNAL(activated()), this, SLOT(slotViewSettings()));

	MenuData = settings.readEntry("LayoutChange", tr("Layout Change"));
	fileLayout = new QAction(tr("Layout Change"), MenuData, 0, this);
	fileLayout->setStatusTip(tr("Layout Change"));
	connect(fileLayout, SIGNAL(activated()), this, SLOT(slotFileLayout()));

	MenuData = settings.readEntry("ServiceStatus", tr("Service Status"));
	fileService = new QAction(tr("Service Status"), MenuData, 0, this);
	fileService->setStatusTip(tr("Service Status"));
	connect(fileService, SIGNAL(activated()), this, SLOT(slotFileService()));

	MenuData = settings.readEntry("About", tr("&About..."));
	helpAboutApp = new QAction(tr("About"), MenuData, 0, this);
	helpAboutApp->setStatusTip(tr("About the application"));
	helpAboutApp->setWhatsThis(tr("About\n\nAbout the application"));
	connect(helpAboutApp, SIGNAL(activated()), this, SLOT(slotHelpAbout()));

	MenuData = settings.readEntry("RenameGroup", tr("Rename Group"));
	groupRename = new QAction(tr("Rename Group"),  MenuData, 0, this);
	groupRename->setStatusTip(tr("Rename the selected Group"));
	connect(groupRename, SIGNAL(activated()), this, SLOT(slotRenameGroup()));

	MenuData = settings.readEntry("DeleteGroup", tr("Delete Group"));
	groupDelete = new QAction(tr("Delete Group"),  MenuData, 0, this);
	groupDelete->setStatusTip(tr("Delete the selected Group"));
	connect(groupDelete, SIGNAL(activated()), this, SLOT(slotDeleteGroup()));

	MenuData = settings.readEntry("AddGroup", tr("Add Group"));
	groupAdd = new QAction(tr("Add Group"),  MenuData, 0, this);
	groupAdd->setStatusTip(tr("Add a new Group"));
	connect(groupAdd, SIGNAL(activated()), this, SLOT(slotAddGroup()));

	MenuData = settings.readEntry("AddContact", tr("Add Contact"));
	contactAdd = new QAction(tr("Add Contact"),  MenuData, 0, this);
	contactAdd->setStatusTip(tr("Add a new Contact"));
	connect(contactAdd, SIGNAL(activated()), this, SLOT(slotContactAdd()));

	MenuData = settings.readEntry("BlockContact", tr("Block Contact"));
	contactBlock = new QAction(tr("Block Contact"),  MenuData, 0, this);
	contactBlock->setStatusTip(tr("Block the selected Contact"));
	connect(contactBlock, SIGNAL(activated()), this, SLOT(slotContactBlock()));

	MenuData = settings.readEntry("AllowContact", tr("Allow Contact"));
	contactAllow = new QAction(tr("Allow Contact"),  MenuData, 0, this);
	contactAllow->setStatusTip(tr("Remove the selected Contact from blocked list"));
	connect(contactAllow, SIGNAL(activated()), this, SLOT(slotContactAllow()));

	MenuData = settings.readEntry("RemoveContact", tr("Remove Contact"));
	contactRemove = new QAction(tr("Remove Contact"),  MenuData, 0, this);
	contactRemove->setStatusTip(tr("Remove the selected Contact from group"));
	connect(contactRemove, SIGNAL(activated()), this, SLOT(slotContactRemove()));

	MenuData = settings.readEntry("DeleteContact", tr("Delete Contact"));
	contactDelete = new QAction(tr("Delete Contact"),  MenuData, 0, this);
	contactDelete->setStatusTip(tr("Delete the selected Contact"));
	connect(contactDelete, SIGNAL(activated()), this, SLOT(slotContactDelete()));

	MenuData = settings.readEntry("SendMessage", tr("Send Message"));
	fileChat = new QAction(tr("Send Message"),  MenuData, 0, this);
	connect(fileChat, SIGNAL(activated()), this, SLOT(slotContactChat()));

	MenuData = settings.readEntry("SendMail", tr("Send Mail"));
	fileMail = new QAction(tr("Send Mail"),  MenuData, 0, this);
	connect(fileMail, SIGNAL(activated()), this, SLOT(slotContactMail()));

	MenuData = settings.readEntry("ShowProfile", tr("Show Profile"));
	fileProfile = new QAction(tr("Show Profile"),  MenuData, 0, this);
	connect(fileProfile, SIGNAL(activated()), this, SLOT(slotContactProfile()));

	_StatusText[NLN] = settings.readEntry("Online", tr("Online"));
	_StatusText[BSY] = settings.readEntry("Busy", tr("Busy"));
	_StatusText[BRB] = settings.readEntry("Berightback", tr("Be right back"));
	_StatusText[AWY] = settings.readEntry("AwayfromComputer", tr("Away"));
	_StatusText[PHN] = settings.readEntry("Onthephone", tr("On the phone"));
	_StatusText[LUN] = settings.readEntry("Outtolunch", tr("Out to lunch"));
	_StatusText[HDN] = settings.readEntry("Invisible", tr("Invisible"));
	_StatusText[IDL] = settings.readEntry("Idle", tr("Away*"));
	_StatusText[BLO] = settings.readEntry("Blocked", tr("Blocked"));

}

void KMerlinApp::slotMailNotifier( QString message, uint count )
{
	if (_MailNoticeEnable == "1") {
		if (message != "") {
			QString msg;
			msg = "Received mail form " + message;
			Global::statusMessage(msg);
			ledBlink();
		} else {
			ledOff();
		}
	}
}
void KMerlinApp::slotShowNotifier(QString handle, uint status, uint oldstatus)
{
	QString msg;
	if( status == oldstatus ) return;

	if (_BlockedVisible == "0") {
		if(imService->isBlocked(handle) ) {
			return;
		}
	}
	if( status == NLN )
	{
		msg = imService->getPublicName(handle) + tr(" is: ") + tr("Online") ;
		Global::statusMessage(msg);
	}
	if( status == FLN )
	{
		msg = imService->getPublicName(handle) + tr(" is: ") + tr("Offline") ;
		Global::statusMessage(msg);
	}
}	

void KMerlinApp::slotContactChat()
{
	const QString handle = view->getHandle();
	if(handle != 0L)
	{
		if(imService->isAvailable(handle) )
		{
			imService->slotStartChatSession( handle );
		}
	}
}

void KMerlinApp::slotContactMail()
{
	const QString handle = view->getHandle();
	if(handle != 0L)
	{
		if(imService->getMailEnable() == false)
		{
			qCopSend("QPE/System", "execute(QString,QString)",_MailAp,handle);
//		imService->contactSendMail( handle );
		} else {
			OpenHotMail(handle);
		}
	}
}

void KMerlinApp::slotContactProfile()
{
	const QString handle = view->getHandle();
	QString Url;
	Url = _ProfileUrl + handle;
	if(handle != 0L)
	{
		qCopSend("QPE/System", "execute(QString,QString)",_BrowserAp,Url);
	}
}

void KMerlinApp::slotContactBlock()
{
	if(view->getHandle() != 0L)
	imService->contactBlock( view->getHandle() );
}

void KMerlinApp::slotContactAllow()
{
	if(view->getHandle() != 0L)
	imService->contactUnBlock( view->getHandle() );
}

void KMerlinApp::slotContactRemove()
{
		if(view->getHandle() != 0L)
	{
		QString curGroup = view->getGroup();
		imService->contactRemove( view->getHandle(), curGroup );
	}

}

void KMerlinApp::slotContactMove()
{
	QString curGroup = view->getParent();
	QStringList list = imService->getGroups();
	contactMove->clear();
	if( curGroup == 0L ) return;
	for ( QStringList::Iterator it = list.begin(); it != list.end(); ++it )
	{
//		if((*it).latin1() != curGroup )
		if(QString::fromLocal8Bit((*it)) != curGroup )
		{
			contactMove->insertItem(QString::fromLocal8Bit((*it)) );
		}
	}
}

void KMerlinApp::slotContactMyText()
{
	contactMyText->clear();
	int i;
	for ( i = 0; i < 16; i++ )
	{
		if(_MyText[i] != "")
		{
			contactMyText->insertItem(_MyText[i]);
		}
	}
}

void KMerlinApp::slotContactMove(int i)
{
  imService->contactMove( view->getHandle(), view->getGroup(), contactMove->text(i) );
}

void KMerlinApp::slotContactMyText(int i)
{
	if(!widgetList.isEmpty()){
		ChatWindow *chatWindow;
		for( chatWindow = widgetList.first(); chatWindow != 0; chatWindow = widgetList.next() )
		{
                    if(chatWindow == view->TabView->currentPage()){
			int line, col;
			chatWindow->view->strSend->getCursorPosition(&line, &col);
			chatWindow->view->strSend->insertAt(contactMyText->text(i), line, col, false);
			chatWindow->view->SendButton->setEnabled(true);
			chatWindow->view->textChanged = true;
			return;
                    }
		}
	}
}

void KMerlinApp::slotContactCopy()
{
	QString curGroup = view->getParent();
	QStringList list = imService->getGroups();
	contactCopy->clear();
	if( curGroup == 0L ) return;
	for ( QStringList::Iterator it = list.begin(); it != list.end(); ++it )
	{
		if(QString::fromLocal8Bit((*it)) != curGroup )
		{
			contactCopy->insertItem(QString::fromLocal8Bit((*it)) );
		}
	}
}

void KMerlinApp::slotContactCopy(int i )
{
  imService->contactCopy( view->getHandle(), contactCopy->text(i) );

}


void KMerlinApp::slotContactDelete()
{
	if(view->getHandle() != 0L)
	imService->contactDelete(view->getHandle() );
}


void KMerlinApp::slotRenameGroup()
{
	bool ok = FALSE;
	InputDlg dlg(0,"KMerlin",true);
	dlg.strInfo->setText(tr("<b>Enter the new Group name</b>"));
	ok = dlg.exec();
	if ( ok && !dlg.strText->text().isEmpty() )
	{
		// user entered something and pressed ok
		imService->groupRename( view->getGroup(), dlg.strText->text() );
	}
	else
	{
		// user entered nothing or pressed cancel
	}

}

void KMerlinApp::slotDeleteGroup()
{
	if( view->isEmpty()  )
	{
		imService->groupDelete( view->getGroup() );
	}
	else
	{
		QMessageBox::warning(0,tr("Error"),tr("Group not Empty!"));
	}

}

void KMerlinApp::slotAddGroup()
{
	imService->groupAdd( );
}


void KMerlinApp::initMenuBar()
{
  ///////////////////////////////////////////////////////////////////
  // MENUBAR

  ///////////////////////////////////////////////////////////////////
  // menuBar entry fileMenu
  fileMenu=new QPopupMenu();
  fileConnect->addTo(fileMenu);
  fileDisconnect->addTo(fileMenu);
  fileMenu->insertSeparator();
  fileChat->addTo(fileMenu);
  fileMail->addTo(fileMenu);
  fileProfile->addTo(fileMenu);
  fileMenu->insertSeparator();
  viewSettings->addTo(fileMenu);
  fileMenu->insertSeparator();
  fileLayout->addTo(fileMenu);
  fileMenu->insertSeparator();
  fileService->addTo(fileMenu);
//  fileMenu->insertSeparator();
//	helpAboutApp->addTo(fileMenu);

  contactMenu = new QPopupMenu();
  contactAdd->addTo(contactMenu);
	contactRemove->addTo(contactMenu);
  contactMenu->insertSeparator();
	contactBlock->addTo(contactMenu);
  contactAllow->addTo(contactMenu);
  contactMenu->insertSeparator();
  //contactDelete->addTo(contactMenu);

	Config settings(tr("/home/QtPalmtop/share/kmerlin_menu.conf"), Config::File );
	settings.setGroup("Menu");
	QString MenuData;

	contactMove = new QPopupMenu();
	MenuData = settings.readEntry("MoveContact", tr("Move Contact"));
	contactMenu->insertItem(MenuData,contactMove);
	contactCopy = new QPopupMenu();
	MenuData = settings.readEntry("CopyContact", tr("Copy Contact"));
	contactMenu->insertItem(MenuData,contactCopy);
	contactMenu->insertSeparator();


	groupMenu = new QPopupMenu();
	groupAdd->addTo(groupMenu);
	groupDelete->addTo(groupMenu);
	groupRename->addTo(groupMenu);
	MenuData = settings.readEntry("Group", tr("Group"));
	contactMenu->insertItem(MenuData,groupMenu);

  contactMyText = new QPopupMenu();
//  contactMenu->insertItem(tr("MyText"),contactMyText);

  connect(contactMenu, SIGNAL( aboutToShow() ), this, SLOT(slotContactMenu()));

  connect(contactMove, SIGNAL( aboutToShow() ), this, SLOT(slotContactMove()));
  connect(contactMove, SIGNAL( activated(int ) ), this, SLOT(slotContactMove(int )));

  connect(contactCopy, SIGNAL( aboutToShow() ), this, SLOT(slotContactCopy()));
  connect(contactCopy, SIGNAL( activated(int ) ), this, SLOT(slotContactCopy(int )));

  connect(contactMyText, SIGNAL( aboutToShow() ), this, SLOT(slotContactMyText()));
  connect(contactMyText, SIGNAL( activated(int ) ), this, SLOT(slotContactMyText(int )));

  // status

	statusMenu = new QPopupMenu();
	id_NLN = statusMenu->insertItem(Resource::loadPixmap("/kmerlin/online.png"),_StatusText[NLN]);
	id_BSY = statusMenu->insertItem(_StatusText[BSY]);
	id_BRB = statusMenu->insertItem(_StatusText[BRB]);
	id_AWY = statusMenu->insertItem(_StatusText[AWY]);
	id_PHN = statusMenu->insertItem(_StatusText[PHN]);
	id_LUN = statusMenu->insertItem(_StatusText[LUN]);
	id_HDN = statusMenu->insertItem(Resource::loadPixmap("/kmerlin/offline.png"),_StatusText[HDN]);


  connect(statusMenu, SIGNAL(activated(int)),this,SLOT(slotChangeStatus(int)));



  ///////////////////////////////////////////////////////////////////
  // menuBar entry helpMenu
  helpMenu=new QPopupMenu();
  helpAboutApp->addTo(helpMenu);

	chatMenu = new QPopupMenu();

  ///////////////////////////////////////////////////////////////////
  // MENUBAR CONFIGURATION
	menu = new QPEMenuBar( this );
	MenuData = settings.readEntry("Go", tr("&Go"));
	menu->insertItem(MenuData, fileMenu);
	MenuData = settings.readEntry("Contact", tr("&Contact"));
	menu->insertItem(MenuData,contactMenu);
	MenuData = settings.readEntry("MyText", tr("M&yText"));
	menu->insertItem(MenuData,contactMyText);
	MenuData = settings.readEntry("MyStatus", tr("&MyStatus"));
	menu->insertItem(MenuData, statusMenu);
	menu->insertItem(Resource::loadPixmap("/kmerlin/messenger.png"), chatMenu);
}


void KMerlinApp::initDoc()
{
//   doc=new KMerlinDoc();
}

void KMerlinApp::initView()
{
  ////////////////////////////////////////////////////////////////////
  // set the main widget here
	view = new OnlineView(this,0,layout,_tabFontSize);
	view->theApp = this;
	setCentralWidget(view);
}


/////////////////////////////////////////////////////////////////////
// SLOT IMPLEMENTATION
/////////////////////////////////////////////////////////////////////
void KMerlinApp::slotContactMenu()
{
	QString handle = view->getHandle();
	if(handle == 0L)
	{
		// nothing selected
		contactBlock->setEnabled(false);
		contactAllow->setEnabled(false);
		contactRemove->setEnabled(false);
		return;
	}
	else contactRemove->setEnabled(true);
	if(imService->isBlocked(handle) )
	{
	 	contactAllow->setEnabled(true);
		contactBlock->setEnabled(false);
	}
	else
	{
	 	contactAllow->setEnabled(false);
		contactBlock->setEnabled(true);
	}

}
void KMerlinApp::slotViewSettings()
{

	ledOff();
	Config settings(ConfigName, Config::User );
	settings.setGroup("Base");
	Setting dlg(0,"Setting",true);
	dlg.publicName->setReadOnly(!connected);
	dlg.handle->setText(_handle);
	if(_handle.isEmpty()) dlg.handle->setText("@hotmail.com");
	dlg.passWord->setText( _passWd);
	dlg.publicName->setText( QString::fromLocal8Bit(_publicName) );

	dlg.hostAddr->setReadOnly(!connected);
	dlg.tcpPort->setReadOnly(!connected);

	dlg.hostAddr->setText(_hostAddr);
	dlg.tcpPort->setText(_tcpPort);
	dlg.refTime->setText(_refTime);
	dlg.fontSize->setText(_fontSize);
	dlg.fontCol1->setText(_fontCol1);
	dlg.fontCol2->setText(_fontCol2);
	dlg.fontCol3->setText(_fontCol3);
	dlg.fontCol4->setText(_fontCol4);
   	dlg.msgWidth->setText(_msgWidth);
    if(_autoWidth=="0"){dlg.autoWidth->setChecked(false);}else{dlg.autoWidth->setChecked(true);}

	dlg.marginH->setText(_marginH);
	dlg.marginV->setText(_marginV);
	dlg.maxComment->setText(_maxComment);

	QString url = _logPath + "/KMerlin_Log/Hotmail.html";
	QFile f(url);
	if (f.exists() == true) {
		f.remove();
	}

	dlg.logPath->setText(_logPath);
	dlg.downPath->setText(_downPath);
	dlg.logFontSize->setText(_logFontSize);
	dlg.tabFontSize->setText(_tabFontSize);
	dlg.infoFontSize->setText(_infoFontSize);
	dlg.sendFontSize->setText(_sendFontSize);

	dlg.RecvmsgText->setText(_RecvmsgText);
	dlg.RecvdmsgText->setText(_RecvdmsgText);
	dlg.UnRecvdmsgText->setText(_UnRecvdmsgText);
	dlg.WritesmsgText->setText(_WritesmsgText);
	dlg.SayText->setText(_SayText);

	dlg.MyText0->setText(_MyText[0]);
	dlg.MyText1->setText(_MyText[1]);
	dlg.MyText2->setText(_MyText[2]);
	dlg.MyText3->setText(_MyText[3]);
	dlg.MyText4->setText(_MyText[4]);
	dlg.MyText5->setText(_MyText[5]);
	dlg.MyText6->setText(_MyText[6]);
	dlg.MyText7->setText(_MyText[7]);
	dlg.MyText8->setText(_MyText[8]);
	dlg.MyText9->setText(_MyText[9]);
	dlg.MyText10->setText(_MyText[10]);
	dlg.MyText11->setText(_MyText[11]);
	dlg.MyText12->setText(_MyText[12]);
	dlg.MyText13->setText(_MyText[13]);
	dlg.MyText14->setText(_MyText[14]);
	dlg.MyText15->setText(_MyText[15]);
//	dlg.Recvmsg->setText(_Recvmsg);
	QString strTemp = "";
	int loop = 0;
	int idx = 0;
	QStringList msgList = QStringList::split(",","Another,You,Both", true);
	for ( QStringList::Iterator it = msgList.begin(); it != msgList.end(); ++it) {
		strTemp = (*it).latin1();
		if (strTemp == _Recvmsg) {
			idx = loop;
		}
		loop++;
	}                        
	dlg.Recvmsg->setCurrentItem(idx);

//	dlg.RecvmsgTime->setText(_MsgRecvtime);
	msgList = QStringList::split(",","Full Format,Date Time,Time", true);
	idx = 0;
	loop = 0;
	for ( QStringList::Iterator it = msgList.begin(); it != msgList.end(); ++it) {
		strTemp = (*it).latin1();
		if (strTemp == _MsgRecvtime) {
			idx = loop;
		}
		loop++;
	}                        
	dlg.RecvmsgTime->setCurrentItem(idx);

//	dlg.DispRecvTime->setText(_DispRecvtime);
	msgList = QStringList::split(",","None,Full Format,Date Time,Time", true);
	idx = 0;
	loop = 0;
	for ( QStringList::Iterator it = msgList.begin(); it != msgList.end(); ++it) {
		strTemp = (*it).latin1();
		if (strTemp == _DispRecvtime) {
			idx = loop;
		}
		loop++;
	}                        
	dlg.DispRecvTime->setCurrentItem(idx);


    if(_logging=="0"){dlg.Logging->setChecked(false);}else{dlg.Logging->setChecked(true);}

    if(_sndEnable=="0"){dlg.sndEnable->setChecked(false);}else{dlg.sndEnable->setChecked(true);}
    if(_Mobile=="0"){dlg.mobileEnable->setChecked(false);}else{dlg.mobileEnable->setChecked(true);}

	dlg.mobileEnable->setEnabled(!connected);

    if(_OfflineVisible=="0"){dlg.offlineVisible->setChecked(false);}else{dlg.offlineVisible->setChecked(true);}
    if(_BlockedVisible=="0"){dlg.blockedVisible->setChecked(false);}else{dlg.blockedVisible->setChecked(true);}

    if(_MailNoticeEnable=="0"){dlg.MailNoticeEnable->setChecked(false);}else{dlg.MailNoticeEnable->setChecked(true);}

	QFontDatabase objFontDB;
	QStringList strFontList = objFontDB.families(true);
	strTemp = "";
	loop = 0;
	idx = 0;
	dlg.fontName->clear();
	for ( QStringList::Iterator it = strFontList.begin(); it != strFontList.end(); ++it) {
		strTemp = (*it).latin1();
		dlg.fontName->insertItem(strTemp,   -1);
		if (strTemp == _fontName) {
			idx = loop;
		}
		loop++;
	}
	dlg.fontName->setCurrentItem(idx);

	QStringList modeList = QStringList::split(",","off,on,default,flashon,flashoff,vfstblink,fastblink,normblink,slowblink,softblink,softflash", true);
	idx = 0;
	loop = 0;
	for ( QStringList::Iterator it = modeList.begin(); it != modeList.end(); ++it) {
		strTemp = (*it).latin1();
		if (strTemp == _ledMode) {
			idx = loop;
		}
		loop++;
	}                        
	dlg.ledMode->setCurrentItem(idx);

	if(_ConnectRequest=="0"){dlg.ConnectRequest->setChecked(false);}else{dlg.ConnectRequest->setChecked(true);}

	QStringList connectList = QStringList::split(",","No,Yes", true);
	idx = 0;
	loop = 0;
	for ( QStringList::Iterator it = connectList.begin(); it != connectList.end(); ++it) {
		strTemp = (*it).latin1();
		if (strTemp == _AutoConnectMode) {
			idx = loop;
		}
		loop++;
	}                        
	dlg.AutoConnectMode->setCurrentItem(idx);

	connectList = QStringList::split(",","No,Yes,Confirm", true);
	idx = 0;
	loop = 0;
	for ( QStringList::Iterator it = connectList.begin(); it != connectList.end(); ++it) {
		strTemp = (*it).latin1();
		if (strTemp == _DisconnectMode) {
			idx = loop;
		}
		loop++;
	}                        
	dlg.DisconnectMode->setCurrentItem(idx);

	dlg.MailAp->setText(_MailAp);
	dlg.BrowserAp->setText(_BrowserAp);
	dlg.ServerStatusUrl->setText(_ServerStatusUrl);
	dlg.ProfileUrl->setText(_ProfileUrl);

	if( dlg.exec() == QDialog::Accepted )
	{
		_handle = dlg.handle->text();
		_passWd = dlg.passWord->text();
		_hostAddr = dlg.hostAddr->text();
		_tcpPort = dlg.tcpPort->text();
		_refTime = dlg.refTime->text();
		_fontName = dlg.fontName->currentText();
		_fontSize = dlg.fontSize->text();
		_fontCol1 = dlg.fontCol1->text();
		_fontCol2 = dlg.fontCol2->text();
		_fontCol3 = dlg.fontCol3->text();
		_fontCol4 = dlg.fontCol4->text();
		_msgWidth = dlg.msgWidth->text();
		_ledMode = dlg.ledMode->currentText();
	        if(dlg.ConnectRequest->isChecked()){ _ConnectRequest = "1";}else{ _ConnectRequest = "0";}
		_AutoConnectMode = dlg.AutoConnectMode->currentText();
		_DisconnectMode = dlg.DisconnectMode->currentText();
        if(dlg.autoWidth->isChecked()){ _autoWidth = "1";}else{ _autoWidth = "0";}

		_marginH = dlg.marginH->text();
		_marginV = dlg.marginV->text();
		_maxComment = dlg.maxComment->text();
		bool ok;
		maxComment = _maxComment.toInt(&ok,10);
		if(!ok){maxComment = 10;}

		_logPath = dlg.logPath->text();
		_downPath = dlg.downPath->text();
		_logFontSize = dlg.logFontSize->text();
		_tabFontSize = dlg.tabFontSize->text();
		_infoFontSize = dlg.infoFontSize->text();
		_sendFontSize = dlg.sendFontSize->text();
		_RecvmsgText = dlg.RecvmsgText->text();
		_RecvdmsgText = dlg.RecvdmsgText->text();
		_UnRecvdmsgText = dlg.UnRecvdmsgText->text();
		_WritesmsgText = dlg.WritesmsgText->text();
		_SayText = dlg.SayText->text();

		if (_RecvmsgText == "") _RecvmsgText = "You received the last message  at :%1";
		if (_RecvdmsgText == "") _RecvdmsgText = "Your last message was received at :%1";
		if (_UnRecvdmsgText == "") _UnRecvdmsgText = "Your last message was not received :%1";
		if (_WritesmsgText == "") _WritesmsgText = "%1,  writes a message";
		if (_WaitmsgText == "") _WaitmsgText = "Please wait....";
		if (_SayText == "") _SayText = "%1 Says";

		_Recvmsg = dlg.Recvmsg->currentText();
		_MsgRecvtime = dlg.RecvmsgTime->currentText();
		_DispRecvtime = dlg.DispRecvTime->currentText();
		_MyText[0] = dlg.MyText0->text();
		_MyText[1] = dlg.MyText1->text();
		_MyText[2] = dlg.MyText2->text();
		_MyText[3] = dlg.MyText3->text();
		_MyText[4] = dlg.MyText4->text();
		_MyText[5] = dlg.MyText5->text();
		_MyText[6] = dlg.MyText6->text();
		_MyText[7] = dlg.MyText7->text();
		_MyText[8] = dlg.MyText8->text();
		_MyText[9] = dlg.MyText9->text();
		_MyText[10] = dlg.MyText10->text();
		_MyText[11] = dlg.MyText11->text();
		_MyText[12] = dlg.MyText12->text();
		_MyText[13] = dlg.MyText13->text();
		_MyText[14] = dlg.MyText14->text();
		_MyText[15] = dlg.MyText15->text();
		_MailAp = dlg.MailAp->text();
		_BrowserAp = dlg.BrowserAp->text();
		_ServerStatusUrl = dlg.ServerStatusUrl->text();
		_ProfileUrl = dlg.ProfileUrl->text();

		if (_MailAp == "") _MailAp = "qtmail";
		if (_BrowserAp == "") _BrowserAp = "netfront3";
		if (_ServerStatusUrl == "") _ServerStatusUrl = "http://messenger.msn.com/Status.aspx";
		if (_ProfileUrl == "") _ProfileUrl = "http://members.msn.com/default.msnw?mem=";

        if(dlg.Logging->isChecked()){ _logging = "1";}else{ _logging = "0";}
        if(dlg.sndEnable->isChecked()){ _sndEnable = "1";}else{ _sndEnable = "0";}
		if(_sndEnable == "0") { soundEnable = false; }else{	soundEnable = true;}

		QDir dir;
		dir.setPath(_logPath);
	    if ( !dir.exists() ) mkdir(dir.path().local8Bit(),0700);
		if ( !dir.exists() ) _logPath = (QString(getenv("HOME")) + "/Documents");

		dir.setPath(_downPath);
	    if ( !dir.exists() ) mkdir(dir.path().local8Bit(),0700);
		if ( !dir.exists() ) _downPath = (QString(getenv("HOME")) + "/Documents");

		settings.writeEntry("Handle",_handle);
		settings.writeEntry("Password",_passWd);
		settings.writeEntry("HostAddress",_hostAddr);
		settings.writeEntry("Port",_tcpPort);
		settings.writeEntry("RefreshTime",_refTime);
		imService->setRefTimer(_refTime);
		settings.writeEntry("FontName",_fontName);
		settings.writeEntry("FontSize",_fontSize);
		settings.writeEntry("FontCol1",_fontCol1);
		settings.writeEntry("FontCol2",_fontCol2);
		settings.writeEntry("FontCol3",_fontCol3);
		settings.writeEntry("FontCol4",_fontCol4);
		settings.writeEntry("AutoWidth",_autoWidth);
		settings.writeEntry("MessageTabWidth",_msgWidth);

		settings.writeEntry("LogPath",_logPath);
		settings.writeEntry("DownloadPath",_downPath);
		settings.writeEntry("LogFontSize",_logFontSize);
		settings.writeEntry("TabFontSize",_tabFontSize);
		settings.writeEntry("InfoFontSize",_infoFontSize);
		settings.writeEntry("SendFontSize",_sendFontSize);
		settings.writeEntry("ReceiveMessage",_Recvmsg);
		settings.writeEntry("ReceiveMessageText",_RecvmsgText);
		settings.writeEntry("ReceivedMessageText",_RecvdmsgText);
		settings.writeEntry("UnReceivedMessageText",_UnRecvdmsgText);
		settings.writeEntry("WritesMessageText",_WritesmsgText);
		settings.writeEntry("SayText",_SayText);
		settings.writeEntry("DispReceiveTime",_DispRecvtime);
		settings.writeEntry("MessageReceiveTime",_MsgRecvtime);

		settings.writeEntry("MyText0",_MyText[0]);
		settings.writeEntry("MyText1",_MyText[1]);
		settings.writeEntry("MyText2",_MyText[2]);
		settings.writeEntry("MyText3",_MyText[3]);
		settings.writeEntry("MyText4",_MyText[4]);
		settings.writeEntry("MyText5",_MyText[5]);
		settings.writeEntry("MyText6",_MyText[6]);
		settings.writeEntry("MyText7",_MyText[7]);
		settings.writeEntry("MyText8",_MyText[8]);
		settings.writeEntry("MyText9",_MyText[9]);
		settings.writeEntry("MyText10",_MyText[10]);
		settings.writeEntry("MyText11",_MyText[11]);
		settings.writeEntry("MyText12",_MyText[12]);
		settings.writeEntry("MyText13",_MyText[13]);
		settings.writeEntry("MyText14",_MyText[14]);
		settings.writeEntry("MyText15",_MyText[15]);

		settings.writeEntry("MailAp",_MailAp);
		settings.writeEntry("BrowserAp",_BrowserAp);
		settings.writeEntry("ServerStatusUrl",_ServerStatusUrl);
		settings.writeEntry("ProfileUrl",_ProfileUrl);

		settings.writeEntry("MarginH",_marginH);
		settings.writeEntry("MarginV",_marginV);
		settings.writeEntry("MaxComment",_maxComment);

		settings.writeEntry("SoundEnable",_sndEnable);
		settings.writeEntry("Logging",_logging);
		settings.writeEntry("LedMode",_ledMode);
		settings.writeEntry("ConnectRequest",_ConnectRequest);
		settings.writeEntry("AutoConnectMode",_AutoConnectMode);
		settings.writeEntry("DisconnectMode",_DisconnectMode);

	        if(dlg.mobileEnable->isChecked()){ _Mobile = "1";}else{ _Mobile = "0";}
		imService->setMobile(_Mobile);
		settings.writeEntry("Mobile",_Mobile);

	        if(dlg.offlineVisible->isChecked()){ _OfflineVisible = "1";}else{ _OfflineVisible = "0";}
		settings.writeEntry("OfflineVisible",_OfflineVisible);

	        if(dlg.blockedVisible->isChecked()){ _BlockedVisible = "1";}else{ _BlockedVisible = "0";}
		settings.writeEntry("BlockedVisible",_BlockedVisible);

	        if(dlg.MailNoticeEnable->isChecked()){ _MailNoticeEnable = "1";}else{ _MailNoticeEnable = "0";}
		settings.writeEntry("MailNoticeEnable",_MailNoticeEnable);

		if( connected )
		{
			view->ListView->clear();
			view->slotConnected(true);
		}
        view->setWidth(_autoWidth,_msgWidth,layout);
        reSetTab();

		if( connected )
		{
			if( dlg.publicName->text() != QString::fromLocal8Bit(_publicName) )
			{
				imService->setMyPublicName( dlg.publicName->text().utf8());
			}
		}

	}
}

void KMerlinApp::slotConnected( bool f )
{
	connected = f;
	if( f ) // connected
	{
		fileCancel->removeFrom(fileMenu);
		currentStatus = NLN;
		fileConnect->setEnabled(false);
		fileDisconnect->setEnabled(true);
		contactMenu->setEnabled(true);
		groupMenu->setEnabled(true);
		statusMenu->setEnabled(true);
//		view->setOnlineLabelText(_publicName + " ("+tr("Online")+")");
		view->setOnlineLabelText(_publicName+" " + "(" + QString(_StatusText[NLN].local8Bit()) + ")" );
	}
	else
	{
		fileCancel->removeFrom(fileMenu);
		if(workTimer != 0L)
		{
			killTimer(workTimer);
		}
		workTimer = 0L;
		if(!widgetList.isEmpty()){
			ChatWindow *chatWindow;
			for( chatWindow = widgetList.first(); chatWindow != 0; chatWindow = widgetList.first() )
			{
	                        chatWindow->slotFileQuit();
			}
		}

		if(!logList.isEmpty()){
			logviewimpl *logWindow;
			for( logWindow = logList.first(); logWindow != 0; logWindow = logList.first() )
			{
	                        logWindow->slotLogClose();
			}
		}
		currentStatus = FLN;
		fileConnect->setEnabled(true);
		fileDisconnect->setEnabled(false);
		contactMenu->setEnabled(false);
		groupMenu->setEnabled(false);
		statusMenu->setEnabled(false);
		view->setOnlineLabelText(tr("Offline"));
	}

}

void KMerlinApp::slotChangeStatus(int i)
{
	if(workTimer == 0L)
	{
		workTimer = startTimer(50000);
	}

//	if(statusMenu->text(i) == tr("Online"))

//		statusMenu->setItemChecked(id_AWY,false);
//		statusMenu->setItemChecked(id_BSY,false);
//		statusMenu->setItemChecked(id_PHN,false);
//		statusMenu->setItemChecked(id_LUN,false);
//		statusMenu->setItemChecked(id_HDN,false);

//	if(statusMenu->text(i) == tr("Away from Computer"))

	if( i == id_NLN )
	{
		imService->changeStatus(NLN,m_pictureObj);
	}
	if( i == id_BSY )
	{
		imService->changeStatus(BSY,m_pictureObj);
	}
	if( i == id_BRB )
	{
		imService->changeStatus(BRB,m_pictureObj);
	}
	if( i == id_AWY )
	{
		imService->changeStatus(AWY,m_pictureObj);
	}
	if( i == id_PHN )
	{
		imService->changeStatus(PHN,m_pictureObj);
	}
	if( i == id_LUN )
	{
		imService->changeStatus(LUN,m_pictureObj);
	}
	if( i == id_HDN )
	{
		imService->changeStatus(HDN,m_pictureObj);
	}
	view->setOnlineLabelText(tr("Change status to: ")+ QString(statusMenu->text(i).local8Bit()) );
	ledOff();
}

void KMerlinApp::slotFileCancel()
{
	imService->cancelConnect();
	view->setOnlineLabelText(tr("Offline"));
	fileCancel->removeFrom(fileMenu);
	fileConnect->setEnabled(true);

	ledOff();
}
void KMerlinApp::slotFileLayout()
{
	if (layout == "0") {
		layout = "1";
	} else {
		layout = "0";
	}
	Config settings(ConfigName, Config::User );
	settings.setGroup("Base");
	settings.writeEntry("Layout",layout);

	view->setWidth(_autoWidth,_msgWidth,layout);
	reSetTab();
	QMessageBox::warning(0,tr("Warning"),tr("Please Restart !!"));
}

void KMerlinApp::slotFileService()
{
	qCopSend("QPE/System", "execute(QString,QString)",_BrowserAp,_ServerStatusUrl);
}

void KMerlinApp::qCopSend(QCString channel,QCString message,QString parameter1,QString parameter2 )
{

	QCopEnvelope e(channel, message);
	if (parameter1 != "") {
		e << parameter1;
	}
	if (parameter2 != "") {
		e << parameter2;
	}
}
void KMerlinApp::slotFileConnect()
{

	netConnected = false;
	if(_handle.isEmpty() )
	{
		slotViewSettings();
	}
		connect( hqPppEnv, SIGNAL( netConnectingSignal()), this, SLOT( slotNetConnectSlot())) ;
		if(_ConnectRequest == "1") {
			if(hqPppEnv->IsConnecting() <= 0) {
				hqPppEnv->connectPPP();
			} else {
				qCopSend("QPE/Network", "up()","","");
			}
		} else {
			qCopSend("QPE/Network", "up()","","");
		}
//	view->setOnlineLabelText(tr("Connecting to Service..."));

//	fileConnect->setEnabled(false);
//	fileCancel->addTo(fileMenu);
//	imService->setMyContactInfo(_handle, _passWd, _hostAddr, _tcpPort);
//	imService->connectToService();
}
void KMerlinApp::slotNetConnectSlot()
{
	if ( netConnected ) {
		return;
	}
	netConnected = true;
	view->setOnlineLabelText(tr("Connecting to Service..."));

//	if(_handle.isEmpty() )
//	{
//		slotViewSettings();
//	}
	fileConnect->setEnabled(false);
	fileCancel->addTo(fileMenu);
	imService->setMyContactInfo(_handle, _passWd, _hostAddr, _tcpPort);
	imService->connectToService();
}
void KMerlinApp::slotFileDisconnect()
{
//	if(workTimer == 0L)
//	{
//		workTimer = startTimer(50000);
//	}
	if(workTimer != 0L)
	{
		killTimer(workTimer);
	}
	workTimer = 0L;
  view->setOnlineLabelText(tr("Disconnecting..."));

  imService->disconnect();
	ledOff();

}




void KMerlinApp::slotHelpAbout()
{
  QMessageBox::about(this,tr("About..."),
                      tr("KMerlin\nVersion 0.3.2\n(c) 2001 by Olaf Lueg\nolaf.lueg@t-online.de\nhttp:\\kmerlin.olsd.de") );
}

void KMerlinApp::slotAuthContact(QString handle)
{
	NewUserImpl *authDlg = new NewUserImpl(0);
	authDlg->setHandle(handle);
	connect( authDlg, SIGNAL(addUser( QString )), this, SLOT(slotAddContact( QString )));
	connect( authDlg, SIGNAL(blockUser( QString )), this, SLOT(slotBlockContact( QString )));
	authDlg->show();
}

void KMerlinApp::slotAddContact(QString handle)
{
	imService->contactAdd( handle );
}

void KMerlinApp::slotBlockContact(QString handle)
{
	imService->contactBlock(handle);
}

void KMerlinApp::slotContactAdd()
{
	bool ok = FALSE;
	InputDlg dlg(0,"KMerlin",true);
	ok = dlg.exec();
	if ( ok && !dlg.strText->text().isEmpty() )
	{
		// user entered something and pressed ok
		imService->contactAdd(dlg.strText->text() );
	}
	else
	{
		// user entered nothing or pressed cancel
	}

}

void KMerlinApp::slotOpenChatWindow(IMChatService *board,QString handle)
{
	if(widgetList.isEmpty())
	{
		ChatWindow *chatWindow = new ChatWindow(view->TabView, _infoFontSize, _menuBtnFontSize, _sendFontSize);
		view->TabView->addTab(chatWindow,imService->getPublicName(handle));
		chatWindow->theApp = this;
		chatWindow->chatWith = handle;
		chatWindow->connectToMenu();
		connect(chatWindow,SIGNAL(sendMsg(QString)),board,SLOT(slotSendMsg(QString)));
		connect(chatWindow,SIGNAL(closeSession()),board,SLOT(slotCloseSession()));
		connect(chatWindow,SIGNAL(inviteContact(QString)),board,SLOT(slotInviteContact(QString)));
		connect(chatWindow,SIGNAL(typingMsg()),board,SLOT(slotTypingMsg()));
		connect(chatWindow,SIGNAL(createSession(QString)),imService,SLOT(slotStartChatSession(QString)));
		connect(board,SIGNAL(msgReceived(QString,QString,QString)),chatWindow,SLOT(slotMsgReceived(QString,QString,QString)));
		connect(board,SIGNAL(userTypingMsg(QString)),chatWindow,SLOT(slotContactTyping(QString )));
		connect(board,SIGNAL(msgAcknowledgement(bool)),chatWindow,SLOT(slotMsgAcknowledgement(bool)));
		connect(board,SIGNAL(switchBoardIsActive(bool)),chatWindow,SLOT(slotSwitchBoardIsActive(bool)));
		connect(board,SIGNAL(updateChatMember(QString,QString,bool)),chatWindow,SLOT(slotUpdateChatMemberList(QString,QString,bool)));
        connect(view->TabView,SIGNAL(currentChanged(QWidget *)),chatWindow,SLOT(slotCurrentChanged(QWidget *)));

		widgetList.append(chatWindow);
		view->TabView->showPage(chatWindow);
        chatWindow->view->strSend->setFocus();
		reSetTab();
		return;
	}
	else
	{
		ChatWindow *chatWindow;
		for( chatWindow = widgetList.first(); chatWindow != 0; chatWindow = widgetList.next() )
			{
				if(chatWindow->chatWith == handle)
				{
                    if(chatWindow != view->TabView->currentPage()){
    					view->TabView->showPage(chatWindow);
                        chatWindow->view->strSend->setFocus();
                    }

					if(chatWindow->isChatMember(handle)) return;
					chatWindow->disconnect();
					connect(chatWindow,SIGNAL(sendMsg(QString)),board,SLOT(slotSendMsg(QString)));
					connect(chatWindow,SIGNAL(closeSession()),board,SLOT(slotCloseSession()));
					connect(chatWindow,SIGNAL(inviteContact(QString)),board,SLOT(slotInviteContact(QString)));
					connect(chatWindow,SIGNAL(typingMsg()),board,SLOT(slotTypingMsg()));
					connect(chatWindow,SIGNAL(createSession(QString)),imService,SLOT(slotStartChatSession(QString)));
					connect(board,SIGNAL(msgReceived(QString,QString,QString)),chatWindow,SLOT(slotMsgReceived(QString,QString,QString)));
					connect(board,SIGNAL(userTypingMsg(QString)),chatWindow,SLOT(slotContactTyping(QString )));
					connect(board,SIGNAL(msgAcknowledgement(bool)),chatWindow,SLOT(slotMsgAcknowledgement(bool)));
					connect(board,SIGNAL(switchBoardIsActive(bool)),chatWindow,SLOT(slotSwitchBoardIsActive(bool)));
					connect(board,SIGNAL(updateChatMember(QString,QString,bool)),chatWindow,SLOT(slotUpdateChatMemberList(QString,QString,bool)));
                    connect(view->TabView,SIGNAL(currentChanged(QWidget *)),chatWindow,SLOT(slotCurrentChanged(QWidget *)));

					return;
				}
			}
	}
	ChatWindow *chatWindow = new ChatWindow();
	view->TabView->addTab(chatWindow,imService->getPublicName(handle));
	chatWindow->theApp = this;
	chatWindow->chatWith = handle;
	chatWindow->connectToMenu();
	connect(chatWindow,SIGNAL(sendMsg(QString)),board,SLOT(slotSendMsg(QString)));
	connect(chatWindow,SIGNAL(closeSession()),board,SLOT(slotCloseSession()));
	connect(chatWindow,SIGNAL(inviteContact(QString)),board,SLOT(slotInviteContact(QString)));
	connect(chatWindow,SIGNAL(typingMsg()),board,SLOT(slotTypingMsg()));
	connect(chatWindow,SIGNAL(createSession(QString)),imService,SLOT(slotStartChatSession(QString)));
	connect(board,SIGNAL(msgReceived(QString,QString,QString)),chatWindow,SLOT(slotMsgReceived(QString,QString,QString)));
	connect(board,SIGNAL(userTypingMsg(QString)),chatWindow,SLOT(slotContactTyping(QString )));
	connect(board,SIGNAL(msgAcknowledgement(bool)),chatWindow,SLOT(slotMsgAcknowledgement(bool)));
	connect(board,SIGNAL(switchBoardIsActive(bool)),chatWindow,SLOT(slotSwitchBoardIsActive(bool)));
	connect(board,SIGNAL(updateChatMember(QString,QString,bool)),chatWindow,SLOT(slotUpdateChatMemberList(QString,QString,bool)));
    connect(view->TabView,SIGNAL(currentChanged(QWidget *)),chatWindow,SLOT(slotCurrentChanged(QWidget *)));

	widgetList.append( chatWindow );
	view->TabView->showPage(chatWindow);
    chatWindow->view->strSend->setFocus();
	reSetTab();
}

void KMerlinApp::slotStatusChanged(uint status)
{
	if(workTimer != 0L) killTimer(workTimer);
	if ( currentStatus == status ) {
	} else {
		statusMenu->setItemChecked(id_NLN,false);
		statusMenu->setItemChecked(id_BRB,false);
		statusMenu->setItemChecked(id_AWY,false);
		statusMenu->setItemChecked(id_BSY,false);
		statusMenu->setItemChecked(id_PHN,false);
		statusMenu->setItemChecked(id_LUN,false);
		statusMenu->setItemChecked(id_HDN,false);
	}
	if(status == NLN)
	{
		view->setOnlineLabelText(_publicName+" " + "(" + QString(_StatusText[status].local8Bit()) + ")" );
		if ( currentStatus != status ) {
			currentStatus = status;
			statusMenu->setItemChecked(id_NLN,true);
		}
	}
	if(status == BSY)
	{
		view->setOnlineLabelText(_publicName+" " + "(" + QString(_StatusText[status].local8Bit()) + ")" );
		if ( currentStatus != status ) {
			currentStatus = status;
			statusMenu->setItemChecked(id_BSY,true);
		}
	}
	if(status == AWY)
	{
		view->setOnlineLabelText(_publicName+" " + "(" + QString(_StatusText[status].local8Bit()) + ")" );
		if ( currentStatus != status ) {
			currentStatus = status;
			statusMenu->setItemChecked(id_AWY,true);
		}
	}
	if(status == BRB)
	{
		view->setOnlineLabelText(_publicName+" " + "(" + QString(_StatusText[status].local8Bit()) + ")" );
		if ( currentStatus != status ) {
			currentStatus = status;
			statusMenu->setItemChecked(id_BRB,true);
		}
	}
	if(status == PHN)
	{
		view->setOnlineLabelText(_publicName+" " + "(" + QString(_StatusText[status].local8Bit()) + ")" );
		if ( currentStatus != status ) {
			currentStatus = status;
			statusMenu->setItemChecked(id_PHN,true);
		}
	}
	if(status == LUN)
	{
		view->setOnlineLabelText(_publicName+" " + "(" + QString(_StatusText[status].local8Bit()) + ")" );
		if ( currentStatus != status ) {
			currentStatus = status;
			statusMenu->setItemChecked(id_LUN,true);
		}
	}
	if(status == HDN)
	{
		view->setOnlineLabelText(_publicName+" " + "(" + QString(_StatusText[status].local8Bit()) + ")" );
		if ( currentStatus != status ) {
			currentStatus = status;
			statusMenu->setItemChecked(id_HDN,true);
		}
	}
	/*
	if(status == IDL)
	{
		view->setOnlineLabelText(_publicName+" " + "(" + QString(_StatusText[status].local8Bit()) + ")" );
		if ( currentStatus != status ) {
			currentStatus = status;
			fileStatus->setItemChecked(id_IDL,true);
		}
	}
	*/
}

void KMerlinApp::slotPublicNameChanged(QString publicName)
{
	_publicName = publicName;
	slotStatusChanged(currentStatus);
}

void KMerlinApp::keypressed(QKeyEvent * k)
{
    switch (k->key()) {
        case Key_F11         : menu->setFocus();            break;
    }
}

void KMerlinApp::reSetTab(){
	bool ok;
	int marginH = _marginH.toInt(&ok,10);	
	int marginV = _marginV.toInt(&ok,10);

	if(!widgetList.isEmpty()){
		QRect qrTab = view->TabView->geometry();
		qDebug("Width:%d Height:%d",qrTab.width(),qrTab.height());
		ChatWindow *chatWindow;
		for( chatWindow = widgetList.first(); chatWindow != 0; chatWindow = widgetList.next() )
		{
			QRect qr = chatWindow->geometry();
			qr.setWidth(qrTab.width()-marginH);
			qr.setHeight(qrTab.height()-marginV);
			chatWindow->setGeometry(qr);
			chatWindow->setMaxLayout(qr);
//			chatWindow->updateGeometry();
		}
	}

	if(!logList.isEmpty()){
		QRect qrTab = view->TabView->geometry();
		qDebug("Width:%d Height:%d",qrTab.width(),qrTab.height());
		logviewimpl *logWindow;
		for( logWindow = logList.first(); logWindow != 0; logWindow = logList.next() )
		{
			QRect qr = logWindow->geometry();
			qr.setWidth(qrTab.width()-marginH);
			qr.setHeight(qrTab.height()-marginV);
			logWindow->setGeometry(qr);
			logWindow->setMaxLayout(qr);
//			logWindow->setMaximumWidth(qr.width());
//			logWindow->setMaximumHeight(qr.height());
//			logWindow->setMinimumWidth(qr.width());
//			logWindow->setMinimumHeight(qr.height());
//			logWindow->updateGeometry();
		}
	}

//	view->TabView->updateGeometry();

}

void KMerlinApp::slotSetMainCaption(QString caption){
    setCaption(appName + " - " + caption);
}

void KMerlinApp::slotOpenLogWindow(QString loghandle){
	bool ok;
	int marginH = _marginH.toInt(&ok,10);	
	int marginV = _marginV.toInt(&ok,10);

	if(!logList.isEmpty()) {
		logviewimpl *logWindow;
		for( logWindow = logList.first(); logWindow != 0; logWindow = logList.next() )
		{
			if(logWindow->chatWith == loghandle) {
				view->TabView->showPage(logWindow);
				logWindow->logView->setFocus();
				return;
			}
		}
		
	}
		
	QString tabName = "[Log]" + imService->getPublicName(loghandle);
	logviewimpl *logWindow = new logviewimpl(view->TabView,0,_infoFontSize, _menuBtnFontSize);
	view->TabView->addTab(logWindow,tabName);
	logWindow->theApp = this;
	logWindow->chatWith = loghandle;
	logWindow->init();

	view->TabView->showPage(logWindow);
    logWindow->logView->setFocus();

	QRect qrTab = view->TabView->geometry();
	QRect qr = logWindow->geometry();
	qr.setWidth(qrTab.width()-marginH);
	qr.setHeight(qrTab.height()-marginV);

	logList.append( logWindow );
	reSetTab();
	return;
}

void KMerlinApp::ledBlink(){
	SharpLed *sl = new SharpLed();
	sl->mail_led_set(_ledMode);
	sl = NULL;
}

void KMerlinApp::ledOff(){
	SharpLed *sl = new SharpLed();
	sl->mail_led_set("off");
	sl->mail_led_set("default");
	sl = NULL;
}

void KMerlinApp::closeEvent(QCloseEvent *e){
	if ( connected == true ) {
		slotFileDisconnect();
	}
	if (_DisconnectMode == "Yes") {
		hqPppEnv->disconnectPPP();
	} 
	if (_DisconnectMode == "Confirm") {
		qCopSend("QPE/Network", "disconnectRequest()","","");
	} 

	QString url = _logPath + "/KMerlin_Log/Hotmail.html";
	QFile f(url);
	if (f.exists() == true) {
		f.remove();
	}
 
	delete hqPppEnv;
	ledOff();
	e->accept();
}

void KMerlinApp::changeTab(int direction){

	int i;
	i = view->TabView->currentPageIndex();
	view->TabView->setCurrentPage(i + direction);

	if(!logList.isEmpty()){
		logviewimpl *logWindow;
		for( logWindow = logList.first(); logWindow != 0; logWindow = logList.next() )
		{
                    if(logWindow == view->TabView->currentPage()){
			logWindow->logView->setFocus();
			return;
                    }
		}
	}

	if(!widgetList.isEmpty()){
		ChatWindow *chatWindow;
		for( chatWindow = widgetList.first(); chatWindow != 0; chatWindow = widgetList.next() )
		{
                    if(chatWindow == view->TabView->currentPage()){
                        chatWindow->view->strSend->setFocus();
			return;
                    }
		}
	}


}

void KMerlinApp::ListViewSetFocus(){

	view->ListView->setFocus();
}
QString KMerlinApp::pictureObject()
{
	if(m_pictureObj.isNull())
		resetPictureObject(true); //silent=true to keep infinite loop away
	return m_pictureObj;
}

void KMerlinApp::resetPictureObject(bool silent)
{
	QString old=m_pictureObj;

//	if(pluginData(protocol(),"exportCustomPicture") != "1")
//		m_pictureObj="";
//	else
//	{
		QFile pictFile(Resource::findPixmap("/kmerlin/buddyicon.png") );
		if(!pictFile.open(IO_ReadOnly))
			m_pictureObj="";
		else
		{
			QByteArray ar=pictFile.readAll();
			QString sha1d= QString((base64_encode(SHA1::hash(ar))));
//			qDebug("sha1d:" + sha1d);
			QString size=QString::number( pictFile.size() );
			QString all= "Creator"+ _handle +"Size"+size+"Type3LocationTFR2C.tmpFriendlyAAA=SHA1D"+ sha1d;
//			qDebug("all:" + all);
			m_pictureObj="<msnobj Creator=\"" + _handle + "\" Size=\"" + size  + "\" Type=\"3\" Location=\"TFR2C.tmp\" Friendly=\"AAA=\" SHA1D=\""+sha1d+"\" SHA1C=\""+ QString(base64_encode(SHA1::hashString(all.utf8())))  +"\"/>";
		}
//	}
//	qDebug("msnobj:" + m_pictureObj);
	QString a;
	a = encode(m_pictureObj,106);
//	qDebug("encode:%s" , a.data());
	m_pictureObj = a;
}

/**************************************************************************
 * Base64 Functions
 **************************************************************************/

const char Base64EncMap[64] =
{
  0x41, 0x42, 0x43, 0x44, 0x45, 0x46, 0x47, 0x48,
  0x49, 0x4A, 0x4B, 0x4C, 0x4D, 0x4E, 0x4F, 0x50,
  0x51, 0x52, 0x53, 0x54, 0x55, 0x56, 0x57, 0x58,
  0x59, 0x5A, 0x61, 0x62, 0x63, 0x64, 0x65, 0x66,
  0x67, 0x68, 0x69, 0x6A, 0x6B, 0x6C, 0x6D, 0x6E,
  0x6F, 0x70, 0x71, 0x72, 0x73, 0x74, 0x75, 0x76,
  0x77, 0x78, 0x79, 0x7A, 0x30, 0x31, 0x32, 0x33,
  0x34, 0x35, 0x36, 0x37, 0x38, 0x39, 0x2B, 0x2F
};

QString KMerlinApp::base64_encode(const QByteArray& in)
{

    QByteArray out;
    // clear out the output buffer
    out.resize (0);
    if ( in.isEmpty() )
        return "";

    unsigned int sidx = 0;
    unsigned int didx = 0;
    const char* data = in.data();
    const unsigned int len = in.size();

    unsigned int out_len = ((len+2)/3)*4;

    // Deal with the 76 characters or less per
    // line limit specified in RFC 2045 on a
    // pre request basis.
    	
//    insertLFs = (insertLFs && out_len > 76);
//    if ( insertLFs )
//      out_len += ((out_len-1)/76);

    int count = 0;
    out.resize( out_len );

    // 3-byte to 4-byte conversion + 0-63 to ascii printable conversion
    if ( len > 1 )
    {
        while (sidx < len-2)
        {
//            if ( insertLFs )
//            {
//                if ( count && (count%76) == 0 )
//                    out[didx++] = '\n';
//                count += 4;
//            }
            out[didx++] = Base64EncMap[(data[sidx] >> 2) & 077];
            out[didx++] = Base64EncMap[(data[sidx+1] >> 4) & 017 |
                                       (data[sidx] << 4) & 077];
            out[didx++] = Base64EncMap[(data[sidx+2] >> 6) & 003 |
                                       (data[sidx+1] << 2) & 077];
            out[didx++] = Base64EncMap[data[sidx+2] & 077];
            sidx += 3;
        }
    }

    if (sidx < len)
    {
//        if ( insertLFs && (count > 0) && (count%76) == 0 )
//           out[didx++] = '\n';

        out[didx++] = Base64EncMap[(data[sidx] >> 2) & 077];
        if (sidx < len-1)
        {
            out[didx++] = Base64EncMap[(data[sidx+1] >> 4) & 017 |
                                       (data[sidx] << 4) & 077];
            out[didx++] = Base64EncMap[(data[sidx+1] << 2) & 077];
        }
        else
        {
            out[didx++] = Base64EncMap[(data[sidx] << 4) & 077];
        }
    }

    // Add padding
    while (didx < out.size())
    {
        out[didx] = '=';
        didx++;
    }

    return QCString( out.data(), out.size()+1 );

}

QString  KMerlinApp::encode( const QString& segment, int encoding_hint )
{
  const char *encode_string;
  encode_string = "<>#@\"&%?={}|^~[]\'`\\:+";

//qDebug("encode0:" + segment);
  QCString local;
  if (encoding_hint==0)
    local = segment.local8Bit();
  else
  {
      QTextCodec * textCodec = QTextCodec::codecForMib( encoding_hint );
      if (!textCodec)
          local = segment.local8Bit();
      else
          local = textCodec->fromUnicode( segment );
  }

  int old_length = local.length();
//qDebug("encode1");
  if ( !old_length )
    return segment.isNull() ? QString::null : QString(""); // differenciate null and empty

//qDebug("encode2");
  // a worst case approximation
  QChar *new_segment = new QChar[ old_length * 3 + 1 ];
  int new_length = 0;

  for ( int i = 0; i < old_length; i++ )
  {
    // 'unsave' and 'reserved' characters
    // according to RFC 1738,
    // 2.2. URL Character Encoding Issues (pp. 3-4)
    // WABA: Added non-ascii
    unsigned char character = local[i];
    if ( (character <= 32) || (character >= 127) ||
         strchr(encode_string, character) )
    {
      new_segment[ new_length++ ] = '%';

      unsigned int c = character / 16;
      c += (c > 9) ? ('A' - 10) : '0';
      new_segment[ new_length++ ] = c;

      c = character % 16;
      c += (c > 9) ? ('A' - 10) : '0';
      new_segment[ new_length++ ] = c;

    }
    else
      new_segment[ new_length++ ] = local[i];
  }

//qDebug("encode3");
  QString result = QString(new_segment, new_length);
  delete [] new_segment;
  return result;
}

void KMerlinApp::OpenHotMail(QString _address) {

    QDir dir;
	dir.setPath(_logPath);
    if ( !dir.exists() ) mkdir(dir.path().local8Bit(),0700);
	dir.setPath(_logPath + "/KMerlin_Log");
    if ( !dir.exists() ) mkdir(dir.path().local8Bit(),0700);
    QString url = dir.path() + "/Hotmail.html";

	QFile f(url);
	bool ok;
	ok = f.open(IO_WriteOnly);

	if(ok) {
		QString buf = "";
		buf = imService->GetHotMail(_address);
		f.writeBlock(buf, buf.length());
		f.close();
		qCopSend("QPE/System", "execute(QString,QString)",_BrowserAp,url);
	}
}