/*
 * kmerlin.s
 * Ccopyright (c) 2003-2004, deitest@hotmail.com, yanmar@ogonigo.com
 * 
 *kmerlin.s is based on  kmerlin ver1.41. olueg@olsd.de
 *Fixed by deitest@hotmail.com, yanmar@ogonigo.com 2003-2004
 */
/***************************************************************************
                          kmerlin.h  -  description
                             -------------------
    begin                : Sam Dez  8 15:23:00 CET 2001
    copyright            : (C) 2001 by Olaf Lueg
    email                : olueg@olsd.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KMERLIN_H
#define KMERLIN_H

// include files for QT
#include <qapp.h>
#include <qmainwindow.h>
#include <qaction.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qtoolbutton.h>
#include <qstatusbar.h>
#include <qwhatsthis.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qmsgbox.h>
#include <qfiledialog.h>

#include <sys/ioctl.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <getopt.h>
#include <sys/soundcard.h>

// application specific includes

class IMService;
class IMChatService;
class OnlineView;
class ChatWindow;
class logviewimpl;

class QPEToolBar;
class QPEMenuBar;

class HQPppEnv;

/**
  * This Class is the base class for your application. It sets up the main
  * window and providing a menubar, toolbar
  * and statusbar. For the main view, an instance of class KMerlinView is
  * created which creates your view.
  */
class KMerlinApp : public QMainWindow
{
  Q_OBJECT
  
  public:
    QString appName;
    QString _publicName;
    QString _hostAddr;
    QString _tcpPort;
    QString _fontName;
    QString _fontSize;
    QString _fontCol1;
    QString _fontCol2;
    QString _fontCol3;
    QString _fontCol4;
    QString _refTime;
    QString _msgWidth;
    QString _autoWidth;

	QString _sndEnable;
	QString _logPath;
	QString _downPath;
	QString _logFontSize;
	QString _marginH;
	QString _marginV;
	QString _maxComment;
	int maxComment;

    QString _ledMode;

	bool soundEnable;
	QString layout;
    QString _Mobile;
	QString _infoFontSize;
	QString _menuBtnFontSize;
	QString _sendFontSize;
	QString _tabFontSize;
	QString _Recvmsg;
	QString _RecvmsgText;
	QString _RecvdmsgText;
	QString _UnRecvdmsgText;
	QString _WritesmsgText;
	QString _WaitmsgText;
	QString _SayText;
	QString _DispRecvtime;
	QString _MsgRecvtime;
	QString _logging;
	QString m_pictureObj;
	QString _MyText[16];
	QString _OfflineVisible;
	QString _BlockedVisible;
	QString _MailNoticeEnable;
	QString _AutoConnectMode;
	QString _DisconnectMode;
	QString _ConnectRequest;
	QString _MailAp;
	QString _BrowserAp;
	QString _ServerStatusUrl;
	QString _ProfileUrl;

	QString _StatusText[10];

	QString _HotMailUrl;

    OnlineView *view;
    /** construtor */
    KMerlinApp(QString);
    /** destructor */
    ~KMerlinApp();
    /** initializes all QActions of the application */
    void initActions();
    /** initMenuBar creates the menu_bar and inserts the menuitems */
    void initMenuBar();
    /** setup the document*/
    void initDoc();
    /** setup the mainview*/
    void initView();
	void reSetTab();
	void changeTab(int directon);
	void ListViewSetFocus();

    QList<ChatWindow> widgetList;
    QList<logviewimpl> logList;

    IMService *imService;
		int workTimer;
		int refreshTimer;

		void timerEvent(QTimerEvent *ev);

		QPopupMenu *chatMenu;

    void ledBlink();
    void ledOff();

	void qCopSend(QCString channel,QCString message,QString parameter1,QString parameter2 );
	void OpenHotMail(QString);
	QString pictureObject();
	void resetPictureObject(bool silent);
	QString base64_encode(const QByteArray& in);


  public slots:
    void keypressed(QKeyEvent *);
    /** generate a new document in the actual view */
    void slotFileConnect();
    void slotNetConnectSlot();
    void slotFileLayout();
    void slotFileService();
    /** open a document */
    void slotFileDisconnect();
    void slotFileCancel();
    void slotMailNotifier( QString message, uint count );
    void slotShowNotifier(QString handle, uint status, uint oldstatus);

    /** shows an about dlg*/
    void slotHelpAbout();
    void slotContactAdd();
    void slotContactRemove();
    void slotContactDelete();
    void slotContactAllow();
    void slotContactBlock();
    void slotContactChat();
    void slotContactMail();
    void slotContactProfile();

	void slotContactMenu();

    void slotContactCopy();
    void slotContactCopy( int i);

    void slotContactMove();
    void slotContactMove( int i );

    void slotContactMyText();
    void slotContactMyText( int i );

    void slotOpenChatWindow(IMChatService *board,QString handle);
    void slotRenameGroup();
    void slotDeleteGroup();
    void slotAddGroup();

    void slotChangeStatus( int i);
    void slotConnected( bool f);

	void slotStatusChanged(uint status);
	void slotPublicNameChanged(QString publicName);

    void slotViewSettings();
	void slotAuthContact(QString handle);
	void slotAddContact(QString handle);
	void slotBlockContact(QString handle);
    void slotSetMainCaption(QString caption);
	void slotOpenLogWindow(QString loghandle);

  private:
    /** view is the main widget which represents your working area. The View
     * class should handle all events of the view widget.  It is kept empty so
     * you can create your view according to your application's needs by
     * changing the view class.
     */
    int currentStatus;
    QString ConfigName;
    bool connected;
    QString _handle;
    QString _passWd;

    int id_NLN, id_BRB, id_HDN, id_LUN, id_PHN, id_AWY, id_BSY;
    /** doc represents your actual document and is created only once. It keeps
     * information such as filename and does the serialization of your files.
     */
//    KMerlinDoc *doc;

    QPEMenuBar *menu;
    /** file_menu contains all items of the menubar entry "File" */
    QPopupMenu *fileMenu;
    /** edit_menu contains all items of the menubar entry "Edit" */

    QPopupMenu *helpMenu;
    /** the main toolbar */
    /** actions for the application initialized in initActions() and used to en/disable them
      * according to your needs during the program */
    QPopupMenu *fileStatus;

    QPopupMenu* contactMenu;
    QPopupMenu *contactCopy;
    QPopupMenu *contactMove;
    QPopupMenu *contactMyText;
    QPopupMenu *statusMenu;
		
    QAction* contactAdd;
    QAction* contactDelete;
    QAction* contactRemove;
    QAction* contactBlock;
    QAction* contactAllow;

    QPopupMenu* groupMenu;
    QAction* groupAdd;
    QAction* groupDelete;
    QAction* groupRename;

    QAction *fileConnect;
    QAction *fileDisconnect;
		QAction *fileChat;
		QAction *fileMail;
		QAction *fileProfile;
		QAction *fileCancel;

    QAction *viewSettings;
    QAction *fileLayout;
    QAction *fileService;
    QAction *helpAboutApp;

	HQPppEnv*	hqPppEnv;
	bool netConnected;
protected:
	void closeEvent( QCloseEvent *e );
	static QString encode( const QString& segment, int encoding_hint );

};
#endif


