/*
 * kmerlin.s
 * Ccopyright (c) 2003-2004, deitest@hotmail.com, yanmar@ogonigo.com
 * 
 *kmerlin.s is based on  kmerlin ver1.41. olueg@olsd.de
 *Fixed by deitest@hotmail.com, yanmar@ogonigo.com 2003-2004
 */
/***************************************************************************
                          onlineview.cpp  -  description
                             -------------------
    begin                : Fri Jun 22 2001
    copyright            : (C) 2001 by olaf lueg
    email                : olaf.lueg@t-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

// my own
#include "onlineview.h"
#include "imservice.h"
#include "mylistview.h"
#include "kmerlin.h"
#include <qpe/resource.h>

// qt
#include <qlabel.h>
#include <qlayout.h>
#include <qpushbutton.h>
#include <qlineedit.h>
#include <qsizepolicy.h>
#include <qstringlist.h>
#include <qtabwidget.h>
#include <qevent.h>
#include <sl/slsoundconf.h>

QBoxLayout *hbox;

OnlineView::OnlineView(QWidget *parent, const char *name,QString _layout,QString _tabFontSize ) : QWidget(parent,name) {

	setBackgroundMode(PaletteBase);
	//setGeometry(0,0,640,480);
	loadIcons();
	MailCount = 0;
	QVBoxLayout *layout=new QVBoxLayout(this);
	layout->setSpacing(0);
	layout->setMargin(0);
	//layout->addSpacing(0);
//	QHBoxLayout *hbox=new QHBoxLayout(layout);
	hbox=new QBoxLayout(layout,(QBoxLayout::Direction) 0);
	if (_layout != "0") {
		hbox->setDirection((QBoxLayout::Direction) 3);
	}
//	QVBoxLayout *vbox=new QVBoxLayout(hbox);

	// create the ListView
	// an item has now 3 columns publicName+(Status),Handle,Sort - display's online at first
	// one visible column
	ListView = new MyListView(this);
	ListView->setBackgroundMode(PaletteBase);
	ListView->setTooltipColumn(1);        // e-mail for tooltip
	ListView->setSorting(2,true);	      // display Online Item at first
	ListView->setVScrollBarMode(QScrollView::Auto);
	ListView->setHScrollBarMode(QScrollView::Auto);

	TabView = new QTabWidget(this);
	//TabView->setBackgroundMode(PaletteButton);
	TabView->setTabPosition(QTabWidget::Bottom);
	bool ok;
	QFont f = TabView->font();
	f.setPointSize((_tabFontSize).toInt(&ok,10));
	TabView->setFont(f);

	hbox->addWidget(ListView,0);
//	vbox->addWidget(ListView,0);

	hbox->addWidget(TabView,0);

	//create the onlineLabel
//	onlineLabel = new QLabel(this);
//	onlineLabel->setAlignment(QLabel::AlignHCenter);
//	onlineLabel->setText(tr("Offline"));
//	onlineLabel->setMinimumWidth(160);
//	onlineLabel->setMaximumWidth(160);

//	vbox->addWidget(onlineLabel);

	// connection for ListView
	connect( ListView, SIGNAL( expanded(QListViewItem*) ), this, SLOT( slotExpanded(QListViewItem*) ) );
	connect( ListView, SIGNAL( collapsed(QListViewItem*) ), this, SLOT( slotCollapsed(QListViewItem*) ) );
	connect( ListView,SIGNAL(doubleClicked(QListViewItem*)),this,SLOT(slotDbClicked(QListViewItem*)));
	connect( ListView,SIGNAL(returnPressed(QListViewItem*)),this,SLOT(slotDbClicked(QListViewItem*)));

	ListView->installEventFilter( this );

	ListView->setFocus();
}
OnlineView::~OnlineView()
{
}

bool OnlineView::isEmpty()
{
	if(ListView->currentItem()->childCount() == 0)
	{
		return true;
	}
	else
	return false;
}

QString OnlineView::getParent()
{
	if( ListView->currentItem() == 0 ) return 0L;
	if(ListView->currentItem()->parent() != 0)
	{
		return ListView->currentItem()->parent()->text(0);
	}
	else
	{
		return 0L;
	}
}

QString OnlineView::getGroup()
{
	if( ListView->currentItem() == 0 ) return 0L;
	if(ListView->currentItem()->parent() != 0)
	{
		return ListView->currentItem()->parent()->text(0);
	}
	else
	{
		return ListView->currentItem()->text(0);
	}
}

QString OnlineView::getHandle()
{
	if( ListView->currentItem() == 0 ) return 0L;
	if(ListView->currentItem()->parent() != 0)
	{
		return ListView->currentItem()->text(1);
	}
	else
	{
		return 0L;
	}
}


void OnlineView::slotConnected(bool f)
{
	QStringList groups, contacts;
	QString group;
	uint status;
	QListViewItem *item, *item1;
	if( f )
	{
		groups = theApp->imService->getGroups();
		for ( QStringList::Iterator it = groups.begin(); it != groups.end(); ++it )
		 {
			item=  new QListViewItem(ListView, QString::fromLocal8Bit((*it).data()) ,"","1");
			item->setPixmap(0,expandedPixmap);
			item->setOpen(true);
			contacts = theApp->imService->getContacts( (*it).latin1() );
			if (theApp->_BlockedVisible == "1") {
				for ( QStringList::Iterator it1 = contacts.begin(); it1 != contacts.end(); ++it1 )
			 	{
			 		status = theApp->imService->getStatus( (*it1).latin1() );
					if(!(theApp->imService->isBlocked( (*it1).latin1()))){
						continue;
					}
					if ((theApp->_OfflineVisible == "0") && (status == FLN)){
						continue;
					}
			 		item1= new QListViewItem(item, QString::fromLocal8Bit(theApp->imService->getPublicName((*it1).data()))  , QString::fromLocal8Bit((*it1).data()) ,"1");
		 			item1->setText(0,  theApp->imService->getPublicName((*it1).latin1()) + " (" + theApp->_StatusText[BLO] + ")" );
			 		switch(status)
					{
					case FLN:
					{
			 			item1->setPixmap(0, blockedPixmap);
						break;
					}
					case NLN:
					{
			 			item1->setPixmap(0, blocked2Pixmap);
						break;
					}
					default:
					{
			 			item1->setPixmap(0, blocked3Pixmap);
						break;
					}
				}
				}
		 	}
			for ( QStringList::Iterator it1 = contacts.begin(); it1 != contacts.end(); ++it1 )
		 	{
		 		status = theApp->imService->getStatus( (*it1).latin1() );
				if(status != FLN || theApp->imService->isBlocked( (*it1).latin1())){
					continue;
				}

				if (theApp->_OfflineVisible == "1") {
			 		item1= new QListViewItem(item, QString::fromLocal8Bit(theApp->imService->getPublicName((*it1).data()))  , QString::fromLocal8Bit((*it1).data()) ,"1");
					item1->setText(0, theApp->imService->getPublicName( (*it1).latin1()) );
					item1->setPixmap(0, offlinePixmap );
				}
		 	}
			for ( QStringList::Iterator it1 = contacts.begin(); it1 != contacts.end(); ++it1 )
		 	{
		 		status = theApp->imService->getStatus( (*it1).latin1() );
				if(status == FLN || theApp->imService->isBlocked( (*it1).latin1())){
					continue;
				} 
		 		item1= new QListViewItem(item, QString::fromLocal8Bit(theApp->imService->getPublicName((*it1).data()))  , QString::fromLocal8Bit((*it1).data()) ,"1");
		 		switch(status)
				{
				case NLN:
				{
					item1->setText(0, theApp->imService->getPublicName( (*it1).latin1()) );
					
					if(!(theApp->imService->isMobile( (*it1).latin1()))){
						item1->setPixmap(0, onlinePixmap );
					} else {
						item1->setPixmap(0, mobilePixmap );
					}
					break;
				}
				case BSY:
				case IDL:
				case AWY:
				case PHN:
				case BRB:
				case LUN:
				{
					item1->setText(0, theApp->imService->getPublicName( (*it1).latin1()) + " (" + theApp->_StatusText[status] + ")" );
					item1->setPixmap(0, awayPixmap );
					break;
				}
/*				case IDL:
				{
					item1->setText(0, theApp->imService->getPublicName( (*it1).latin1()) + " ( " + tr("Away") + " )" );
					item1->setPixmap(0, awayPixmap );
					break;
				}
				case AWY:
				{
					item1->setText(0, theApp->imService->getPublicName( (*it1).latin1()) + " ( " + tr("Away") + " )");
					item1->setPixmap(0, awayPixmap );
					break;
				}
				case PHN:
				{
					item1->setText(0, theApp->imService->getPublicName( (*it1).latin1()) + " ( " + tr("On the phone") + " )");
					item1->setPixmap(0, awayPixmap );
					break;
				}
				case BRB:
				{
					item1->setText(0, theApp->imService->getPublicName( (*it1).latin1()) + " ( " + tr("Be right back") + " )");
					item1->setPixmap(0, awayPixmap );
					break;
				}
				case LUN:
				{
					item1->setText(0, theApp->imService->getPublicName( (*it1).latin1()) + " ( " + tr("Out to lunch") + " )");
					item1->setPixmap(0, awayPixmap );
					break;
				}
*/
				}
		 	}
		}
		if (theApp->_MailNoticeEnable == "1") {
			QString mailmsg;
			if( theApp->imService->getMailEnable()) {
				if (MailCount == 0) {
					mailmsg = "No new e-mail messages";
				} else {
					mailmsg.sprintf("%d new e-mail messages",MailCount);
				}
			} else {
				mailmsg = "Go to my e-mail inbox";
			}
			item=  new QListViewItem(ListView, mailmsg ,"","1");
			item->setPixmap(0, mailPixmap);
		}
	}
	else
	{
		ListView->clear();
		theApp->ledOff();
		MailCount = 0;
	}
}

void OnlineView::slotUpdateGroup(QString oldGroup, QString newGroup)
{
	QListViewItemIterator it( ListView );
	for ( ; it.current(); ++it )
	{
		if( it.current()->text(0) == QString::fromLocal8Bit(oldGroup))
		{
			if( it.current()->parent() == 0)
			{
				it.current()->setText(0,QString::fromLocal8Bit(newGroup));
			}
		}
	}
}

void OnlineView::slotRemoveGroup( QString groupName)
{
	QListViewItemIterator it( ListView );
	for ( ; it.current(); ++it )
	{
		if( it.current()->text(0) == QString::fromLocal8Bit(groupName)  )
		{
			if( it.current()->parent() == 0)
			{
				delete it.current();
				return;
			}
		}
	}
}
void OnlineView::slotInsertGroup( QString groupName )
{
	QListViewItem *item = new QListViewItem(ListView, QString::fromLocal8Bit(groupName), "", "1" );
	item->setPixmap(0,expandedPixmap);
	item->setOpen(true);
}

void OnlineView::slotUpdateMail(QString message, uint count)
{
	MailCount = count;
	if (theApp->_MailNoticeEnable == "1") {
		ListView->clear();
		slotConnected(true);
		if ( message != "" ) {
			if(theApp->soundEnable) SlSoundPlayer::play(Resource::findSound("kmerlin/online"),true);
		}
	}
}

void OnlineView::slotUpdateContact(QString handle, uint status, uint oldstatus)
{
	QListViewItemIterator it( ListView );
	QListViewItem *item;
	bool playFlag = false;
	if (theApp->_BlockedVisible == "0") {
		if( theApp->imService->isBlocked( handle) )
		{
			ListView->clear();
			slotConnected(true);
			return;
		}
	}
	for ( ; it.current(); ++it )
	{
		if( it.current()->text(1) == handle )
		{
			item = it.current();
			if(status == NLN && oldstatus == FLN) {
				if(theApp->soundEnable){
					playFlag = true;
				}
				break;
			}
		}
	}

	ListView->clear();
	slotConnected(true);

	if(playFlag) SlSoundPlayer::play(Resource::findSound("kmerlin/online"),true);
}

void OnlineView::slotContactRemoved( QString handle, QString groupName )
{
	QListViewItemIterator it( ListView );
	for ( ; it.current(); ++it )
	{
		if( it.current()->parent() != 0 )
		{
		if( it.current()->parent()->text(0) ==  QString::fromLocal8Bit(groupName) )
		{
			if( it.current()->text(1) ==  handle )
			{
				delete it.current();
				return;
			}
		}
		}
	}
}

void OnlineView::slotContactAdded(QString handle, QString publicName, QString groupName)
{

	ListView->clear();
	slotConnected(true);
}

void OnlineView::loadIcons()
{
	offlinePixmap 	= Resource::loadPixmap("/kmerlin/offline.png");
	onlinePixmap 	= Resource::loadPixmap("/kmerlin/online.png");
	mobilePixmap 	= Resource::loadPixmap("/kmerlin/mobile.png");
	invisiblePixmap	= Resource::loadPixmap("/kmerlin/away.png");
	awayPixmap	= Resource::loadPixmap("/kmerlin/away.png");
	blockedPixmap	= Resource::loadPixmap("/kmerlin/blocked.png");
	blocked2Pixmap	= Resource::loadPixmap("/kmerlin/blocked2.png");
	blocked3Pixmap	= Resource::loadPixmap("/kmerlin/blocked3.png");
	mailPixmap	= Resource::loadPixmap("/kmerlin/envelope.png");

	setIcon(Resource::loadPixmap("kmerlin.png") );
	// root pixmaps
	collapsedPixmap	= Resource::loadPixmap("/kmerlin/contents2.png");
	expandedPixmap	= Resource::loadPixmap("/kmerlin/contents.png");
	execPixmap	= Resource::loadPixmap("exec.png");
}

//** change the pixmap for root items */
void OnlineView::slotExpanded(QListViewItem *item)
{
	if(item->parent()  == 0){
		item->setPixmap(0,expandedPixmap);
	}
}

void OnlineView::slotCollapsed(QListViewItem *item)
{
	if(item->parent() == 0)
	{
		item->setPixmap(0,collapsedPixmap);
	}
}

void OnlineView::setOnlineLabelText(const QString& text)
{
//	onlineLabel->setText(QString::fromLocal8Bit(text));
    emit setMainCaption(QString::fromLocal8Bit(text));
}

void OnlineView::slotDbClicked(QListViewItem* item)
{
	if(item != 0)
	{
		if(item->parent() != 0)
		{
			if(theApp->imService->isAvailable(item->text(1)) )
			{
				emit chatToUser(item->text(1));
			}
			else
			{
				theApp->slotOpenLogWindow(item->text(1));
			}
		}
		else
		{
			if (item->text(0).contains("Go to my e-mail inbox")) {
				theApp->qCopSend("QPE/System", "execute(QString)",theApp->_MailAp,"");
				theApp->ledOff();
			}
			if (item->text(0).contains(" new e-mail message")) {
				theApp->OpenHotMail("");
				theApp->ledOff();
			}
			return;
		}
	}
}

void OnlineView::setWidth(QString aWidth, QString mWidth, QString Layout){
    _autoWidth = aWidth;
    _msgWidth = mWidth;
	if (Layout == "0") {
		hbox->setDirection((QBoxLayout::Direction) 0);
		ListView->setMinimumHeight(0);
		ListView->setMaximumHeight(1600);
//    	TabView->setMinimumHeight(0);
//    	TabView->setMaximumHeight(1600);
		if(_autoWidth != "1") {
			bool ok;
			ListView->setMinimumWidth(0);
//    	ListView->setMaximumWidth(160);
			TabView->setMinimumWidth(_msgWidth.toInt(&ok,10));
			TabView->setMaximumWidth(_msgWidth.toInt(&ok,10));

		} else {
			TabView->setMinimumWidth(200);
			TabView->setMaximumWidth(1600);
			ListView->setMinimumWidth(0);
			ListView->setMaximumWidth(1600);
		}
		hbox->setDirection((QBoxLayout::Direction) 0);
	} else {
		hbox->setDirection((QBoxLayout::Direction) 3);

		ListView->setMinimumWidth(0);
		ListView->setMaximumWidth(1600);
		TabView->setMinimumWidth(0);
		TabView->setMaximumWidth(1600);
		if(_autoWidth != "1") {
			bool ok;
			ListView->setMinimumHeight(0);
//    	ListView->setMaximumHeight(160);
			TabView->setMinimumHeight(_msgWidth.toInt(&ok,10));
			TabView->setMaximumHeight(_msgWidth.toInt(&ok,10));

		} else {
			ListView->setMinimumHeight(0);
			ListView->setMaximumHeight(100);
			TabView->setMinimumHeight(200);
			TabView->setMaximumHeight(1600);
		}
		hbox->setDirection((QBoxLayout::Direction) 3);
	}
}

bool OnlineView::eventFilter(QObject *obj, QEvent *ev)
{
	if ( obj == ListView ) {
		if ( ev->type() == QEvent::KeyPress ) {
			QKeyEvent *k = (QKeyEvent*)ev;
		    switch (k->key()) {
		        case 0x201a          : theApp->changeTab(0);            break;
			return TRUE;
			}
		}
	}
	return QWidget::eventFilter( obj, ev);
}
