/*
 * kmerlin.s
 * Ccopyright (c) 2003-2004, deitest@hotmail.com, yanmar@ogonigo.com
 * 
 *kmerlin.s is based on  kmerlin ver1.41. olueg@olsd.de
 *Fixed by deitest@hotmail.com, yanmar@ogonigo.com 2003-2004
 */
/***************************************************************************
                          onlineview.h  -  description
                             -------------------
    begin                : Fri Jun 22 2001
    copyright            : (C) 2001 by olaf lueg
    email                : olaf.lueg@t-online.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


#ifndef ONLINEVIEW_H
#define ONLINEVIEW_H

#include <qwidget.h>
#include <qpixmap.h>
#include <qevent.h>

class MyListView;
class QLabel;
class QListViewItem;
class QPixmap;
class QTabWidget;
class KMerlinApp;

/**This is the new Online View
  *@author olaf lueg
  */

class OnlineView : public QWidget  {
   Q_OBJECT
public:
	OnlineView(QWidget *parent=0, const char *name=0, QString _layout="0", QString _tabFontSize="12");
	~OnlineView();
	KMerlinApp *theApp;
	QPixmap execPixmap;
	QTabWidget* TabView;
    QString _msgWidth;
    QString _autoWidth;

public:
	QString getHandle();
	QString getGroup();
	QString getParent();
	bool isEmpty();
	void setOnlineLabelText(const QString& text);
    void setWidth(QString aWidth, QString mWidth, QString layout);
	MyListView* ListView;
protected:
	QLabel* onlineLabel;
	QPixmap offlinePixmap,onlinePixmap,mobilePixmap,invisiblePixmap,awayPixmap, blockedPixmap, blocked2Pixmap, blocked3Pixmap,mailPixmap;
	/** Root pixmaps */
	QPixmap collapsedPixmap,expandedPixmap;
	/** Menus */
	QListViewItem *onlineItem,*offlineItem;
	uint MailCount;

protected: //functions
	void loadIcons();
	bool eventFilter(QObject *obj, QEvent *ev);

public slots: // Public slots
	/** No descriptions */
	void slotExpanded(QListViewItem *item);
	void slotCollapsed(QListViewItem *item);
	void slotDbClicked(QListViewItem* item);

	void slotConnected(bool f);

	void slotUpdateGroup(QString oldGroup, QString newGroup);
	void slotInsertGroup( QString groupName );
	void slotRemoveGroup( QString groupName);

	void slotContactAdded(QString handle, QString publicName, QString groupName);
	void slotContactRemoved( QString handle, QString groupName );
	void slotUpdateContact(QString handle, uint status, uint oldstatus);
	void slotUpdateMail(QString message, uint count);

signals: // Signals
  /** No descriptions */
  void chatToUser(QString handle);
  void setMainCaption(QString caption);
};

#endif
