/*
 * kmerlin.s
 * Ccopyright (c) 2003-2004, deitest@hotmail.com, yanmar@ogonigo.com
 * 
 *kmerlin.s is based on  kmerlin ver1.41. olueg@olsd.de
 *Fixed by deitest@hotmail.com, yanmar@ogonigo.com 2003-2004
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "setting.h"

#include <qcheckbox.h>
#include <qcombobox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qlayout.h>
#include <qvariant.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

/* 
 *  Constructs a Setting which is a child of 'parent', with the 
 *  name 'name' and widget flags set to 'f' 
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
Setting::Setting( QWidget* parent,  const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    if ( !name )
	setName( "Settings" );
    resize( 420, 326 ); 
    setMinimumSize( QSize( 420, 0 ) );
    setMaximumSize( QSize( 420, 400 ) );
    setCaption( tr( "Settings" ) );
    setSizeGripEnabled( TRUE );
    SettingsLayout = new QGridLayout( this ); 
    SettingsLayout->setSpacing( 0 );
    SettingsLayout->setMargin( 0 );

    tabWidget = new QTabWidget( this, "tabWidget" );

    Widget3 = new QWidget( tabWidget, "Widget3" );

    TextLabel1 = new QLabel( Widget3, "TextLabel1" );
    TextLabel1->setGeometry( QRect( 10, 0, 280, 20 ) ); 
    TextLabel1->setText( tr( "Account(ex:xxx@hotmail.com)" ) );

    TextLabel3 = new QLabel( Widget3, "TextLabel3" );
    TextLabel3->setGeometry( QRect( 10, 53, 120, 20 ) ); 
    TextLabel3->setText( tr( "Password" ) );

    passWord = new QLineEdit( Widget3, "passWord" );
    passWord->setGeometry( QRect( 10, 73, 390, 30 ) ); 
    passWord->setEchoMode( QLineEdit::Password );

    handle = new QLineEdit( Widget3, "handle" );
    handle->setGeometry( QRect( 10, 20, 390, 30 ) ); 
    tabWidget->insertTab( Widget3, tr( "Account" ) );

    mobileEnable = new QCheckBox(  Widget3, "mobileEnable" );
    mobileEnable->setGeometry( QRect( 10, 110, 170, 20 ) ); 
    mobileEnable->setText( tr( "Mobile Device" ) );

    offlineVisible = new QCheckBox(  Widget3, "offlineVisible" );
    offlineVisible->setGeometry( QRect( 10, 133, 280, 20 ) ); 
    offlineVisible->setText( tr( "Offline Visible" ) );

    blockedVisible = new QCheckBox(  Widget3, "blockedVisible" );
    blockedVisible->setGeometry( QRect( 10, 156, 280, 20 ) ); 
    blockedVisible->setText( tr( "Blocked Visible" ) );

    MailNoticeEnable = new QCheckBox(  Widget3, "MailNoticeEnable" );
    MailNoticeEnable->setGeometry( QRect( 10, 179, 280, 20 ) ); 
    MailNoticeEnable->setText( tr( "HOTMAIL Notifier Enable" ) );

    Widget4 = new QWidget( tabWidget, "Widget4" );

    TextLabel4_2 = new QLabel( Widget4, "TextLabel4_2" );
    TextLabel4_2->setGeometry( QRect( 10, 53, 120, 20 ) ); 
    TextLabel4_2->setText( tr( "Host Address" ) );

    refTime = new QLineEdit( Widget4, "refTime" );
    refTime->setGeometry( QRect( 120, 126, 90, 30 ) ); 
    refTime->setEchoMode( QLineEdit::Normal );

    TextLabel4_2_2_2_2 = new QLabel( Widget4, "TextLabel4_2_2_2_2" );
    TextLabel4_2_2_2_2->setGeometry( QRect( 211, 135, 220, 20 ) ); 
    TextLabel4_2_2_2_2->setText( tr( "msec" ) );

    TextLabel4 = new QLabel( Widget4, "TextLabel4" );
    TextLabel4->setGeometry( QRect( 10, 0, 120, 20 ) ); 
    TextLabel4->setText( tr( "Public name" ) );

    publicName = new QLineEdit( Widget4, "publicName" );
    publicName->setGeometry( QRect( 10, 20, 390, 30 ) ); 
    publicName->setEchoMode( QLineEdit::Normal );

    hostAddr = new QLineEdit( Widget4, "hostAddr" );
    hostAddr->setGeometry( QRect( 10, 73, 390, 30 ) ); 
    hostAddr->setEchoMode( QLineEdit::Normal );

    TextLabel4_2_2_2_3_3 = new QLabel( Widget4, "TextLabel4_2_2_2_3_3" );
    TextLabel4_2_2_2_3_3->setGeometry( QRect( 10, 257, 390, 20 ) ); 
    TextLabel4_2_2_2_3_3->setText( tr( "*a restart is necessary." ) );

    TextLabel4_2_2 = new QLabel( Widget4, "TextLabel4_2_2" );
    TextLabel4_2_2->setGeometry( QRect( 10, 106, 120, 20 ) ); 
    TextLabel4_2_2->setText( tr( "TCP Port" ) );

    tcpPort = new QLineEdit( Widget4, "tcpPort" );
    tcpPort->setGeometry( QRect( 10, 126, 90, 30 ) ); 
    tcpPort->setEchoMode( QLineEdit::Normal );

    TextLabel4_2_2_2 = new QLabel( Widget4, "TextLabel4_2_2_2" );
    TextLabel4_2_2_2->setGeometry( QRect( 120, 106, 220, 20 ) ); 
    TextLabel4_2_2_2->setText( tr( "Refresh Timer" ) );

    ConnectRequest = new QCheckBox( Widget4, "ConnectRequest" );
    ConnectRequest->setGeometry( QRect( 10, 159, 390, 20 ) ); 
    ConnectRequest->setText( tr( "Connect Request" ) );

    AutoConnectMode = new QComboBox( FALSE, Widget4, "AutoConnectMode" );
    AutoConnectMode->insertItem( tr( "No" ) );
    AutoConnectMode->insertItem( tr( "Yes" ) );
    AutoConnectMode->setGeometry( QRect( 10, 199, 90, 31 ) ); 
    AutoConnectMode->setEditable( FALSE );
    AutoConnectMode->setAutoCompletion( FALSE );

    TextLabel4_2_2_3 = new QLabel( Widget4, "TextLabel4_2_2_3" );
    TextLabel4_2_2_3->setGeometry( QRect( 10, 179, 220, 20 ) ); 
    TextLabel4_2_2_3->setText( tr( "Auto Login" ) );

    DisconnectMode = new QComboBox( FALSE, Widget4, "DisconnectMode" );
    DisconnectMode->insertItem( tr( "No" ) );
    DisconnectMode->insertItem( tr( "Yes" ) );
    DisconnectMode->insertItem( tr( "Confirm" ) );
    DisconnectMode->setGeometry( QRect( 120, 199, 130, 31 ) ); 
    DisconnectMode->setEditable( FALSE );
    DisconnectMode->setAutoCompletion( FALSE );

    TextLabel4_2_2_4 = new QLabel( Widget4, "TextLabel4_2_2_4" );
    TextLabel4_2_2_4->setGeometry( QRect( 120, 179, 220, 20 ) ); 
    TextLabel4_2_2_4->setText( tr( "Disconnect when End" ) );

    tabWidget->insertTab( Widget4, tr( "Net" ) );

    tab = new QWidget( tabWidget, "tab" );

    TextLabel4_3_2_2 = new QLabel( tab, "TextLabel4_3_2_2" );
    TextLabel4_3_2_2->setGeometry( QRect( 10, 53, 160, 20 ) ); 
    TextLabel4_3_2_2->setText( tr( "My'Says'" ) );

    fontCol1 = new QLineEdit( tab, "fontCol1" );
    fontCol1->setGeometry( QRect( 10, 73, 100, 30 ) ); 
    fontCol1->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_2 = new QLabel( tab, "TextLabel4_3_2_2_2" );
    TextLabel4_3_2_2_2->setGeometry( QRect( 10, 106, 160, 20 ) ); 
    TextLabel4_3_2_2_2->setText( tr( "Another'Says'" ) );

    fontCol2 = new QLineEdit( tab, "fontCol2" );
    fontCol2->setGeometry( QRect( 10, 126, 100, 30 ) ); 
    fontCol2->setEchoMode( QLineEdit::Normal );

    fontCol3 = new QLineEdit( tab, "fontCol3" );
    fontCol3->setGeometry( QRect( 150, 73, 100, 30 ) ); 
    fontCol3->setEchoMode( QLineEdit::Normal );

    fontCol4 = new QLineEdit( tab, "fontCol4" );
    fontCol4->setGeometry( QRect( 150, 126, 100, 30 ) ); 
    fontCol4->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_2_2 = new QLabel( tab, "TextLabel4_3_2_2_2_2" );
    TextLabel4_3_2_2_2_2->setGeometry( QRect( 150, 106, 160, 20 ) ); 
    TextLabel4_3_2_2_2_2->setText( tr( "Another'Msg'" ) );

    TextLabel4_3_2_2_3 = new QLabel( tab, "TextLabel4_3_2_2_3" );
    TextLabel4_3_2_2_3->setGeometry( QRect( 150, 53, 160, 20 ) ); 
    TextLabel4_3_2_2_3->setText( tr( "My'Msg'" ) );

    TextLabel4_3_2 = new QLabel( tab, "TextLabel4_3_2" );
    TextLabel4_3_2->setGeometry( QRect( 190, 0, 120, 20 ) ); 
    TextLabel4_3_2->setText( tr( "Size" ) );

    fontSize = new QLineEdit( tab, "fontSize" );
    fontSize->setGeometry( QRect( 190, 20, 40, 30 ) ); 
    fontSize->setEchoMode( QLineEdit::Normal );

    fontName = new QComboBox( FALSE, tab, "fontName" );
    fontName->setGeometry( QRect( 7, 19, 180, 31 ) ); 
    fontName->setEditable( FALSE );
    fontName->setAutoCompletion( FALSE );

    TextLabel4_3 = new QLabel( tab, "TextLabel4_3" );
    TextLabel4_3->setGeometry( QRect( 10, 0, 120, 20 ) ); 
    TextLabel4_3->setText( tr( "Font Name" ) );

    TextLabel4_2_2_2_3 = new QLabel( tab, "TextLabel4_2_2_2_3" );
    TextLabel4_2_2_2_3->setGeometry( QRect( 10, 257, 240, 20 ) ); 
    TextLabel4_2_2_2_3->setText( tr( "*a restart is necessary." ) );

    logFontSize = new QLineEdit( tab, "logFontSize" );
    logFontSize->setGeometry( QRect( 10, 180, 40, 30 ) ); 
    logFontSize->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_2_3 = new QLabel( tab, "TextLabel4_3_2_2_2_3" );
    TextLabel4_3_2_2_2_3->setGeometry( QRect( 10, 160, 390, 20 ) ); 
    TextLabel4_3_2_2_2_3->setText( tr( "Log Font Size(Point)" ) );
    tabWidget->insertTab( tab, tr( "Font" ) );

    tab_3 = new QWidget( tabWidget, "tab_3" );

    TextLabel4_2_2_2_4_2 = new QLabel( tab_3, "TextLabel4_2_2_2_4_2" );
    TextLabel4_2_2_2_4_2->setGeometry( QRect( 10, 257, 240, 20 ) ); 
    TextLabel4_2_2_2_4_2->setText( tr( "*a restart is necessary." ) );

    tabFontSize = new QLineEdit( tab_3, "tabFontSize" );
    tabFontSize->setGeometry( QRect( 10, 20, 40, 30 ) ); 
    tabFontSize->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_4_3 = new QLabel( tab_3, "TextLabel4_3_2_2_4_3" );
    TextLabel4_3_2_2_4_3->setGeometry( QRect( 10, 0, 390, 20 ) ); 
    TextLabel4_3_2_2_4_3->setText( tr( "Tab Font Size(Point)" ) );

    infoFontSize = new QLineEdit( tab_3, "infoFontSize" );
    infoFontSize->setGeometry( QRect( 10, 73, 40, 30 ) ); 
    infoFontSize->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_4_4 = new QLabel( tab_3, "TextLabel4_3_2_2_4_4" );
    TextLabel4_3_2_2_4_4->setGeometry( QRect( 10, 53, 390, 20 ) ); 
    TextLabel4_3_2_2_4_4->setText( tr( "Info Font Size(Point)" ) );

    sendFontSize = new QLineEdit( tab_3, "sendFontSize" );
    sendFontSize->setGeometry( QRect( 10, 126, 40, 30 ) ); 
    sendFontSize->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_4_5 = new QLabel( tab_3, "TextLabel4_3_2_2_4_5" );
    TextLabel4_3_2_2_4_5->setGeometry( QRect( 10, 106, 390, 20 ) ); 
    TextLabel4_3_2_2_4_5->setText( tr( "Send Font Size(Point)" ) );

    tabWidget->insertTab( tab_3, tr( "Font2" ) );

    tab_4 = new QWidget( tabWidget, "tab_4" );

    RecvmsgText = new QLineEdit( tab_4, "RecvmsgText" );
    RecvmsgText->setGeometry( QRect( 10, 20, 390, 30 ) ); 
    RecvmsgText->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_5_3 = new QLabel( tab_4, "TextLabel4_3_2_2_5_3" );
    TextLabel4_3_2_2_5_3->setGeometry( QRect( 10, 0, 390, 20 ) ); 
    TextLabel4_3_2_2_5_3->setText( tr( "Receive Message(%1:Time)" ) );

    RecvdmsgText = new QLineEdit( tab_4, "RecvdmsgText" );
    RecvdmsgText->setGeometry( QRect( 10, 73, 390, 30 ) ); 
    RecvdmsgText->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_5_4 = new QLabel( tab_4, "TextLabel4_3_2_2_5_4" );
    TextLabel4_3_2_2_5_4->setGeometry( QRect( 10, 53, 390, 20 ) ); 
    TextLabel4_3_2_2_5_4->setText( tr( "Received Message(%1:Time)" ) );

    UnRecvdmsgText = new QLineEdit( tab_4, "UnRecvdmsgText" );
    UnRecvdmsgText->setGeometry( QRect( 10, 126, 390, 30 ) ); 
    UnRecvdmsgText->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_5_5 = new QLabel( tab_4, "TextLabel4_3_2_2_5_5" );
    TextLabel4_3_2_2_5_5->setGeometry( QRect( 10, 106, 390, 20 ) ); 
    TextLabel4_3_2_2_5_5->setText( tr( "Unreceived Message(%1:Time)" ) );

    WritesmsgText = new QLineEdit( tab_4, "WritesmsgText" );
    WritesmsgText->setGeometry( QRect( 10, 179, 390, 30 ) ); 
    WritesmsgText->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_5_6 = new QLabel( tab_4, "TextLabel4_3_2_2_5_6" );
    TextLabel4_3_2_2_5_6->setGeometry( QRect( 10, 159, 390, 20 ) ); 
    TextLabel4_3_2_2_5_6->setText( tr( "Writes Message(%1:PublicName)" ) );

    SayText = new QLineEdit( tab_4, "SayText" );
    SayText->setGeometry( QRect( 10, 232, 390, 30 ) ); 
    SayText->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_5_7 = new QLabel( tab_4, "TextLabel4_3_2_2_5_7" );
    TextLabel4_3_2_2_5_7->setGeometry( QRect( 10, 212, 390, 20 ) ); 
    TextLabel4_3_2_2_5_7->setText( tr( "Say Notification Message(%1:PublicName)" ) );

    tabWidget->insertTab( tab_4, tr( "Message" ) );

    tab_6 = new QWidget( tabWidget, "tab_6" );

    Recvmsg = new QComboBox( FALSE, tab_6, "Recvmsg" );
    Recvmsg->insertItem( tr( "Another" ) );
    Recvmsg->insertItem( tr( "You" ) );
    Recvmsg->insertItem( tr( "Both" ) );
    Recvmsg->setGeometry( QRect( 10, 20, 220, 31 ) ); 
    Recvmsg->setEditable( FALSE );
    Recvmsg->setAutoCompletion( FALSE );

    TextLabel4_3_2_2_7_3 = new QLabel( tab_6, "TextLabel4_3_2_2_7_3" );
    TextLabel4_3_2_2_7_3->setGeometry( QRect( 10, 0, 390, 20 ) ); 
    TextLabel4_3_2_2_7_3->setText( tr( "Disp Receive Time Info Message" ) );

    RecvmsgTime = new QComboBox( FALSE, tab_6, "RecvmsgTime" );
    RecvmsgTime->insertItem( tr( "Full Format" ) );
    RecvmsgTime->insertItem( tr( "Date Time" ) );
    RecvmsgTime->insertItem( tr( "Time" ) );
    RecvmsgTime->setGeometry( QRect( 10, 73, 220, 31 ) ); 
    RecvmsgTime->setEditable( FALSE );
    RecvmsgTime->setAutoCompletion( FALSE );

    TextLabel4_3_2_2_7_4 = new QLabel( tab_6, "TextLabel4_3_2_2_7_4" );
    TextLabel4_3_2_2_7_4->setGeometry( QRect( 10, 53, 390, 20 ) ); 
    TextLabel4_3_2_2_7_4->setText( tr( "Info Message Time Format" ) );

    DispRecvTime = new QComboBox( FALSE, tab_6, "DispRecvTime" );
    DispRecvTime->insertItem( tr( "None" ) );
    DispRecvTime->insertItem( tr( "Full Format" ) );
    DispRecvTime->insertItem( tr( "Date Time" ) );
    DispRecvTime->insertItem( tr( "Time" ) );
    DispRecvTime->setGeometry( QRect( 10, 126, 220, 31 ) ); 
    DispRecvTime->setEditable( FALSE );
    DispRecvTime->setAutoCompletion( FALSE );

    TextLabel4_3_2_2_7_5 = new QLabel( tab_6, "TextLabel4_3_2_2_7_5" );
    TextLabel4_3_2_2_7_5->setGeometry( QRect( 10, 106, 390, 20 ) ); 
    TextLabel4_3_2_2_7_5->setText( tr( "Chat Message Time Format" ) );

    tabWidget->insertTab( tab_6, tr( "Time" ) );

    tab_5 = new QWidget( tabWidget, "tab_5" );

    Logging = new QCheckBox( tab_5, "Logging" );
    Logging->setGeometry( QRect( 10, 0, 390, 20 ) ); 
    Logging->setText( tr( "Logging Enable" ) );

    logPath = new QLineEdit( tab_5, "logPath" );
    logPath->setGeometry( QRect( 10, 60, 390, 30 ) ); 
    logPath->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_6_3 = new QLabel( tab_5, "TextLabel4_3_2_2_6_3" );
    TextLabel4_3_2_2_6_3->setGeometry( QRect( 10, 20, 390, 40 ) ); 
    TextLabel4_3_2_2_6_3->setText( tr( "Log Path\n (a 'KMerlin_Log' dir is made in.)" ) );

    downPath = new QLineEdit( tab_5, "downPath" );
    downPath->setGeometry( QRect( 10, 113, 390, 30 ) ); 
    downPath->setEchoMode( QLineEdit::Normal );

    TextLabel4_3_2_2_6_4 = new QLabel( tab_5, "TextLabel4_3_2_2_6_4" );
    TextLabel4_3_2_2_6_4->setGeometry( QRect( 10, 93, 390, 20 ) ); 
    TextLabel4_3_2_2_6_4->setText( tr( "Download Path" ) );

    tabWidget->insertTab( tab_5, tr( "Path" ) );

    tab_7 = new QWidget( tabWidget, "tab_7" );

    MyText0 = new QLineEdit( tab_7, "MyText0" );
    MyText0->setGeometry( QRect( 10, 0, 390, 30 ) ); 
    MyText0->setEchoMode( QLineEdit::Normal );

    MyText1 = new QLineEdit( tab_7, "MyText1" );
    MyText1->setGeometry( QRect( 10, 33, 390, 30 ) ); 
    MyText1->setEchoMode( QLineEdit::Normal );

    MyText2 = new QLineEdit( tab_7, "MyText2" );
    MyText2->setGeometry( QRect( 10, 66, 390, 30 ) ); 
    MyText2->setEchoMode( QLineEdit::Normal );

    MyText3 = new QLineEdit( tab_7, "MyText3" );
    MyText3->setGeometry( QRect( 10, 99, 390, 30 ) ); 
    MyText3->setEchoMode( QLineEdit::Normal );

    MyText4 = new QLineEdit( tab_7, "MyText4" );
    MyText4->setGeometry( QRect( 10, 132, 390, 30 ) ); 
    MyText4->setEchoMode( QLineEdit::Normal );

    MyText5 = new QLineEdit( tab_7, "MyText5" );
    MyText5->setGeometry( QRect( 10, 165, 390, 30 ) ); 
    MyText5->setEchoMode( QLineEdit::Normal );

    MyText6 = new QLineEdit( tab_7, "MyText6" );
    MyText6->setGeometry( QRect( 10, 198, 390, 30 ) ); 
    MyText6->setEchoMode( QLineEdit::Normal );

    MyText7 = new QLineEdit( tab_7, "MyText7" );
    MyText7->setGeometry( QRect( 10, 231, 390, 30 ) ); 
    MyText7->setEchoMode( QLineEdit::Normal );

    tabWidget->insertTab( tab_7, tr( "MyText" ) );

    tab_8 = new QWidget( tabWidget, "tab_8" );

    MyText8 = new QLineEdit( tab_8, "MyText8" );
    MyText8->setGeometry( QRect( 10, 0, 390, 30 ) ); 
    MyText8->setEchoMode( QLineEdit::Normal );

    MyText9 = new QLineEdit( tab_8, "MyText9" );
    MyText9->setGeometry( QRect( 10, 33, 390, 30 ) ); 
    MyText9->setEchoMode( QLineEdit::Normal );

    MyText10 = new QLineEdit( tab_8, "MyText10" );
    MyText10->setGeometry( QRect( 10, 66, 390, 30 ) ); 
    MyText10->setEchoMode( QLineEdit::Normal );

    MyText11 = new QLineEdit( tab_8, "MyText11" );
    MyText11->setGeometry( QRect( 10, 99, 390, 30 ) ); 
    MyText11->setEchoMode( QLineEdit::Normal );

    MyText12 = new QLineEdit( tab_8, "MyText12" );
    MyText12->setGeometry( QRect( 10, 132, 390, 30 ) ); 
    MyText12->setEchoMode( QLineEdit::Normal );

    MyText13 = new QLineEdit( tab_8, "MyText13" );
    MyText13->setGeometry( QRect( 10, 165, 390, 30 ) ); 
    MyText13->setEchoMode( QLineEdit::Normal );

    MyText14 = new QLineEdit( tab_8, "MyText14" );
    MyText14->setGeometry( QRect( 10, 198, 390, 30 ) ); 
    MyText14->setEchoMode( QLineEdit::Normal );

    MyText15 = new QLineEdit( tab_8, "MyText15" );
    MyText15->setGeometry( QRect( 10, 231, 390, 30 ) ); 
    MyText15->setEchoMode( QLineEdit::Normal );

    tabWidget->insertTab( tab_8, tr( "MyText2" ) );

    tab_2 = new QWidget( tabWidget, "tab_2" );

    msgWidth = new QLineEdit( tab_2, "msgWidth" );
    msgWidth->setGeometry( QRect( 10, 20, 100, 30 ) ); 
    msgWidth->setEchoMode( QLineEdit::Normal );

    TextLabel4_4 = new QLabel( tab_2, "TextLabel4_4" );
    TextLabel4_4->setGeometry( QRect( 10, 0, 180, 20 ) ); 
    TextLabel4_4->setText( tr( "MessageTab Width" ) );

    autoWidth = new QCheckBox( tab_2, "autoWidth" );
    autoWidth->setGeometry( QRect( 120, 26, 151, 20 ) ); 
    autoWidth->setText( tr( "Auto Width" ) );

    TextLabel4_4_2 = new QLabel( tab_2, "TextLabel4_4_2" );
    TextLabel4_4_2->setGeometry( QRect( 10, 52, 180, 20 ) ); 
    TextLabel4_4_2->setText( tr( "MarginH" ) );

    TextLabel4_4_2_2 = new QLabel( tab_2, "TextLabel4_4_2_2" );
    TextLabel4_4_2_2->setGeometry( QRect( 120, 52, 180, 20 ) ); 
    TextLabel4_4_2_2->setText( tr( "MarginV" ) );

    marginH = new QLineEdit( tab_2, "marginH" );
    marginH->setGeometry( QRect( 10, 72, 100, 30 ) ); 
    marginH->setEchoMode( QLineEdit::Normal );

    marginV = new QLineEdit( tab_2, "marginV" );
    marginV->setGeometry( QRect( 120, 72, 100, 30 ) ); 
    marginV->setEchoMode( QLineEdit::Normal );

    TextLabel4_2_2_2_3_2 = new QLabel( tab_2, "TextLabel4_2_2_2_3_2" );
    TextLabel4_2_2_2_3_2->setGeometry( QRect( 10, 257, 240, 20 ) ); 
    TextLabel4_2_2_2_3_2->setText( tr( "*a restart is necessary." ) );

    sndEnable = new QCheckBox( tab_2, "sndEnable" );
    sndEnable->setGeometry( QRect( 10, 110, 151, 20 ) ); 
    sndEnable->setText( tr( "Sound Enable" ) );

    maxComment = new QLineEdit( tab_2, "maxComment" );
    maxComment->setGeometry( QRect( 10, 160, 100, 30 ) ); 
    maxComment->setEchoMode( QLineEdit::Normal );

    TextLabel4_4_3 = new QLabel( tab_2, "TextLabel4_4_3" );
    TextLabel4_4_3->setGeometry( QRect( 10, 140, 180, 20 ) ); 
    TextLabel4_4_3->setText( tr( "Max Comment" ) );

    TextLabel4_3_3 = new QLabel( tab_2, "TextLabel4_3_3" );
    TextLabel4_3_3->setGeometry( QRect( 13, 191, 120, 20 ) ); 
    TextLabel4_3_3->setText( tr( "Mail Led Mode" ) );

    ledMode = new QComboBox( FALSE, tab_2, "ledMode" );
    ledMode->insertItem( tr( "off" ) );
    ledMode->insertItem( tr( "on" ) );
    ledMode->insertItem( tr( "default" ) );
    ledMode->insertItem( tr( "flashon" ) );
    ledMode->insertItem( tr( "flashoff" ) );
    ledMode->insertItem( tr( "vfstblink" ) );
    ledMode->insertItem( tr( "fastblink" ) );
    ledMode->insertItem( tr( "normblink" ) );
    ledMode->insertItem( tr( "slowblink" ) );
    ledMode->insertItem( tr( "softblink" ) );
    ledMode->insertItem( tr( "softflash" ) );
    ledMode->setGeometry( QRect( 10, 210, 220, 31 ) ); 
    ledMode->setEditable( FALSE );
    ledMode->setAutoCompletion( FALSE );

    tabWidget->insertTab( tab_2, tr( "Etc" ) );

    tab_9 = new QWidget( tabWidget, "tab_9" );

    MailAp = new QLineEdit( tab_9, "MailAp" );
    MailAp->setGeometry( QRect( 10, 20, 390, 30 ) ); 
    MailAp->setEchoMode( QLineEdit::Normal );

    TextLabel9_1 = new QLabel( tab_9, "TextLabel9_1" );
    TextLabel9_1->setGeometry( QRect( 10, 0, 390, 20 ) ); 
    TextLabel9_1->setText( tr( "Mail" ) );

    BrowserAp = new QLineEdit( tab_9, "BrowserAp" );
    BrowserAp->setGeometry( QRect( 10, 72, 390, 30 ) ); 
    BrowserAp->setEchoMode( QLineEdit::Normal );

    TextLabel9_2 = new QLabel( tab_9, "TextLabel9_2" );
    TextLabel9_2->setGeometry( QRect( 10, 52, 390, 20 ) ); 
    TextLabel9_2->setText( tr( "Browser" ) );

    ServerStatusUrl = new QLineEdit( tab_9, "ServerStatusUrl" );
    ServerStatusUrl->setGeometry( QRect( 10, 124, 390, 30 ) ); 
    ServerStatusUrl->setEchoMode( QLineEdit::Normal );

    TextLabel9_3 = new QLabel( tab_9, "TextLabel9_3" );
    TextLabel9_3->setGeometry( QRect( 10, 104, 390, 20 ) ); 
    TextLabel9_3->setText( tr( "Service Status URL" ) );

    ProfileUrl = new QLineEdit( tab_9, "ProfileUrl" );
    ProfileUrl->setGeometry( QRect( 10, 176, 390, 30 ) ); 
    ProfileUrl->setEchoMode( QLineEdit::Normal );

    TextLabel9_4 = new QLabel( tab_9, "TextLabel9_4" );
    TextLabel9_4->setGeometry( QRect( 10, 156, 390, 20 ) ); 
    TextLabel9_4->setText( tr( "Profile URL" ) );

    tabWidget->insertTab( tab_9, tr( "Etc2" ) );

    SettingsLayout->addWidget( tabWidget, 0, 0 );

    // tab order
    setTabOrder( tabWidget, handle );
    setTabOrder( handle, passWord );
    setTabOrder( passWord, publicName );
    setTabOrder( publicName, hostAddr );
    setTabOrder( hostAddr, tcpPort );
    setTabOrder( tcpPort, refTime );
    setTabOrder( refTime, fontName );
    setTabOrder( fontName, fontSize );
    setTabOrder( fontSize, fontCol1 );
    setTabOrder( fontCol1, fontCol3 );
    setTabOrder( fontCol3, fontCol2 );
    setTabOrder( fontCol2, fontCol4 );
}

/*  
 *  Destroys the object and frees any allocated resources
 */
Setting::~Setting()
{
    // no need to delete child widgets, Qt does it all for us
}

