#include "sharpioctl.h"

#include <sys/ioctl.h>
#include <stdio.h>
#include <getopt.h>
#include <sys/soundcard.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>

class SharpLed
{
public:
	SharpLed(){}
	virtual ~SharpLed() {}

	virtual void mail_led_set(QString arg){
		/* Mail LED Control */
		int stat = -1;
		if (arg == "default")
		{
			stat = LED_COLLIE_1_DEFAULT;
		}
		else if (arg == "off")
		{
			stat = LED_COLLIE_1_OFF;
		}
		else if (arg == "on")
		{
			stat = LED_COLLIE_1_ON;
		}
		else if (arg == "flashon")
		{
			stat = LED_COLLIE_1_FLASHON;
		}
		else if (arg == "flashoff")
		{
			stat = LED_COLLIE_1_FLASHOFF;
		}
		else if (arg == "vfstblink")
		{
			stat = LED_COLLIE_1_VFSTBLINK;
		}
		else if (arg == "fastblink")
		{
			stat = LED_COLLIE_1_FASTBLINK;
		}
		else if (arg == "normblink")
		{
			stat = LED_COLLIE_1_NORMBLINK;
		}
		else if (arg == "slowblink")
		{
			stat = LED_COLLIE_1_SLOWBLINK;
		}
		else if (arg == "softblink")
		{
			stat = LED_COLLIE_1_SOFTBLINK;
		}
		else if (arg == "softflash")
		{
			stat = LED_COLLIE_1_SOFTFLASH;
		}
		else
		{
			return;
		}
	
		sharp_led_status ledstatus;
		ledstatus.which = SHARP_LED_COLLIE_1;
		ledstatus.status = stat;
		ioctlset(DEVNAME_LED, SHARP_LED_SETSTATUS, &ledstatus);
	}
	
	virtual void ioctlset(char *devname, int command, void *value){
		/* IOCTL */
		int fd, success;
		fd  = open(devname, O_RDWR);
		if (fd == -1)
		{
			return;
		}
	
		success = ioctl(fd, command, value);
		if (success == -1)
		{
			close(fd);
			return;
		}
	
		close(fd);
	}

};
